(***************************************************************************)
(**                            UNIT BOXSERV.PAS                           **)
(***************************************************************************)
(**  Routinen fr die Mail-Server-Ansteuerung. Es existiert ein           **)
(**  Beispielfile, wie ein Server programmiert werden kann.               **)
(**                                                                       **)
(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)
(** DG4IAD und DG6VJ                                                      **)
(**                                                                       **)
(** dg6vj, mar 96                                                         **)
(***************************************************************************)
UNIT BOXSERV;


INTERFACE

USES BOXVARS;

{bergabe-Typ zu den Server-Programmen}
TYPE 
     {Liste der Server im Speicher}
     pServerListe = ^tServerListe;
     tServerListe = RECORD
       next: pServerListe;      {Pointer auf das nchste Feld}
       Filename: STRING[50];
       Rubrik: STRING[8];
     END;

VAR ServListRoot: pServerListe;


{Macht die komplette Mail-Server-Ansteuerung - Rckgabe: KILL, wenn die
 Mail gelscht werden soll. (Nach der Auswertung nicht mehr bentigt)}
PROCEDURE CheckForServer(Idx: Verwalt_Rec; VAR Kill: BOOLEAN);



IMPLEMENTATION

USES IADVAR,TOOLBOX,{$IFNDEF LINUX}MEMORY,{$ENDIF}DOS (*,EXEC*);


{$IFNDEF LINUX}
{Die folgenden beiden Routinen habe ich geschrieben, weil Ofs und
 Seg von Pascal bei mir NICHT geklappt haben. Meine sind auf jedenfall
 nicht lnger, hi}

{Segment-Adresse von dem bergebenen Pointer zurck geben}
FUNCTION Segment(X: Pointer): WORD; Assembler;
ASM
  LES SI,X      {Adresse von X nach ES:SI}
  MOV AX,ES     {Segment-Adresse zurck geben}
END;


{Offset-Adresse von dem bergebenen Pointer zurck geben}
FUNCTION Offset(X: Pointer): WORD; Assembler;
ASM
  LES SI,X      {Adresse von X nach ES:SI}
  MOV AX,SI     {Segment-Adresse zurck geben}
END;


{$ENDIF}

{Testet, ob die bergebene Rubrik zu einem Server-Programm zugeordnet
 wurde}
FUNCTION Is_a_Server_Board(Boardname: str8; VAR Filename: STRING): BOOLEAN;
VAR tmp: pServerListe;
    Found: BOOLEAN;
BEGIN
  tmp := ServListRoot;
  Found := FALSE;

  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Rubrik=Boardname THEN BEGIN
      Found := TRUE;
      Filename := tmp^.Filename;
    END;
    tmp := tmp^.next;
  END;
  Is_a_Server_Board := Found;
END;



{Dies ist die einzige Routine, die dem restlichen Programm bekannt ist.
 Wird aufgerufen, sobalt eine neue Mail 'rein kommt (Einspielen von einem
 User, ungepacktes Forward oder gepacktes Forward)}
PROCEDURE CheckForServer(Idx: Verwalt_Rec; VAR Kill: BOOLEAN);
VAR Params,             {bergabeparameter (Segment+Offset)}
    Filename,Msgfile: STRING;   {Dateiname des Servers (was aufgerufen wird)}
    Rueck: BYTE;        {Rueckgabewert des Proggis}
    Hlp,Hlp2: STRING[10];
BEGIN
  IF Is_a_Server_Board(Idx.Rubrik,Filename) THEN BEGIN


    {Programm aufrufen}
     {$IFNDEF LINUX}
    SetMemTop(HeapPtr);
    dos.exec(Filename,BOXPATH+' '+idx.filename);
    SetMemTop(HeapEnd);
    Rueck := dosexitcode;
{$ENDIF}
    {Speicher wieder frei geben (bergabeparameter)}

    {Rckgabe auswerten. Wenn Rueck = 1: Mail lschen, sonst nicht}
    IF Rueck=1 THEN Kill := TRUE
               ELSE Kill := FALSE;
  END
  ELSE Kill := FALSE;
END;


BEGIN
  ServListRoot := NIL;
END.

