
{CONVHOST.PAS
 Hier stehen die Routinen drin, die zur Kommunikation zwischen Convers-
 Servern verwendet werden.
 DG6VJ
}
UNIT CONVHOST;

INTERFACE

USES CONVVAR;

{Hier landen alle Befehle des Hosts}
PROCEDURE HostCommands(ch: BYTE; S: STRING);
FUNCTION LoginToServer(ch: BYTE; S: STRING): BOOLEAN;
PROCEDURE SendPings;

PROCEDURE Host_AWAY_Cmd(NotTo: BYTE; User: str6; Host: str15; Time: LONGINT; Text: STRING);
PROCEDURE Host_INVI_Cmd(NotTo: BYTE; From: str6; User: str6; Chan: INTEGER);
PROCEDURE Host_CMSG_Cmd(NotTo: BYTE; User: str10; Channel: INTEGER;  Text: STRING);
PROCEDURE Host_UMSG_Cmd(NotTo: BYTE; From: str6; Rec: str6; ChanNr: BYTE; Text: STRING);
PROCEDURE Host_MODE_Cmd(NotTo: BYTE; Chan: INTEGER; Flags: WORD);
PROCEDURE Host_OPER_Cmd(NotTo: BYTE; from: str10; Chan: INTEGER; User: str6);
PROCEDURE Host_TOPI_Cmd(NotTo: BYTE; User: str6; Host: str15; Time: LONGINT; Chan: INTEGER;  Text: STRING);
PROCEDURE Host_USER_Cmd(NotTo: BYTE; User: str6; Host: str15; Time: LONGINT; FromChan,ToChan: INTEGER; Text: STRING);

FUNCTION GetHostChannel(Hostname: str15): BYTE;

PROCEDURE NewDestination(Name,Via: str15; Time: WORD; Revision: str6);
PROCEDURE DeleteDestination(Host: str15);
PROCEDURE ChangeDestinationTime(Host: str15; Newtime: WORD);
FUNCTION IsInDestinationList(Host: str15): BOOLEAN;


IMPLEMENTATION

USES CONVERS,IADVAR;

{*************************************************************************}
{***         Die einzelnen Convers-Kommandos als Prozeduren            ***}
{*************************************************************************}
PROCEDURE H_Away_Cmd(ch: BYTE; User: str6; Host: str15; Time: LONGINT; Text: STRING);
VAR S: STRING;
BEGIN
  STR(Time,S);
  S := '/'+#255#128+'AWAY '+User+' '+Host+' '+S;
  IF LENGTH(Text)>0 THEN S := S + ' ' + Text;
  PutData(ch,S+#13);
END;


PROCEDURE H_Mode_Cmd(ch: BYTE; Chan: INTEGER; ChanFlags: WORD);
VAR S: STRING;
    i: BYTE;
BEGIN
  STR(Chan,S);
  S := '/'+#255#128+'MODE '+S+' -';

  IF ChanFlags AND TOPIC_CHOP=0 THEN S := S + 't';
  IF ChanFlags AND INVISIBLE=0 THEN S := S + 'i';
  IF ChanFlags AND SECRET=0 THEN S := S + 's';
  IF ChanFlags AND MODERATE=0 THEN S := S + 'm';
  IF ChanFlags AND PRIVAT=0 THEN S := S + 'p';
  IF ChanFlags AND LOCAL=0 THEN S := S + 'l';

  S := S + '+';

  IF ChanFlags AND TOPIC_CHOP>0 THEN S := S + 't';
  IF ChanFlags AND INVISIBLE>0 THEN S := S + 'i';
  IF ChanFlags AND SECRET>0 THEN S := S + 's';
  IF ChanFlags AND MODERATE>0 THEN S := S + 'm';
  IF ChanFlags AND PRIVAT>0 THEN S := S + 'p';
  IF ChanFlags AND LOCAL>0 THEN S := S + 'l';

  PutData(ch,S+#13);
END;


PROCEDURE H_Oper_Cmd(ch: BYTE; From: str15; Call: str6; Chan: INTEGER);
VAR S: STRING;
BEGIN
  STR(Chan,S);
  S := '/'+#255#128+'OPER '+From+' '+S+' '+Call;
  PutData(ch,S+#13);
END;


PROCEDURE H_Topic_Cmd(ch: BYTE; From: str6; Host: str15; Time: LONGINT; Chan: INTEGER; Text: STRING);
VAR S,Hlp: STRING;
BEGIN
  STR(Time,S);
  STR(Chan,Hlp);
  S := '/'+#255#128+'TOPI '+From+' '+Host+' '+S+' '+Hlp;
  IF LENGTH(Text)>0 THEN S := S + ' '+Text;
  PutData(ch,S+#13);
END;


PROCEDURE H_UserDat_Cmd(ch: BYTE; From: str6; Host: str15; Text: STRING);
VAR S: STRING;
BEGIN
  S := '/'+#255#128+'UDAT '+From+' '+Host;
  IF LENGTH(Text)>0 THEN S := S + ' ' + Text;
  PutData(ch,S+#13);
END;


PROCEDURE H_User_Cmd(ch: BYTE; User: str6; Host: str15; Time: LONGINT; From_Chan,To_Chan: INTEGER; Text: STRING);
VAR S: STRING;
    Hlp: STRING;
BEGIN
  STR(Time,S);
  STR(From_Chan,Hlp);
  S := '/'+#255#128+'USER '+User+' '+Host+' '+S+' '+Hlp + ' ';
  STR(To_Chan,Hlp);
  S := S + Hlp + ' ';
  IF LENGTH(Text)>0 THEN S := S + Text
                    ELSE S := S + '@';
  PutData(ch,S+#13);
END;



{Away-Message an alle Hosts schicken}
PROCEDURE Host_AWAY_Cmd;
VAR tmp: pHostListe;
BEGIN
  tmp := HostDataRoot;
  WHILE tmp<>NIL DO BEGIN
    IF tmp^.Chan<>NotTo THEN H_Away_Cmd(tmp^.Chan,User,Host,Time,Text);
    tmp := tmp^.next;
  END;
END;



PROCEDURE Host_INVI_Cmd;
VAR S: STRING;
    tmp: pHostListe;
BEGIN
  tmp := HostDataRoot;
  S := '/'+#255#128+'INVI '+From+' '+User+' '+S;
  WHILE tmp<>NIL DO BEGIN
    IF tmp^.Chan<>NotTo THEN PutData(tmp^.Chan,S+#13);
    tmp := tmp^.next;
  END;
END;


PROCEDURE Host_CMSG_Cmd;
VAR S: STRING;
    tmp: pHostListe;
BEGIN
  tmp := HostDataRoot;
  STR(Channel,S);
  S := '/'+#255#128+'CMSG '+User+' '+S+' '+Text;
  WHILE tmp<>NIL DO BEGIN
    IF (tmp^.Chan<>NotTo) AND (tmp^.state=2) THEN PutData(tmp^.Chan,S+#13);
    tmp := tmp^.next;
  END;
END;


PROCEDURE Host_UMSG_Cmd;
BEGIN
  PutData(ChanNr,'/'+#255#128+'UMSG '+From+' '+Rec+' '+Text+#13);
END;


PROCEDURE Host_MODE_Cmd(NotTo: BYTE; Chan: INTEGER; Flags: WORD);
VAR tmp: pHostListe;
BEGIN
  tmp := HostDataRoot;
  WHILE tmp<>NIL DO BEGIN
    IF tmp^.Chan<>NotTo THEN H_Mode_Cmd(tmp^.Chan,Chan,Flags);
    tmp := tmp^.next;
  END;
END;


PROCEDURE Host_OPER_Cmd;
VAR tmp: pHostListe;
BEGIN
  tmp := HostDataRoot;
  WHILE tmp<>NIL DO BEGIN
    IF tmp^.Chan<>NotTo THEN H_Oper_Cmd(tmp^.Chan,From,User,Chan);
    tmp := tmp^.next;
  END;
END;


PROCEDURE Host_TOPI_Cmd;
VAR tmp: pHostListe;
BEGIN
  tmp := HostDataRoot;
  WHILE tmp<>NIL DO BEGIN
    IF tmp^.Chan<>NotTo THEN H_Topic_Cmd(tmp^.Chan,User,Host,Time,Chan,Text);
    tmp := tmp^.next;
  END;
END;


PROCEDURE Host_USER_Cmd;
VAR tmp: pHostListe;
BEGIN
  tmp := HostDataRoot;
  WHILE tmp<>NIL DO BEGIN
    IF tmp^.Chan<>NotTo THEN H_User_Cmd(tmp^.Chan,User,Host,Time,FromChan,ToChan,Text);
    tmp := tmp^.next;
  END;
END;










{Kompletten Status des Converses hier senden (User, Topics, Modes etc}
PROCEDURE SendConversStatus(ch: BYTE);
VAR b: BYTE;
    User_tmp: pConvUserChan;
    Chan_tmp: pChanRec;
    tmp: pExtUser;
BEGIN

{*************** Vorhandene User-Liste schicken ****************************}
  FOR b := 0 TO 255 DO IF KS[b]<>NIL THEN IF KS[b]^.status=6 THEN BEGIN
    IF KS[b]^.ConvData^.Operator THEN H_Oper_Cmd(ch,'conversd',KS[b]^.ConvData^.Call,-1);
    User_Tmp := KS[b]^.ConvData^.Channels;
    WHILE User_tmp<>NIL DO BEGIN
      H_User_Cmd(ch,KS[b]^.ConvData^.Call,OwnConvData^.HostName,User_Tmp^.Login,-1,User_tmp^.Channel,KS[b]^.ConvData^.Pers);
      IF User_tmp^.Flags AND IS_CHANOP>0 THEN H_Oper_Cmd(ch,User_tmp^.From_Oper,KS[b]^.ConvData^.Call,User_tmp^.Channel);
      User_tmp := User_tmp^.next;
    END;
  END;

  tmp := ExtUserRoot;
  WHILE tmp<>NIL DO BEGIN
    H_User_Cmd(ch,tmp^.Call,tmp^.Host,tmp^.Login,-1,tmp^.Channel,tmp^.Pers);
    IF tmp^.ChanOp THEN H_Oper_Cmd(ch,tmp^.From_ChanOp,tmp^.Call,tmp^.Channel);
    IF tmp^.Operator THEN H_Oper_Cmd(ch,tmp^.From_Oper,tmp^.Call,-1);
    tmp := tmp^.next;
  END;


  {**************** Channel-Topic und -Mode schicken **********************}
  Chan_Tmp := ChannelDatRoot;
  WHILE Chan_tmp <> NIL DO BEGIN
    H_Mode_Cmd(ch,Chan_Tmp^.Channel,Chan_Tmp^.Flags);
    IF LENGTH(Chan_Tmp^.topic)>0 THEN WITH Chan_Tmp^ DO H_Topic_Cmd(ch,topic_who,Topic_Who_Host,Topic_When,Channel,topic);
    Chan_tmp := chan_tmp^.next;
  END;

END;






PROCEDURE RX_Host_Cmd(ch: BYTE; S: STRING);
VAR i,b: BYTE;
    Hlp: STRING;
    tmp: pHostListe;
    Found: BOOLEAN;
BEGIN

  S := COPY(S,POS(' ',S)+1,255);

  Hlp := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);

  tmp := HostDataRoot;
  Found := FALSE;
  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Hostname = Hlp THEN Found := TRUE
                           ELSE tmp := tmp^.next;
  END;
  IF Found THEN BEGIN
    tmp^.Chan := ch;
    KS[ch]^.ConvHost := tmp;

    {Software + Flags aus dem HOST-Befehl holen}
    IF POS(' ',S)>0 THEN BEGIN
      Hlp := COPY(S,POS(' ',S)+1,255);
      S := COPY(S,1,POS(' ',S)-1);
    END
    ELSE Hlp := '';

    KS[ch]^.ConvHost^.Revision := S;

    {bekannte Flags aus Hlp 'rausholen und speichern}
    FOR i := 1 TO LENGTH(Hlp) DO BEGIN
      CASE Hlp[i] OF
        'a': KS[ch]^.ConvHost^.Flags := KS[ch]^.ConvHost^.Flags OR FLG_OLD_AWAY;
        'd': KS[ch]^.ConvHost^.Flags := KS[ch]^.ConvHost^.Flags OR FLG_DESTI_FORW;
        'm': KS[ch]^.ConvHost^.Flags := KS[ch]^.ConvHost^.Flags OR FLG_CHAN_MODE;
        'p': KS[ch]^.ConvHost^.Flags := KS[ch]^.ConvHost^.Flags OR FLG_PINGPONG;
        'u': KS[ch]^.ConvHost^.Flags := KS[ch]^.ConvHost^.Flags OR FLG_UDAT;
        'A': KS[ch]^.ConvHost^.Flags := KS[ch]^.ConvHost^.Flags OR FLG_NEW_AWAY;
      END;
    END;
    NewDestination(KS[ch]^.convhost^.hostname,KS[ch]^.convhost^.hostname,1,S);
    KS[ch]^.ConvHost^.Since := AktUnixTime;

    {Sendet alle User-Infos, Topics etc etc ab, die hier vorhanden sind.}
    PutData(ch,'/'+#255#128+'HOST '+OwnConvData^.Hostname+' mct-'+ConvRelease+' '+OwnFlags+#13);

    SendConversStatus(ch);
  END;
END;


{Rckgabe: TRUE, wenn der bergebene Hostname als Link eingetragen ist.
           FALSE, wenn nicht}
FUNCTION IsHost(HostName: str15): BOOLEAN;
VAR tmp: pHostListe;
    Found: BOOLEAN;
BEGIN
  tmp := HostDataRoot;
  Found := FALSE;
  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Hostname = Hostname THEN Found := TRUE;
    tmp := tmp^.next;
  END;
  IsHost := Found;
END;


PROCEDURE RX_User_Cmd(ch: BYTE; S: STRING);
VAR tmp,last: pExtUser;
    Call: str6;
    Host: str15;
    code: WORD;
    FromChan,ToChan: INTEGER;
    Time: LONGINT;
    Hlp: STRING;
    Pers: STRING;
    b: BYTE;
    ChanFlags: WORD;
    OK,Found: BOOLEAN;
    tmp2: pConvUserChan;
BEGIN
  {Text USER bersprigen}
  S := COPY(S,POS(' ',S)+1,255);

  Hlp := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);
  Call := Hlp;

  Hlp := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);
  Host := Hlp;

  Hlp := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);
  VAL(Hlp,Time,code);
  IF code<>0 THEN Exit;

  Hlp := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);
  VAL(Hlp,FromChan,code);
  IF code<>0 THEN Exit;

  IF POS(' ',S)>0 THEN BEGIN
    Hlp := COPY(S,1,POS(' ',S)-1);
    S := COPY(S,POS(' ',S)+1,255);
  END
  ELSE BEGIN
    Hlp := S;
    S := '';
  END;
  VAL(Hlp,ToChan,code);
  IF code<>0 THEN Exit;

  IF LENGTH(S)>0 THEN IF S<>'@' THEN Pers := S
                                ELSE Pers := '';

  {*********** Nur Pers-text ndern ***************************}
  IF ToChan=FromChan THEN BEGIN
    tmp := ExtUserRoot;
    WHILE tmp<>NIL DO BEGIN
      IF tmp^.Call=Call THEN BEGIN
        tmp^.Pers := Pers;
        S := '*** ('+ConvTime+') '+Call+'@'+Host+' set personal text:'+#13+'    '+Pers+#13;
        SendChannelMessage(FALSE,FromChan,S,0);
      END;
      tmp := tmp^.next;
    END;
    Host_USER_Cmd(ch,Call,Host,Time,FromChan,ToChan,Pers);
    Exit;
  END;

  {****************** In einen Kanal einloggen ******************}
  IF ToChan>=0 THEN BEGIN
    tmp:=ExtUserRoot;
    IF tmp=NIL THEN BEGIN
      new(ExtUserRoot);
      tmp:=ExtUserRoot;
    END
    ELSE BEGIN
      tmp:=ExtUserRoot;
      WHILE tmp^.next<>NIL DO tmp:=tmp^.next;
      New(tmp^.Next);
      tmp:=tmp^.Next;
    END;

    tmp^.Next := NIL;
    tmp^.Call := Call;
    tmp^.Host := Host;
    tmp^.Via_Host := KS[ch]^.ConvHost^.Hostname;
    tmp^.Channel := ToChan;
    tmp^.Pers := Pers;
    tmp^.Away := FALSE;
    tmp^.AwaySince := 0;
    tmp^.AwayText := '';
    tmp^.Operator := FALSE;
    tmp^.From_Oper := '';
    tmp^.ChanOp := FALSE;
    tmp^.From_Chanop := '';
    tmp^.Login := AktUnixTime;
    tmp^.LastText := tmp^.Login;

    {Im Kanal-Record einen User dabei}
    AddOneUserAtChannel(tmp^.Channel);

    ChanFlags := GetChannelFlags(tmp^.Channel);
    Hlp := '*** ('+ConvTime+') '+Call+'@'+Host+' joined ';
    IF ChanFlags AND SECRET>0 THEN Hlp := Hlp + 'this secret channel'
    ELSE IF ChanFlags AND INVISIBLE>0 THEN Hlp := Hlp + 'this invisible channel'
    ELSE BEGIN
      STR(tmp^.Channel,S);
      Hlp := Hlp + 'channel '+S;
    END;
    IF LENGTH(Pers)>0 THEN Hlp := Hlp + #13 + '    ('+Pers+')';

    FOR b := 0 TO 255 DO IF KS[b]<>NIL THEN IF KS[b]^.status=6 THEN BEGIN
      tmp2 := KS[b]^.ConvData^.Channels;
      OK := FALSE;
      WHILE (tmp2<>NIL) AND NOT OK DO BEGIN
        IF (tmp2^.Channel=tmp^.Channel) OR KS[b]^.ConvData^.Verb THEN BEGIN
          SendString(b,Hlp+#13);
          OK := TRUE;
        END;
        tmp := tmp^.next;
      END;
    END;

    IF Pers='' THEN Pers := '@';
    Host_USER_Cmd(ch,tmp^.Call,tmp^.Host,tmp^.Login,FromChan,ToChan,Pers);
  END
  ELSE BEGIN
    {************* Kanal verlassen ****************}
    IF Pers='' THEN Pers := '@';
    Host_USER_Cmd(ch,tmp^.Call,tmp^.Host,tmp^.Login,FromChan,ToChan,Pers);

    tmp:=ExtUserRoot;

    {Ist dies der einzige eingeloggte User?}
    IF tmp^.next=NIL THEN BEGIN
      {Ja - alles weg}
      DISPOSE(ExtUserRoot);
      ExtUserRoot:=NIL;
      Exit;
    END
    ELSE BEGIN
      {Nein - nur diesen User lschen}
      Found := FALSE;
      last := NIL;
      WHILE (tmp<>NIL) AND NOT Found DO BEGIN
        IF (tmp^.Channel=FromChan) AND (tmp^.Call=Call) THEN BEGIN
          IF last=NIL THEN ExtUserRoot := tmp^.next
                      ELSE last^.next := tmp^.next;
          dispose(tmp);
          found := TRUE;
        END
        ELSE BEGIN
          last := tmp;
          tmp := tmp^.next;
        END;
      END;
    END;


    STR(FromChan,Hlp);
    S := '*** ('+ConvTime+') '+Call+'@'+Host+' left channel '+Hlp+' ('+Pers+')'+#13;
    FOR b := 0 TO 255 DO IF KS[b]<>NIL THEN IF KS[b]^.status=6 THEN BEGIN
      tmp2 := KS[b]^.ConvData^.Channels;
      OK := FALSE;
      WHILE (tmp2<>NIL) AND NOT OK DO BEGIN
        IF tmp2^.Channel=FromChan THEN BEGIN
          OK := TRUE;
          SendString(b,S);
        END;
        tmp2 := tmp2^.next;
      END;
    END;
    DelOneUserAtChannel(fromchan);
  END;
END;


{Ping - Pong zurckschicken mit der eigenen Zeit}
PROCEDURE RX_Ping_Cmd(ch: BYTE);
VAR S: STRING;
BEGIN
  STR(KS[ch]^.ConvHost^.TX_Qual,S);
  PutData(ch,'/'+#255#128+'PONG '+S+#13);
END;

{Pong ist die Antwort auf ein Ping. Dahinter wird die Zeit zwischen
 dem letzten Ping/Pong angegeben}
PROCEDURE RX_Pong_Cmd(ch: BYTE; S: STRING);
VAR code: WORD;
    tmp: INTEGER;
    Diff: LONGINT;
BEGIN
  S := COPY(S,POS(' ',S)+1,255);
  VAL(S,tmp,code);
  IF code=0 THEN BEGIN
    KS[ch]^.ConvHost^.RX_Qual := tmp;
  END;
  IF KS[ch]^.ConvHost^.LastPing>0 THEN BEGIN
    KS[ch]^.ConvHost^.TX_Qual := AktUnixTime-KS[ch]^.ConvHost^.LastPing;

    {Wenns so schnell ist, das keine Sekunde vergeht, ist die Differenz 0.
     Dann auf 1 setzen (0=weg)}
    IF KS[ch]^.ConvHost^.TX_Qual=0 THEN KS[ch]^.ConvHost^.TX_Qual := 1;
    ChangeDestinationTime(KS[ch]^.ConvHost^.hostname,ROUND(KS[ch]^.ConvHost^.Tx_Qual+KS[ch]^.ConvHost^.Rx_Qual));
  END;
END;



PROCEDURE RX_CMSG_Cmd(ch: BYTE ;S: STRING);
VAR From: str6;
    Chan: INTEGER;
    code: WORD;
    Hlp: STRING;
    tmp: pHostListe;
BEGIN
  S := COPY(S,POS(' ',S)+1,255);

  From := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);

  Hlp := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);
  VAL(Hlp,Chan,code);
  IF code<>0 THEN Exit;

  SendTextToChannelUser(Chan,S,From,ch);

  tmp := HostDataRoot;
  WHILE tmp<>NIL DO BEGIN
    IF tmp^.Chan <> ch THEN
    BEGIN
      PutData(tmp^.Chan,'/'+#255#128+'CMSG '+From+' '+Hlp+' '+S+#13);
      INC(tmp^.Tx_Bytes);
    END;
    tmp := tmp^.next
  END;

END;
(*
PROCEDURE RX_AWAY_Cmd(ch: BYTE ;S: STRING);
VAR user,host: str10;
    Chan: INTEGER;
    code: WORD;
    time: LONGINT
    Hlp,text: STRING80;
    tmp: pHostListe;
BEGIN
  S := COPY(S,POS(' ',S)+1,255);

  user:= COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);

  host := COPY(S,1,POS(' ',S)-1);

  S := COPY(S,POS(' ',S)+1,255);

  IF POS(' ',s)>0 THEN
  BEGIN
    hlp:=COPY(S,1,POS(' ',s)-1)
    text:=
  END
    S := COPY(S,POS(' ',S)+1,255);

  VAL(S,time,code);
  IF code<>0 THEN Exit;


  tmp := HostDataRoot;
  WHILE tmp<>NIL DO BEGIN
    IF tmp^.Chan <> ch THEN PutData(tmp^.Chan,'/'+#255#128+'AWAY '+user+' '+host+' '+S+#13);
    tmp := tmp^.next
  END;

END;
*)
PROCEDURE SendPings;
VAR tmp: pHostListe;
BEGIN
  tmp := HostDataRoot;
  WHILE (tmp<>NIL) DO BEGIN
    IF (tmp^.Flags AND FLG_PINGPONG>0) AND (KS[tmp^.chan]<>NIL) AND
       (KS[tmp^.Chan]^.Convhost<>NIL) THEN BEGIN
      PutData(tmp^.Chan,'/'+#255#128+'PING'+#13);
      tmp^.LastPing := AktUnixTime;
    END;
    tmp := tmp^.Next;
  END;
END;


{Wird aufgerufen, wenn der erste Convers-Host-Befehl benutzt wird.}
FUNCTION LoginToServer(ch: BYTE; S: STRING): BOOLEAN;
VAR Hlp: STRING;
    tmp: pHostListe;
    OK: BOOLEAN;
BEGIN
  OK := FALSE;

  WHILE POS(#13,S)>0 DO DELETE(S,POS(#13,S),1);
  S := COPY(S,4,255);
  Hlp := COPY(S,1,POS(' ',S)-1);

  IF Hlp='HOST' THEN BEGIN
    Hlp := COPY(S,POS(' ',S)+1,255);
    Hlp := COPY(Hlp,1,POS(' ',Hlp)-1);

    tmp := HostDataRoot;
    WHILE tmp<>NIL DO BEGIN
      IF tmp^.Hostname=Hlp THEN OK := TRUE;
      tmp := tmp^.next;
    END;
  END;

  IF OK THEN BEGIN
    RX_Host_Cmd(ch,S);
    KS[ch]^.status := 110;
    SendPings;
    KS[ch]^.ConvHost^.State := 2;
    KS[ch]^.ConvHost^.Since := AktUnixTime;
  END;
  LoginToServer := OK;
END;


{Destination-Forwarding}
PROCEDURE RX_DEST_Cmd(ch: BYTE; S: STRING);
VAR Hlp: STRING;
    code: WORD;
    Desti: pDesti;
    Via,Hostname: str15;
    Soft: str10;
    Time: WORD;
BEGIN
  S := COPY(S,POS(' ',S)+1,255);

  Hlp := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);

  Hostname := Hlp;
  Via := KS[ch]^.ConvHost^.Hostname;

  IF POS(' ',S)>0 THEN BEGIN
    Hlp := COPY(S,1,POS(' ',S)-1);
    S := COPY(S,POS(' ',S)+1,255);
  END
  ELSE BEGIN
    Hlp := S;
    S := '';
  END;

  VAL(Hlp,Time,code);
  IF code<>0 THEN Exit;

  IF LENGTH(S)>0 THEN Soft := S
                 ELSE Soft := '';

  IF NOT IsInDestinationList(Hostname) THEN BEGIN
    IF Time>0 THEN NewDestination(Hostname,Via,Time,Soft)
  END
  ELSE BEGIN
    IF Time>0 THEN ChangeDestinationTime(Hostname,Time)
              ELSE DeleteDestination(Hostname);
  END;
END;



{Handle-Routine fr die Hosts}
PROCEDURE HostCommands(ch: BYTE; S: STRING);
VAR Hlp: STRING;tmp:pHostListe;Found:BOOLEAN;
BEGIN
  WHILE POS(#13,S)>0 DO DELETE(S,POS(#13,S),1);
  S := COPY(S,4,255);
  IF POS(' ',S)>0 THEN Hlp := COPY(S,1,POS(' ',S)-1)
                  ELSE Hlp := S;
  tmp := HostDataRoot;
  found:=FALSE;
  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.HostName=KS[ch]^.Convhost^.Hostname THEN
    BEGIN
      Found:=TRUE;
      INC(tmp^.RX_Bytes);
    END;
    tmp := tmp^.Next;
  END;

  {********** USER ein/ausloggen + Pers-text setzen ******************}
  IF Hlp='USER' THEN BEGIN
    RX_User_Cmd(ch,S);
    Exit;
  END;

  {***************** LAUFZEITMESSUNG **********************************}
  IF Hlp='PING' THEN BEGIN
    RX_Ping_Cmd(ch);
    Exit;
  END;
  IF Hlp='PONG' THEN BEGIN
    RX_Pong_Cmd(ch,S);
    Exit;
  END;

  {******** Normalen Text fr alle eingeloggten User schreiben **********}
  IF Hlp='CMSG' THEN BEGIN
    RX_CMSG_Cmd(ch,S);
    Exit;
  END;

  IF Hlp='DEST' THEN BEGIN
    RX_DEST_Cmd(ch,S);
    Exit;
  END;
END;


{Gibt die Kanal-Nummer zurck, auf dem die Station eingeloggt ist.}
FUNCTION GetHostChannel(Hostname: str15): BYTE;
VAR tmp: pHostListe;
BEGIN
  tmp := HostDataRoot;
  GetHostChannel := 0;
  WHILE tmp<>NIL DO BEGIN
    IF tmp^.Hostname=Hostname THEN GetHostChannel := tmp^.Chan;
    tmp := tmp^.next;
  END;

END;


{Destination neu Eintragen}
PROCEDURE NewDestination;
VAR tmp: pDesti;
BEGIN
  tmp := DestiRoot;
  IF tmp=NIL THEN BEGIN
    new(DestiRoot);
    tmp:=DestiRoot;
  END
  ELSE BEGIN
    tmp:=DestiRoot;
    WHILE tmp^.next<>NIL DO tmp:=tmp^.next;
    New(tmp^.Next);
    tmp:=tmp^.Next;
  END;

  tmp^.Next := NIL;
  tmp^.Host := Name;
  tmp^.Via := Via;
  tmp^.Zeit := Time;
  tmp^.Revis := Revision;
END;


{Lschen einer Destination aus der Liste}
PROCEDURE DeleteDestination(Host: str15);
VAR last,tmp: pDesti;
    Found: BOOLEAN;
BEGIN
  tmp := DestiRoot;

  {Gucken, ob dies der einzige Eintrag in der Destination-Liste ist}
  IF tmp^.next=NIL THEN BEGIN
    DISPOSE(DestiRoot);
    DestiRoot:=NIL;
    Exit;
  END;

  {Es sind mehrere Stationen in der Liste eingetragen}
  Found := FALSE;
  last := NIL;
  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Host=Host THEN BEGIN
      IF last=NIL THEN DestiRoot := tmp^.next
                  ELSE last^.next := tmp^.next;
      dispose(tmp);
      found := TRUE;
    END
    ELSE BEGIN
      last := tmp;
      tmp := tmp^.next;
    END;
  END;
END;


{ndern der Zeit einer Destination}
PROCEDURE ChangeDestinationTime(Host: str15; Newtime: WORD);
VAR tmp: pDesti;
    Found: BOOLEAN;
BEGIN
  tmp := DestiRoot;

  WHILE (tmp<>NIL) AND NOT found DO BEGIN
    IF tmp^.Host=Host THEN BEGIN
      tmp^.Zeit := NewTime;
      Found := TRUE;
    END;
    tmp := tmp^.next
  END;
END;


{Gibt TRUE zurck, wenn das angegebene Call in unserer Destination-Liste
 steht. Sonst FALSE}
FUNCTION IsInDestinationList(Host: str15): BOOLEAN;
VAR tmp: pDesti;
BEGIN
  tmp := DestiRoot;
  IsInDestinationList := FALSE;

  WHILE tmp<>NIL DO BEGIN
    IF tmp^.Host=Host THEN BEGIN
      IsInDestinationList := TRUE;
      Exit;
    END;
  END;
END;

END.