Unit Compunit;

{  $A+,B-,D+,E-,F-,G+,I-,L+,N-,O-,Q-,R-,S-,T-,V-}

Interface

{--- Gibt Versionsnummer zurck ---}
Function COMPVersion: Word;

{--- bergeben werden eine untypisierte Quellvariable und deren Groesser, sowie
     die untypisierte Zielvariable und deren maximale Groesse.
     Die Laenge der komprimierten Daten wird als Funktionsergebniss zurckgegeben. ---}
Function COMPCode(VAR Source; Len1: Word; Var Dest; Size: Word): Word;

{--- bergeben werden eine untypisierte Quellvariable und deren Groesser, sowie
     die untypisierte Zielvariable und deren maximale Groesse.
     Die Laenge der dekomprimierten Daten wird als Funktionsergebniss zurckgegeben. ---}
Function COMPDecode(VAR Source; Len1: Word; Var Dest; Size: Word): Word;

Implementation

Function COMPVersion: Word;
         Begin
            CompVersion:= $0050;
         end;

Type PByteCast = ^TByteCast;
     TByteCast = Array[0..$FFF0] of Byte;

Type PCode = ^TCode;
     TCode = Record
                Len : Word;
                Code: Word;
             end;

CONST NoNode =  0;
      NoChar = -1;

Type Node_t = Record
                 Bit0: Integer;
                 Bit1: Integer;
                 Ch  : Integer;
              end;

Const CTree: Array[0..257] of Array[0..1] of Word =
(
{  0} (15,  $AB2C), {  1} (15,  $AA84), {  2} (15,  $9FC4),
{  3} (15,  $AB3C), {  4} (15,  $AB1C), {  5} (15,  $AAFC),
{  6} (15,  $AAEC), {  7} (15,  $AAD4), {  8} (15,  $AAB4),
{  9} (10,  $F340), { 10} (15,  $AAA4), { 11} (15,  $7D64),
{ 12} (15,  $AADC), { 13} ( 7,  $F400), { 14} (15,  $AA94), 
{ 15} (15,  $9FF4), { 16} (15,  $9FD4), { 17} (15,  $7D74), 
{ 18} (15,  $AB44), { 19} (15,  $AB34), { 20} (15,  $AB24), 
{ 21} (15,  $AB14), { 22} (15,  $AB04), { 23} (15,  $AAF4), 
{ 24} (15,  $AAE4), { 25} (14,  $AB60), { 26} (15,  $AB0C), 
{ 27} (15,  $AACC), { 28} (15,  $AABC), { 29} (15,  $AAAC), 
{ 30} (15,  $AA9C), { 31} (15,  $AA8C), { 32} ( 3,  $C000), 
{ 33} ( 9,  $3A80), { 34} (10,  $ABC0), { 35} (11,    $60), 
{ 36} (12,  $7D40), { 37} (14,  $AB5C), { 38} (12,     $0), 
{ 39} (14,  $AB58), { 40} ( 9,  $7C00), { 41} ( 9,  $3C80), 
{ 42} (11,  $7D00), { 43} (12,    $10), { 44} ( 7,  $1200), 
{ 45} ( 7,  $7A00), { 46} ( 6,  $B800), { 47} ( 7,  $3200), 
{ 48} ( 7,  $2200), { 49} ( 8,  $F600), { 50} ( 8,  $3D00), 
{ 51} ( 9,  $9E00), { 52} ( 9,  $BD80), { 53} ( 9,  $7C80), 
{ 54} ( 9,    $80), { 55} ( 9,  $AA00), { 56} ( 9,  $BD00), 
{ 57} ( 9,  $9F00), { 58} ( 8,   $300), { 59} (13,  $AB78),
{ 60} (13,  $AB68), { 61} ( 9,  $3C00), { 62} ( 9,  $3000), 
{ 63} (11,    $20), { 64} (12,  $7D50), { 65} ( 7,  $3800), 
{ 66} ( 7,  $7800), { 67} ( 7,  $9C00), { 68} ( 7,  $FE00),
{ 69} ( 6,  $2400), { 70} ( 8,  $BC00), { 71} ( 8,   $200), 
{ 72} ( 8,   $100), { 73} ( 8,  $F100), { 74} (11,    $40), 
{ 75} ( 8,  $3100), { 76} ( 8,  $F200), { 77} ( 7,  $3400), 
{ 78} ( 7,  $1C00), { 79} ( 7,  $1E00), { 80} ( 7,  $BE00), 
{ 81} (11,  $ABA0), { 82} ( 7,  $3E00), { 83} ( 6,  $1400), 
{ 84} ( 7,  $3600), { 85} ( 9,  $F380), { 86} ( 9,  $F080), 
{ 87} ( 8,  $2000), { 88} ( 8,  $FC00), { 89} (10,  $9F80), 
{ 90} ( 9,  $9E80), { 91} (12,  $AB90), { 92} ( 9,  $3B80), 
{ 93} (12,  $AB80), { 94} (14,  $AB54), { 95} (13,  $3A50), 
{ 96} (14,  $AB50), { 97} ( 5,  $A000), { 98} ( 6,  $1800), 
{ 99} ( 6,  $9800), {100} ( 5,  $7000), {101} ( 3,  $4000),
{102} ( 6,   $400), {103} ( 6,  $AC00), {104} ( 6,  $F800), 
{105} ( 4,  $6000), {106} (10,  $3A00), {107} ( 8,  $FD00), 
{108} ( 5,  $2800), {109} ( 6,  $B000), {110} ( 4,  $8000), 
{111} ( 6,  $B400), {112} ( 7,  $1000), {113} (12,  $7D20), 
{114} ( 5,  $E000), {115} ( 5,  $9000), {116} ( 5,  $E800), 
{117} ( 5,   $800), {118} ( 8,  $F700), {119} ( 7,  $A800), 
{120} ( 9,  $7D80), {121} (10,  $F300), {122} ( 7,  $7E00), 
{123} (14,  $AB48), {124} (13,  $3A48), {125} (14,  $AB4C), 
{126} (12,  $3A60), {127} (15,  $9FFC), {128} (15,  $9FEC), 
{129} ( 8,  $2100), {130} (15,  $9FDC), {131} (15,  $9FCC), 
{132} ( 9,  $F000), {133} (15,  $7D7C), {134} (15,  $7D6C),
{135} (14,  $3A40), {136} (15,  $AB40), {137} (15,  $AB38), 
{138} (15,  $AB30), {139} (15,  $AB28), {140} (15,  $AB20),
{141} (15,  $AB18), {142} (13,  $AB70), {143} (15,  $AB10), 
{144} (15,  $AB08), {145} (15,  $AB00), {146} (15,  $AAF8), 
{147} (15,  $AAF0), {148} ( 9,  $3B00), {149} (15,  $AAE8), 
{150} (15,  $AAE0), {151} (15,  $AAD8), {152} (15,  $AAD0), 
{153} (14,  $AB64), {154} (12,  $7D30), {155} (15,  $AAC8), 
{156} (15,  $AAC0), {157} (15,  $AAB8), {158} (15,  $AAB0), 
{159} (15,  $AAA8), {160} (15,  $AAA0), {161} (15,  $AA98), 
{162} (15,  $AA90), {163} (15,  $AA88), {164} (15,  $AA80), 
{165} (15,  $9FF8), {166} (15,  $9FF0), {167} (15,  $9FE8), 
{168} (15,  $9FE0), {169} (15,  $9FD8), {170} (15,  $9FD0), 
{171} (15,  $9FC8), {172} (15,  $9FC0), {173} (15,  $7D78), 
{174} (15,  $7D70), {175} (13,  $3A58), {176} (15,  $7D68), 
{177} (15,  $7D60), {178} (15,  $AB46), {179} (15,  $AB42), 
{180} (15,  $AB3E), {181} (15,  $AB3A), {182} (15,  $AB36), 
{183} (15,  $AB32), {184} (15,  $AB2E), {185} (15,  $AB2A), 
{186} (15,  $AB26), {187} (15,  $AB22), {188} (15,  $AB1E), 
{189} (15,  $AB1A), {190} (15,  $AB16), {191} (15,  $AB12), 
{192} (15,  $AB0E), {193} (15,  $AB0A), {194} (15,  $AB06), 
{195} (15,  $AB02), {196} (15,  $AAFE), {197} (15,  $AAFA),
{198} (15,  $AAF6), {199} (15,  $AAF2), {200} (15,  $AAEE),
{201} (15,  $AAEA), {202} (15,  $AAE6), {203} (15,  $AAE2), 
{204} (15,  $AADE), {205} (15,  $AADA), {206} (15,  $AAD6), 
{207} (15,  $AAD2), {208} (15,  $AACE), {209} (15,  $AACA), 
{210} (15,  $AAC6), {211} (15,  $AAC2), {212} (15,  $AABE), 
{213} (15,  $AABA), {214} (15,  $AAB6), {215} (15,  $AAB2), 
{216} (15,  $AAAE), {217} (15,  $AAAA), {218} (15,  $AAA6), 
{219} (15,  $AAA2), {220} (15,  $AA9E), {221} (12,  $3A70), 
{222} (15,  $AA9A), {223} (15,  $AA96), {224} (15,  $AA92), 
{225} ( 9,  $3080), {226} (15,  $AA8E), {227} (15,  $AA8A), 
{228} (15,  $AA86), {229} (15,  $AA82), {230} (15,  $9FFE), 
{231} (15,  $9FFA), {232} (15,  $9FF6), {233} (15,  $9FF2),
{234} (15,  $9FEE), {235} (15,  $9FEA), {236} (15,  $9FE6), 
{237} (15,  $9FE2), {238} (15,  $9FDE), {239} (15,  $9FDA), 
{240} (15,  $9FD6), {241} (15,  $9FD2), {242} (15,  $9FCE), 
{243} (15,  $9FCA), {244} (15,  $9FC6), {245} (15,  $9FC2), 
{246} (15,  $7D7E), {247} (15,  $7D7A), {248} (15,  $7D76), 
{249} (15,  $7D72), {250} (15,  $7D6E), {251} (15,  $7D6A), 
{252} (15,  $7D66), {253} (15,  $7D62), {254} (15,  $3A46), 
{255} (15,  $3A44), {256} (15,  $AAC4), {257} (15,  $9FE4));


Const DTree: Array[0..512] of Array[0..2] of Integer =
(
{  0} (    79,      1, NoChar),
{  1} (     2,     66, NoChar),
{  2} (    24,      3, NoChar),
{  3} (     4,    208, NoChar),
{  4} (   292,      5, NoChar),
{  5} (     6,    298, NoChar),
{  6} (   317,      7, NoChar),
{  7} (    16,      8, NoChar),
{  8} (     9,    173, NoChar),
{  9} (    10,    116, NoChar),
{ 10} (    41,     11, NoChar),
{ 11} (    12,     37, NoChar),
{ 12} (   125,     13, NoChar),
{ 13} (   357,     14, NoChar),
{ 14} (    15,    438, NoChar),
{ 15} (NoNode, NoNode,      0),
{ 16} (   229,     17, NoChar),
{ 17} (    18,     46, NoChar),
{ 18} (    19,     61, NoChar),
{ 19} (    20,     99, NoChar),
{ 20} (    21,    161, NoChar),
{ 21} (   404,     22, NoChar),
{ 22} (    23,    483, NoChar),
{ 23} (NoNode, NoNode,      1),
{ 24} (   306,     25, NoChar),
{ 25} (   313,     26, NoChar),
{ 26} (   294,     27, NoChar),
{ 27} (   245,     28, NoChar),
{ 28} (   221,     29, NoChar),
{ 29} (   231,     30, NoChar),
{ 30} (   277,     31, NoChar),
{ 31} (    32,    103, NoChar),
{ 32} (    33,    108, NoChar),
{ 33} (    34,    339, NoChar),
{ 34} (   421,     35, NoChar),
{ 35} (    36,    500, NoChar),
{ 36} (NoNode, NoNode,      2),
{ 37} (   122,     38, NoChar),
{ 38} (   353,     39, NoChar),
{ 39} (    40,    434, NoChar),
{ 40} (NoNode, NoNode,      3),
{ 41} (   131,     42, NoChar),
{ 42} (   128,     43, NoChar),
{ 43} (   361,     44, NoChar),
{ 44} (    45,    442, NoChar),
{ 45} (NoNode, NoNode,      4),
{ 46} (    56,     47, NoChar),
{ 47} (    52,     48, NoChar),
{ 48} (   135,     49, NoChar),
{ 49} (   370,     50, NoChar),
{ 50} (    51,    450, NoChar),
{ 51} (NoNode, NoNode,      5),
{ 52} (   138,     53, NoChar),
{ 53} (   375,     54, NoChar),
{ 54} (    55,    454, NoChar),
{ 55} (NoNode, NoNode,      6),
{ 56} (   148,     57, NoChar),
{ 57} (    58,     94, NoChar),
{ 58} (   381,     59, NoChar),
{ 59} (    60,    460, NoChar),
{ 60} (NoNode, NoNode,      7),
{ 61} (    75,     62, NoChar),
{ 62} (    63,    152, NoChar),
{ 63} (   392,     64, NoChar),
{ 64} (    65,    469, NoChar),
{ 65} (NoNode, NoNode,      8),
{ 66} (   164,     67, NoChar),
{ 67} (   311,     68, NoChar),
{ 68} (    69,    246, NoChar),
{ 69} (    70,     97, NoChar),
{ 70} (   253,     71, NoChar),
{ 71} (   257,     72, NoChar),
{ 72} (    73,    270, NoChar),
{ 73} (   319,     74, NoChar),
{ 74} (NoNode, NoNode,      9),
{ 75} (    76,    155, NoChar),
{ 76} (   396,     77, NoChar),
{ 77} (    78,    473, NoChar),
{ 78} (NoNode, NoNode,     10),
{ 79} (   165,     80, NoChar),
{ 80} (   296,     81, NoChar),
{ 81} (   300,     82, NoChar),
{ 82} (   295,     83, NoChar),
{ 83} (   206,     84, NoChar),
{ 84} (    85,    320, NoChar),
{ 85} (   193,     86, NoChar),
{ 86} (    87,    318, NoChar),
{ 87} (   199,     88, NoChar),
{ 88} (   184,     89, NoChar),
{ 89} (    90,    112, NoChar),
{ 90} (    91,    346, NoChar),
{ 91} (   430,     92, NoChar),
{ 92} (    93,    508, NoChar),
{ 93} (NoNode, NoNode,     11),
{ 94} (   379,     95, NoChar),
{ 95} (    96,    458, NoChar),
{ 96} (NoNode, NoNode,     12),
{ 97} (    98,    218, NoChar),
{ 98} (NoNode, NoNode,     13),
{ 99} (   100,    158, NoChar),
{100} (   400,    101, NoChar),
{101} (   102,    478, NoChar),
{102} (NoNode, NoNode,     14),
{103} (   331,    104, NoChar),
{104} (   105,    328, NoChar),
{105} (   408,    106, NoChar),
{106} (   107,    487, NoChar),
{107} (NoNode, NoNode,     15),
{108} (   109,    336, NoChar),
{109} (   417,    110, NoChar),
{110} (   111,    496, NoChar),
{111} (NoNode, NoNode,     16),
{112} (   113,    343, NoChar),
{113} (   425,    114, NoChar),
{114} (   115,    504, NoChar),
{115} (NoNode, NoNode,     17),
{116} (   117,    141, NoChar),
{117} (   118,    186, NoChar),
{118} (   119,    321, NoChar),
{119} (   351,    120, NoChar),
{120} (   121,    432, NoChar),
{121} (NoNode, NoNode,     18),
{122} (   355,    123, NoChar),
{123} (   124,    436, NoChar),
{124} (NoNode, NoNode,     19),
{125} (   359,    126, NoChar),
{126} (   127,    440, NoChar),
{127} (NoNode, NoNode,     20),
{128} (   364,    129, NoChar),
{129} (   130,    444, NoChar),
{130} (NoNode, NoNode,     21),
{131} (   132,    145, NoChar),
{132} (   368,    133, NoChar),
{133} (   134,    448, NoChar),
{134} (NoNode, NoNode,     22),
{135} (   372,    136, NoChar),
{136} (   137,    452, NoChar),
{137} (NoNode, NoNode,     23),
{138} (   377,    139, NoChar),
{139} (   140,    456, NoChar),
{140} (NoNode, NoNode,     24),
{141} (   142,    234, NoChar),
{142} (   143,    236, NoChar),
{143} (   144,    383, NoChar),
{144} (NoNode, NoNode,     25),
{145} (   366,    146, NoChar),
{146} (   147,    446, NoChar),
{147} (NoNode, NoNode,     26),
{148} (   387,    149, NoChar),
{149} (   385,    150, NoChar),
{150} (   151,    462, NoChar),
{151} (NoNode, NoNode,     27),
{152} (   390,    153, NoChar),
{153} (   154,    467, NoChar),
{154} (NoNode, NoNode,     28),
{155} (   394,    156, NoChar),
{156} (   157,    471, NoChar),
{157} (NoNode, NoNode,     29),
{158} (   398,    159, NoChar),
{159} (   160,    475, NoChar),
{160} (NoNode, NoNode,     30),
{161} (   402,    162, NoChar),
{162} (   163,    481, NoChar),
{163} (NoNode, NoNode,     31),
{164} (NoNode, NoNode,     32),
{165} (   175,    166, NoChar),
{166} (   214,    167, NoChar),
{167} (   211,    168, NoChar),
{168} (   169,    195, NoChar),
{169} (   243,    170, NoChar),
{170} (   171,    281, NoChar),
{171} (   286,    172, NoChar),
{172} (NoNode, NoNode,     33),
{173} (   265,    174, NoChar),
{174} (NoNode, NoNode,     34),
{175} (   176,    202, NoChar),
{176} (   177,    315, NoChar),
{177} (   178,    297, NoChar),
{178} (   179,    232, NoChar),
{179} (   180,    252, NoChar),
{180} (   181,    228, NoChar),
{181} (   189,    182, NoChar),
{182} (   255,    183, NoChar),
{183} (NoNode, NoNode,     35),
{184} (   185,    242, NoChar),
{185} (NoNode, NoNode,     36),
{186} (   284,    187, NoChar),
{187} (   192,    188, NoChar),
{188} (NoNode, NoNode,     37),
{189} (   190,    241, NoChar),
{190} (   191,    201, NoChar),
{191} (NoNode, NoNode,     38),
{192} (NoNode, NoNode,     39),
{193} (   194,    227, NoChar),
{194} (NoNode, NoNode,     40),
{195} (   196,    267, NoChar),
{196} (   197,    220, NoChar),
{197} (   237,    198, NoChar),
{198} (NoNode, NoNode,     41),
{199} (   200,    309, NoChar),
{200} (NoNode, NoNode,     42),
{201} (NoNode, NoNode,     43),
{202} (   203,    260, NoChar),
{203} (   204,    268, NoChar),
{204} (   308,    205, NoChar),
{205} (NoNode, NoNode,     44),
{206} (   244,    207, NoChar),
{207} (NoNode, NoNode,     45),
{208} (   304,    209, NoChar),
{209} (   210,    223, NoChar),
{210} (NoNode, NoNode,     46),
{211} (   212,    258, NoChar),
{212} (   238,    213, NoChar),
{213} (NoNode, NoNode,     47),
{214} (   215,    303, NoChar),
{215} (   216,    249, NoChar),
{216} (   273,    217, NoChar),
{217} (NoNode, NoNode,     48),
{218} (   219,    316, NoChar),
{219} (NoNode, NoNode,     49),
{220} (NoNode, NoNode,     50),
{221} (   222,    278, NoChar),
{222} (NoNode, NoNode,     51),
{223} (   224,    264, NoChar),
{224} (   250,    225, NoChar),
{225} (   230,    226, NoChar),
{226} (NoNode, NoNode,     52),
{227} (NoNode, NoNode,     53),
{228} (NoNode, NoNode,     54),
{229} (NoNode, NoNode,     55),
{230} (NoNode, NoNode,     56),
{231} (NoNode, NoNode,     57),
{232} (   251,    233, NoChar),
{233} (NoNode, NoNode,     58),
{234} (   363,    235, NoChar),
{235} (NoNode, NoNode,     59),
{236} (NoNode, NoNode,     60),
{237} (NoNode, NoNode,     61),
{238} (   239,    256, NoChar),
{239} (   240,    480, NoChar),
{240} (NoNode, NoNode,     62),
{241} (NoNode, NoNode,     63),
{242} (NoNode, NoNode,     64),
{243} (NoNode, NoNode,     65),
{244} (NoNode, NoNode,     66),
{245} (NoNode, NoNode,     67),
{246} (   299,    247, NoChar),
{247} (   275,    248, NoChar),
{248} (NoNode, NoNode,     68),
{249} (NoNode, NoNode,     69),
{250} (NoNode, NoNode,     70),
{251} (NoNode, NoNode,     71),
{252} (NoNode, NoNode,     72),
{253} (   271,    254, NoChar),
{254} (NoNode, NoNode,     73),
{255} (NoNode, NoNode,     74),
{256} (NoNode, NoNode,     75),
{257} (NoNode, NoNode,     76),
{258} (   259,    269, NoChar),
{259} (NoNode, NoNode,     77),
{260} (   293,    261, NoChar),
{261} (   262,    263, NoChar),
{262} (NoNode, NoNode,     78),
{263} (NoNode, NoNode,     79),
{264} (NoNode, NoNode,     80),
{265} (   279,    266, NoChar),
{266} (NoNode, NoNode,     81),
{267} (NoNode, NoNode,     82),
{268} (NoNode, NoNode,     83),
{269} (NoNode, NoNode,     84),
{270} (NoNode, NoNode,     85),
{271} (   342,    272, NoChar),
{272} (NoNode, NoNode,     86),
{273} (   274,    335, NoChar),
{274} (NoNode, NoNode,     87),
{275} (   276,    302, NoChar),
{276} (NoNode, NoNode,     88),
{277} (NoNode, NoNode,     89),
{278} (NoNode, NoNode,     90),
{279} (   283,    280, NoChar),
{280} (NoNode, NoNode,     91),
{281} (   374,    282, NoChar),
{282} (NoNode, NoNode,     92),
{283} (NoNode, NoNode,     93),
{284} (   291,    285, NoChar),
{285} (NoNode, NoNode,     94),
{286} (   301,    287, NoChar),
{287} (   288,    326, NoChar),
{288} (   323,    289, NoChar),
{289} (   290,    427, NoChar),
{290} (NoNode, NoNode,     95),
{291} (NoNode, NoNode,     96),
{292} (NoNode, NoNode,     97),
{293} (NoNode, NoNode,     98),
{294} (NoNode, NoNode,     99),
{295} (NoNode, NoNode,    100),
{296} (NoNode, NoNode,    101),
{297} (NoNode, NoNode,    102),
{298} (NoNode, NoNode,    103),
{299} (NoNode, NoNode,    104),
{300} (NoNode, NoNode,    105),
{301} (NoNode, NoNode,    106),
{302} (NoNode, NoNode,    107),
{303} (NoNode, NoNode,    108),
{304} (   305,    307, NoChar),
{305} (NoNode, NoNode,    109),
{306} (NoNode, NoNode,    110),
{307} (NoNode, NoNode,    111),
{308} (NoNode, NoNode,    112),
{309} (   310,    384, NoChar),
{310} (NoNode, NoNode,    113),
{311} (   312,    314, NoChar),
{312} (NoNode, NoNode,    114),
{313} (NoNode, NoNode,    115),
{314} (NoNode, NoNode,    116),
{315} (NoNode, NoNode,    117),
{316} (NoNode, NoNode,    118),
{317} (NoNode, NoNode,    119),
{318} (NoNode, NoNode,    120),
{319} (NoNode, NoNode,    121),
{320} (NoNode, NoNode,    122),
{321} (   322,    325, NoChar),
{322} (NoNode, NoNode,    123),
{323} (   349,    324, NoChar),
{324} (NoNode, NoNode,    124),
{325} (NoNode, NoNode,    125),
{326} (   327,    476, NoChar),
{327} (NoNode, NoNode,    126),
{328} (   406,    329, NoChar),
{329} (   330,    485, NoChar),
{330} (NoNode, NoNode,    127),
{331} (   412,    332, NoChar),
{332} (   410,    333, NoChar),
{333} (   334,    489, NoChar),
{334} (NoNode, NoNode,    128),
{335} (NoNode, NoNode,    129),
{336} (   415,    337, NoChar),
{337} (   338,    494, NoChar),
{338} (NoNode, NoNode,    130),
{339} (   419,    340, NoChar),
{340} (   341,    498, NoChar),
{341} (NoNode, NoNode,    131),
{342} (NoNode, NoNode,    132),
{343} (   423,    344, NoChar),
{344} (   345,    502, NoChar),
{345} (NoNode, NoNode,    133),
{346} (   428,    347, NoChar),
{347} (   348,    506, NoChar),
{348} (NoNode, NoNode,    134),
{349} (   350,    510, NoChar),
{350} (NoNode, NoNode,    135),
{351} (   352,    433, NoChar),
{352} (NoNode, NoNode,    136),
{353} (   354,    435, NoChar),
{354} (NoNode, NoNode,    137),
{355} (   356,    437, NoChar),
{356} (NoNode, NoNode,    138),
{357} (   358,    439, NoChar),
{358} (NoNode, NoNode,    139),
{359} (   360,    441, NoChar),
{360} (NoNode, NoNode,    140),
{361} (   362,    443, NoChar),
{362} (NoNode, NoNode,    141),
{363} (NoNode, NoNode,    142),
{364} (   365,    445, NoChar),
{365} (NoNode, NoNode,    143),
{366} (   367,    447, NoChar),
{367} (NoNode, NoNode,    144),
{368} (   369,    449, NoChar),
{369} (NoNode, NoNode,    145),
{370} (   371,    451, NoChar),
{371} (NoNode, NoNode,    146),
{372} (   373,    453, NoChar),
{373} (NoNode, NoNode,    147),
{374} (NoNode, NoNode,    148),
{375} (   376,    455, NoChar),
{376} (NoNode, NoNode,    149),
{377} (   378,    457, NoChar),
{378} (NoNode, NoNode,    150),
{379} (   380,    459, NoChar),
{380} (NoNode, NoNode,    151),
{381} (   382,    461, NoChar),
{382} (NoNode, NoNode,    152),
{383} (NoNode, NoNode,    153),
{384} (NoNode, NoNode,    154),
{385} (   386,    463, NoChar),
{386} (NoNode, NoNode,    155),
{387} (   388,    464, NoChar),
{388} (   389,    466, NoChar),
{389} (NoNode, NoNode,    156),
{390} (   391,    468, NoChar),
{391} (NoNode, NoNode,    157),
{392} (   393,    470, NoChar),
{393} (NoNode, NoNode,    158),
{394} (   395,    472, NoChar),
{395} (NoNode, NoNode,    159),
{396} (   397,    474, NoChar),
{397} (NoNode, NoNode,    160),
{398} (   399,    477, NoChar),
{399} (NoNode, NoNode,    161),
{400} (   401,    479, NoChar),
{401} (NoNode, NoNode,    162),
{402} (   403,    482, NoChar),
{403} (NoNode, NoNode,    163),
{404} (   405,    484, NoChar),
{405} (NoNode, NoNode,    164),
{406} (   407,    486, NoChar),
{407} (NoNode, NoNode,    165),
{408} (   409,    488, NoChar),
{409} (NoNode, NoNode,    166),
{410} (   411,    490, NoChar),
{411} (NoNode, NoNode,    167),
{412} (   413,    491, NoChar),
{413} (   414,    493, NoChar),
{414} (NoNode, NoNode,    168),
{415} (   416,    495, NoChar),
{416} (NoNode, NoNode,    169),
{417} (   418,    497, NoChar),
{418} (NoNode, NoNode,    170),
{419} (   420,    499, NoChar),
{420} (NoNode, NoNode,    171),
{421} (   422,    501, NoChar),
{422} (NoNode, NoNode,    172),
{423} (   424,    503, NoChar),
{424} (NoNode, NoNode,    173),
{425} (   426,    505, NoChar),
{426} (NoNode, NoNode,    174),
{427} (NoNode, NoNode,    175),
{428} (   429,    507, NoChar),
{429} (NoNode, NoNode,    176),
{430} (   431,    509, NoChar),
{431} (NoNode, NoNode,    177),
{432} (NoNode, NoNode,    178),
{433} (NoNode, NoNode,    179),
{434} (NoNode, NoNode,    180),
{435} (NoNode, NoNode,    181),
{436} (NoNode, NoNode,    182),
{437} (NoNode, NoNode,    183),
{438} (NoNode, NoNode,    184),
{439} (NoNode, NoNode,    185),
{440} (NoNode, NoNode,    186),
{441} (NoNode, NoNode,    187),
{442} (NoNode, NoNode,    188),
{443} (NoNode, NoNode,    189),
{444} (NoNode, NoNode,    190),
{445} (NoNode, NoNode,    191),
{446} (NoNode, NoNode,    192),
{447} (NoNode, NoNode,    193),
{448} (NoNode, NoNode,    194),
{449} (NoNode, NoNode,    195),
{450} (NoNode, NoNode,    196),
{451} (NoNode, NoNode,    197),
{452} (NoNode, NoNode,    198),
{453} (NoNode, NoNode,    199),
{454} (NoNode, NoNode,    200),
{455} (NoNode, NoNode,    201),
{456} (NoNode, NoNode,    202),
{457} (NoNode, NoNode,    203),
{458} (NoNode, NoNode,    204),
{459} (NoNode, NoNode,    205),
{460} (NoNode, NoNode,    206),
{461} (NoNode, NoNode,    207),
{462} (NoNode, NoNode,    208),
{463} (NoNode, NoNode,    209),
{464} (     0,    465, NoChar),
{465} (NoNode, NoNode,    210),
{466} (NoNode, NoNode,    211),
{467} (NoNode, NoNode,    212),
{468} (NoNode, NoNode,    213),
{469} (NoNode, NoNode,    214),
{470} (NoNode, NoNode,    215),
{471} (NoNode, NoNode,    216),
{472} (NoNode, NoNode,    217),
{473} (NoNode, NoNode,    218),
{474} (NoNode, NoNode,    219),
{475} (NoNode, NoNode,    220),
{476} (NoNode, NoNode,    221),
{477} (NoNode, NoNode,    222),
{478} (NoNode, NoNode,    223),
{479} (NoNode, NoNode,    224),
{480} (NoNode, NoNode,    225),
{481} (NoNode, NoNode,    226),
{482} (NoNode, NoNode,    227),
{483} (NoNode, NoNode,    228),
{484} (NoNode, NoNode,    229),
{485} (NoNode, NoNode,    230),
{486} (NoNode, NoNode,    231),
{487} (NoNode, NoNode,    232),
{488} (NoNode, NoNode,    233),
{489} (NoNode, NoNode,    234),
{490} (NoNode, NoNode,    235),
{491} (     0,    492, NoChar),
{492} (NoNode, NoNode,    236),
{493} (NoNode, NoNode,    237),
{494} (NoNode, NoNode,    238),
{495} (NoNode, NoNode,    239),
{496} (NoNode, NoNode,    240),
{497} (NoNode, NoNode,    241),
{498} (NoNode, NoNode,    242),
{499} (NoNode, NoNode,    243),
{500} (NoNode, NoNode,    244),
{501} (NoNode, NoNode,    245),
{502} (NoNode, NoNode,    246),
{503} (NoNode, NoNode,    247),
{504} (NoNode, NoNode,    248),
{505} (NoNode, NoNode,    249),
{506} (NoNode, NoNode,    250),
{507} (NoNode, NoNode,    251),
{508} (NoNode, NoNode,    252),
{509} (NoNode, NoNode,    253),
{510} (   512,    511, NoChar),
{511} (NoNode, NoNode,    254),
{512} (NoNode, NoNode,    255)
);

Function COMPCode(VAR Source; Len1: Word; Var Dest; Size: Word): Word;
Var I     : Word;
    Ch    : Word;
    Len   : Word;
    Len2  : Word;
    Out   : Word;
    BitCnt: Byte;
    Huf   : PCode;

Procedure PutByte(AChar: Byte);
Begin
   Inc(Len2);
   BitCnt:= 0;
   {--- Damit nicht meh Zeichen als zulssig gespeichert werden. ---}
   If Len2 >= Size Then EXIT;
   TByteCast(Dest)[Len2]:= AChar;
end;

Begin
   BitCnt:= 0;
   Out := 0;
   Len2:= 0;
   For I:= 0 TO Len1-1 DO
   Begin
      Huf:= PCode(@CTree[TByteCast(Source)[I]]);
      Ch := Huf^.Code;
      Len:= Huf^.Len;
      While Len > 0 DO
      Begin
         If (CH AND $8000) = $8000 Then
            Out:= Out SHL 1 + 1
         else
            Out:= Out SHL 1;
         Inc(BitCnt);
         If BitCnt = 8 Then PutByte(Out AND $FF);
         CH:= CH SHL 1;
         Dec(Len);
      end;
   end;
   If BitCnt <> 0 Then
   Begin
      Out:= Out SHL (8-BitCnt);
      PutByte(Out AND $FF);
   end;
   If Len2 > Len1 Then
   Begin
      Move(Source, TByteCast(Dest)[1], Len1);
      TByteCast(Dest)[0]:= 255;
      COMPCode:= Len1+1;
   end else
   Begin
      TByteCast(Dest)[0]:= (Len1 AND $FF) - 1;
      COMPCode:= Len2+1;
   end;
end;

{--- Test, ob Daten COMP-kodiert sind kann auch mit dieser Routine erfolgen.
     Ist die zurckgegebene Laenge um 1 groesser, als im ersten Byte des Datenbuffers steht,
     so KANN das Frame COMP-kodiert sein ---}

Function COMPDecode(VAR Source; Len1: Word; Var Dest; Size: Word): Word;
Var Node  : ^Node_t;
    BitCnt: Word;
    Ch    : Integer;
    I     : Word;
    DSize : Word;
Begin
   If TByteCast(Source)[0] = 255 Then
   Begin
   {--- Lngenbyte = 255 -> Nachfolgende Daten nicht COMP-Kodiert ---}
      Move(TByteCast(Source)[1], Dest, Len1-1);
      DSize:= Len1-1;
   end else
   Begin
   {--- COMP-kodierte Daten ---}
      Node := @DTree[0];
      DSize:= 0;
      For I:= 1 TO Len1-1 DO
      Begin
         Ch:= TByteCast(Source)[i];
         For BitCnt:= 7 DownTO 0 DO
         Begin
            If (Ch AND $80) = $80 Then
               Node:= @DTree[Node^.Bit1]
            else
               Node:= @DTree[Node^.Bit0];

            If Node^.Ch <> NoChar Then
            Begin
               If DSize < Size Then
                  TByteCast(Dest)[DSize]:= Node^.Ch;
               Inc(DSize);
               Node:= @DTree[0];
            end;
            Ch:= Ch SHL 1;
         end;
      end;
   end;
   COMPDecode:= DSize;
end;

end.