(****************************************************************************)
(* Packet-Radio I/O-Routinen MCUT.                                          *)
(* TNC-Polling, PC/FlexNet-Interface, Daten senden, Monitor-Auswertung      *)
(* Nicht als Overlay deklarieren!                                           *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(****************************************************************************)
UNIT PACKET;

INTERFACE

{$IFDEF WA8DED}
PROCEDURE PollTNC;
{$ENDIF}
{$IFDEF FLEXNET}
PROCEDURE DoFlexNet;

(* Diese Funktion ueberlaedt die gleichnamige aus dem FLXAPP, da diese
   fehlerhaft ist *)
FUNCTION l2_pconnect(Source,Destination:STRING):WORD;
{$ENDIF}
PROCEDURE DoSendChannels(B:BYTE);
PROCEDURE SetMonitor;


{FUNCTION GetNewMHEntry(VAR src,dest:STRING):INTEGER;}
PROCEDURE SendUnproto(VAR src,dst,data:STRING);


TYPE ByteArray=ARRAY[0..255] OF BYTE;
     PMHentry=^TMHEntry;
     TMHEntry=RECORD
        src,dest:STRING[10];
        path:string;
        port:byte;
        tkby,rkby,text,tcpip,netrom,flexnet,pacsat,unknown:WORD;
        RR,REJ,I,PLUS,MINUS,frames,tottxd:LONGINT;
        lasttxd,avgtxd,maxtxd:BYTE;
        spynr:byte;
        last:longint;
        next:PMHEntry;
	      END;
{$IFDEF BB}
TYPE
  BBEntry=RECORD
	    call: STRING[10];
	    starttime,stoptime: LONGINT;
	    starth,stoph: WORD;
	    txd,len,typ: BYTE;
	  END;
VAR
  BBArr:ARRAY[0..100] OF BBEntry;

CONST BBEntryPos:BYTE=0;
{$ENDIF}  

FUNCTION InsertMHEntry(VAR src,dst:STRING):PMHEntry;
FUNCTION FindMHEntry(VAR src,dest:STRING):PMHEntry;
        

VAR
    mhliste       : ARRAY[0..255] OF pmhentry;
    l,r,hilfstr   : STRING;
    B,W,C         : WORD;
    header:STRING;
    MONI_RPL_FILE : FILE;

IMPLEMENTATION

USES IADVAR,
     {$IFDEF FLEXNET}
     FLXAPP,
     {$ENDIF}
     {$IFDEF WA8DED}
     TNC,
     {$ENDIF}
     COMPUNIT,
     {$IFDEF M}
     MONIMCT,
     {$ELSE}
     TCPIP,
     {$ENDIF}
     MYSTRING,
     SCREEN,
     MCUTLIB2,
     TOOLBOX,
     TERM_O,VIDEO,DOS,CRT,unproto,
     {$IFNDEF LINUX}
     MEMORY,
     {$ENDIF}
     SPYNEW;


CONST MHanz:BYTE=0;
      MHMax:BYTE=50;

(* DumpMoni schreibt Monitordaten in eine datei MCUT.RPL und zwar in
   einem Format, welches das Programm MONI_RPL.EXE von Walter, DG9EP
   auswerten kann
*)   


(* MHGarbage-Collection geht die Hash-Tabelle der MH-Liste durch,
 * sammelt die 10 aeltesten Eintrage im array c1,
 * geht die Tabelle nochmal durch, vergleicht alles mit c1 und
 * entfernt die alten Eintraege.
 *)
PROCEDURE MHGarbageCollection;
VAR P1,p2 : PMHentry;
   p3	     : ^PMHentry;   
   tim	     : LONGINT;
   c1	     : ARRAY[0..20] OF LongInt;
   b,weganz  : BYTE;
W	     : WORD;
BEGIN
   weganz:=0;
  tim:=currixtime;
  for b:=1 TO 20 DO
  BEGIN
    c1[b]:=tim;
  END;
  for w:=0 TO 255 DO
  BEGIN
    p1:=MHLISTE[w];
    while p1<>NIL DO
    BEGIN
      b:=1;
      while (b<=10) AND (c1[b]<p1^.last) do INC(b);
      if b<11 THEN c1[b]:=p1^.last;
      p1:=p1^.next;
    END;   
  END;
  for w:=0 TO 255 DO
  BEGIN
    p1:=MHLISTE[w];
    p3:=@MHLISTE[W];
    while p1<>NIL DO
    BEGIN
      b:=1;
      while (b<=10) AND (c1[b]<=p1^.last) do INC(b);
      {p2:=p1^.next;}
      if b<11 THEN 
      BEGIN
	 p3^:=p1^.next;
	 if p1^.spynr>0 THEN
	    delspy(p1^.spynr);
	 dispose(p1);
	 dec(mhanz);
	 inc(weganz);if weganz>9 then exit;
      END ELSE
      BEGIN	 
	 p3:=@p1^.next;
      END;
       p1:=p3^;
    END;   
  END;
END;
(*
 *  MHHash berechnet aus Quell und Ziellcall einen Hash-Index mit dem
 *  dann auf die MH-Tabelle zugegriffen wird.
 *)
FUNCTION MHHash(src,dest:STRING):BYTE;
VAR B,hash,h1,h2:WORD;
BEGIN
  if pos(' ',dest)>0 THEN dest:=copy(dest,1,pos(' ',dest)-1);
  hash:=0;h1:=0;h2:=0;
  FOR B:=1 TO LENGTH(src) DO
    h1:=(h1 SHL B) and byte(src[b]);
  FOR B:=1 TO LENGTH(dest) DO
    h2:=(h2 SHL B) and byte(dest[b]);
  IF h2>h1 THEN
    hash:=h1 XOR h2 
  ELSE
    hash:=h2 XOR h1;  
  MHHash:=hash;
END;  

(*
 *  FindMHEntry sucht in der MHListe einen bestimmten Eintrag.
 *  Input: src : Quell-Call, dest: Destination-Call
 *  Result: Pointer auf MH-Eintrag.
 *  Seiteneffekte: keine
 *)
FUNCTION FindMHEntry(VAR src,dest:STRING):PMHEntry;
VAR b,h	: BYTE;
hash	: Integer;
p	: PMHentry;
s	: string;
BEGIN
{$IFDEF DEBUG}
   str(Mhanz,s);prints(1,1,s,112);
{$ENDIF}
  if pos(' ',dest)>0 THEN dest:=copy(dest,1,pos(' ',dest)-1);
  hash:=MHHash(src,dest);
  IF MHliste[hash]=NIL THEN
    FindMHEntry:=NIL
  ELSE
  BEGIN
    p:=MHliste[hash];
    WHILE (p<>NIL) AND ((src<>p^.src) OR (dest<>p^.dest)) AND
    ((src<>p^.dest) OR (dest<>p^.src)) DO
      p:=p^.next;
    FindMHEntry:=p;
  END;      
END;

FUNCTION InsertMHEntry(VAR src,dst:STRING):PMhentry;
var hash:INTEGER;bhash:BYTE;P,n:PMHentry;
BEGIN
  if pos(' ',dst)>0 THEN dst:=copy(dst,1,pos(' ',dst)-1);
  n:=FindMHEntry(src,dst);
   
  if n=NIL THEN
  BEGIN
    inc(mhanz);
    IF mhanz>100 THEN
       MHGarbageCollection;
    new(n);
{$IFDEF DEBUG}
    prints(1,20,'nil',112);
{$ENDIF}
     fillchar(n^,sizeof(TMHentry),0);
    hash:=MHHash(src,dst);    
    IF MHliste[hash]=NIL THEN
    BEGIN
      MHListe[hash]:=n;
    END ELSE
    BEGIN
      p:=MHListe[hash];
      while (p^.next<>NIL) DO p:=p^.next;
      p^.next:=n;
    END;
  END;
  InsertMHEntry:=n;
 END;

  
       
      {
FUNCTION MHGetEntry(VAR src,dest:STRING):BYTE;
VAR hash,h:BYTE;
BEGIN
  (* hashwert berechnen... geht sicher noch etwas schneller *)
  asm
    mov ax,0
    push ds
    lds si,src
    xor cx,cx
    mov cl,ds:[si]
    inc si
   @schleife
     add al,ds:[si]
     inc si
    loop @schleife
    pop ds
    mov hash,al
    dec al
    mov h,al
  end;
  WHILE mhliste[hash]<>NIL DO   
    inc(hash);
    }

PROCEDURE DumpMoni(header:STRING;var data;len:WORD);
VAR L:LONGINT;
BEGIN
  IF MONI_RPL_AN THEN
  BEGIN
    {$I-}
    Assign(MONI_RPL_FILE,qrvpath+'MCUT.RPL');
    Reset(MONI_RPL_FILE,1);
    IF IORESULT<>0 THEN REWRITE(MONI_RPL_FILE,1);
    IF IORESULt<>0 THEN EXIT;
    SEEK(MONI_RPL_FILE,FileSize(MONI_RPL_FILE));
    BlockWrite(MONI_RPL_FILE,header[0],length(header)+1);
    L:=LEN;
    BlockWrite(MONI_RPL_FILE,L,4);
    IF len>0 THEN
    BEGIN
      BlockWrite(MONI_RPL_FILE,data,len);
    END;
    L:=FileSize(MONI_RPL_FILE);
    CLOSE(MONI_RPL_FILE);
    IF (MONI_RPL_FILE_SIZE>0) AND (L>MONI_RPL_FILE_SIZE) THEN
    BEGIN
       {$IFNDEF LINUX}
      SetMemTop(HeapPtr);
      SWAPVECTORS;
       {$ENDIF}
      EXEC(qrvpath+'MONI_RPL.EXE',qrvpath+'MCUT.RPL');
       {$IFNDEF LINUX}
       SWAPVECTORS;
      SetMemTop(HeapEnd);
      setvmode(EGAVGAFONT);
{$ENDIF}
       RedrawScreen;
      ERASE(MONI_RPL_FILE);
    END;
  END;
END;

{$IFDEF WA8DED}
(***************************************************************************)
(*    String2ByteArr convertiert einen String, der durch beliebige         *)
(*    Seperatoren getrennte Dezimalzahlen enthlt in ein ARRAY oF BYTE.    *)
(*    Wird bentigt, um die antwort des TNC L-Befehls auszuwerten          *)
(***************************************************************************)

PROCEDURE String2ByteArr(var s:string;var arr:ByteArray;var anz:byte);
VAR B,STA:Byte;
BEGIN
 anz:=1;
 STA:=0;
 arr[1]:=0;
 FOR B:=1 to Length(s) DO
 BEGIN
   IF (S[B]>='0') AND (S[B]<='9') THEN
   BEGIN
     IF STA=0 THEN STA:=1;
     arr[anz]:=10*arr[anz];
     INC(arr[anz],BYTE(S[B])-48);
   END ELSE
     IF STA=1 THEN
     BEGIN
       INC(anz);
       arr[anz]:=0;
       STA:=0;
     END;
 END;
 IF STA=0 THEN DEC(ANZ);
END;




(****************************************************************************)
(* PROCEDURE SplitMoniHead                                                  *)
(* Diese Prozedur ist seehr alt (aus 0.32 vermute ich), sie zerlegt einen   *)
(* WA8DED Monitorheader in seine Bestandteile und legt diese in der         *)
(* Globalvariable HEAD vom typ TMoniHead ab (s. IADVAR).                    *)
(****************************************************************************)

PROCEDURE SplitMoniHead(s:STRING);
var
   b,persis:BYTE;
   astr:STRING[3];
   acall,via1:STRING;
   err:integer;
BEGIN
 via1:='';
 with head DO
 BEGIN
  IF s[2]=':' THEN
  BEGIN
    port:=BYTE(s[1])-48;
    s:=copy(s,3,255);
    IF ports=0 THEN ports:=1;
    IF ports<(port+1) THEN ports:=port+1;
  END
  ELSE port:=0;
  FmC:=Copy(s,4,pos(' ',copy(s,4,length(s)-4))-1);
  s:=copy(s,pos('to',copy(s,1,length(s)))+3,length(s));
  ToC:=Copy(s,1,Pos(' ctl',s)-1);
  IF (pos('via',Toc)>0) AND (pos('*',Toc)>0) THEN
  BEGIN
    persis:=pos('via',toc);
    via1:=copy(toc,persis,255);
  END;
  s:=copy(s,Pos(' ctl',s)+5,length(s));
  IF s[1]='I' THEN
  BEGIN
    count:=BYTE(s[3])-48;
    ns:=count;nr:=BYTE(S[2])-48;
    TYP:=Fr_I;
  END;
  IF s[1]='R' THEN
  BEGIN
    IF s[2]='R' THEN
    BEGIN
      count:=BYTE(s[3])-48;
      TYP:=Fr_RR;
    END;
    IF s[4]='+' THEN
    BEGIN
      count:=BYTE(s[3])-48;
      TYP:=Fr_RR;
    END;
    IF s[2]='E' THEN
    BEGIN
      count:=BYTE(s[4])-48;
      TYP:=FR_REJ;
    END;
  END;
  IF copy(s,1,4)='SABM' THEN typ:=Fr_sabm;
  IF copy(s,1,4)='DISC' THEN typ:=Fr_DISC;
  IF copy(s,1,4)='FRMR' THEN typ:=Fr_FRMR;
  IF copy(s,1,2)='UA' THEN typ:=Fr_UA;
  IF copy(s,1,2)='UI' THEN typ:=Fr_UI;
  IF copy(s,1,2)='DM' THEN typ:=Fr_DM;
  IF pos('pid',s)>0 THEN
    VAL('$'+ltrim(copy(s,pos('pid',s)+4,2)),head.pid,err)
  ELSE head.pid:=$f0;
 END;
END;

{$ENDIF}


(***************************************************************************)
(*   Diese Routine legt den derzeitigen Inhalt von HilfStr in zeilenweise  *)
(*   in die Receive-Queue des Kanals C . Der Rest landet in                *)
(*   KS[c]^.ReceiveRest                                                    *)
(***************************************************************************)

PROCEDURE PutRQ(C:BYTE);
VAR B:BYTE;
BEGIN
  IF KS[c]=NIL THEN
    exit;
  HilfStr:=KS[C]^.ReceiveRest;
  FOR B:=1 TO LENGTH(TncData) DO
  BEGIN
    INC(BYTE(HilfStr[0]));
    HilfStr[Length(hilfStr)]:=TncData[b];
    IF (TncData[b]=#10) OR (TncData[b]=#13) OR (Hilfstr[0]=#254) THEN
    BEGIN
      PushQueue(KS[C]^.ReceiveQueue,0,HilfStr);
      KS[c]^.RxW:=KS[c]^.RxW+BYTE(HilfStr[0]);
      HilfStr[0]:=#0;
    END;
  END;
  KS[c]^.ReceiveRest:=HilfStr;
END;

(***************************************************************************)
(*   SendData berschreibt TNC.SendData und erweitert selbige um die SP9   *)
(*   Huffman Kompression. Diese wird durch DG8NDY's COMPUNIT vorgenommen   *)
(* feb 96: erweiterung fr pc/flexnet. Daten werden abhngig von "device"  *)
(*   an die TNC-Unit bergeben oder direkt ans PCF. Der Speicher frs PCF  *)
(*   muss VORHER mit l2_ialloc() reserviert werden, wird nicht von senddata*)
(*   selbst gemacht!!!                                                     *)
(***************************************************************************)

PROCEDURE senddata(c:byte;var s:string);
VAR compsize      : WORD;ein_s:STRING;
BEGIN
  IF KS[c]^.compress=2 Then
  BEGIN
    compsize:=255;
    compsize:=COMPcode(s[1],byte(s[0]), ein_s[1], compsize);
    ein_s[0]:=char(compsize);
    if length(ein_s)>length(s) then
      ein_s:=#255+s ELSE
    INC(KS[c]^.CompTx,Compsize);
    {$IFDEF WA8DED}
    IF device=0 THEN
      tnc.senddata(c,ein_s);
    {$ENDIF}
    {$IFDEF FLEXNET}
    IF device=1 THEN
    BEGIN
      if length(ein_s)>KS[c]^.paclen THEN
        l2_ialloc(KS[c]^.stream,length(ein_s)-KS[c]^.paclen+1);
      l2_send_str(KS[c]^.Stream,ein_s);
      l2_pack(KS[c]^.Stream);
      
    END;
    {$ENDIF}
  END ELSE
  BEGIN
    {$IFDEF WA8DED}
    IF device=0 THEN
      tnc.senddata(c,s);
    {$ENDIF}
    {$IFDEF FLEXNET}
    IF device=1 THEN
    BEGIN
      l2_send_str(KS[c]^.Stream,s);
      l2_pack(KS[c]^.Stream);
    END;
    {$ENDIF}
  END;
  IF (KS[c]^.compress=1) and (pos('//COMP 1',s)>0) THEN
    KS[c]^.compress:=2;
END;


(****************************************************************************)
(* Diese Routine verarbeitet eingehende QSO-Daten. Sie wird von PollTNC und *)
(* DoFlexNet aufgerufen                                                     *)
(* iad, feb 96                                                              *)
(****************************************************************************)

PROCEDURE HandleTncDataQSO(pollchan:BYTE);
VAR compsize:WORD;
BEGIN
  MCUTisIDLE:=FALSE;
  IF KS[pollchan]<>NIL THEN
  BEGIN
    (*
     * erstmal SP9COMP dekodieren...., muss frameweise
     * passieren, deswegen schon hier.
     *)
    KS[PollChan]^.IdleSince:=CurrIxTime;
    compsize:=255;
    IF KS[Pollchan]^.compress>0 THEN
    BEGIN
       compsize:=COMPDecode(TNCDATA[1], byte(tncdata[0]),ein_s[1] , compSize);
       INC(KS[pollchan]^.CompRx,compsize);
       IF CompSize=byte(TNCData[1])+1 THEN
       BEGIN
         KS[pollchan]^.compress:=2;
         ein_S[0]:=char(compsize);
         tncdata:=ein_s;
       END ELSE
         IF TNCData[1]=#255 THEN
          delete(tncdata,1,1);
    END;
    (* Umlautconvertierung: muss in MCUT.CFG mit DEFUML= definiert sein *)
    IF KS[pollchan]^.RXUmlautTable<=UmlautTableAnz THEN
    BEGIN
      FOR c:= 1 TO Length(TncData) DO
        TNCData[c]:=UmlautTable[KS[pollchan]^.RXUmlautTable]^[byte(Tncdata[c])];
    END;
    (* plausicheck: *)
    IF (Pollchan<=MaxTerminal) THEN
    BEGIN
      (* daten auf Terminal schreiben:*)
      IF (KS[pollchan]<>NIL) AND ((KS[pollchan]^.FLAGS AND KS_SHOWDATA)<>0) THEN
      BEGIN
        WriteBuf(PollChan,TncData,fQSORX,1);
        IF OVF THEN WriteBuf(PollChan,ovfchar,fQSORX,2);
      END;
    END;
    (* Daten in RX-Queue pumpen, luft ber Global-Puffer "TNCDATA" *)
    PutRQ(PollChan);
    (* Wenn 256 Bytes empfangen wurden, hat Pascal so ein problem ... *)
    IF OVF THEN
    BEGIN
      TncData:=''+OVFchar;
      PutRQ(pollchan);
    END;
  END;
END;

(****************************************************************************)
(* Diese Routine verarbeitet eingehende Moniotr-Daten. Sie wird von PollTNC *)
(* und DoFlexNet aufgerufen.  Hier wird die Dekodierereien fr SP9-Comp     *)
(* TCPIP und PACSAT verteilt...                                             *)
(* iad, feb 96                                                              *)
(****************************************************************************)

PROCEDURE HandleTncDataMoni;
VAR buf:ARRAY[1..500] OF BYTE;
    compsize,datasize:WORD;
BEGIN
  MCUTisIDLE:=FALSE;
    Move(TncData[1],Buf[1],length(TncData));
    DataSize:=Length(TncData);
    IF OVF THEN
    BEGIN
      Buf[256]:=ord(OVFChar);
      Inc(DataSize);
    END;
    DumpMoni(header,buf,DataSize);
    HandleSpy(head.ns,head.nr,head.fmc,head.toc,buf,DataSize);
   SaveUI(head.fmc,head.toc,tncdata);
  (*
   * Wenn es sich nicht etwa um TCPIP handelt, dann versuchen,
   * evtl geCOMPtes zu entCOMPen, und Binrdaten zu unterdrcken
   *)
  IF (head.pid=$F0) THEN
  BEGIN
    IF (NOT OVF) AND (MoniDecomp) THEN
    BEGIN
      compsize:=255;
      compsize:=COMPDecode(TNCDATA[1], byte(tncdata[0]),ein_s[1] , compSize);
      IF CompSize=byte(TNCData[1])+1 THEN
      BEGIN
        str(100-round(byte(tncdata[0])/compsize*100),hilfstr);
        WriteMoniBuf('>>> Huffman: '+hilfstr+'%'+#13,fMonHead,1);
        ein_S[0]:=char(compsize);
        tncdata:=ein_s;
      END;
    END;

    w:=0;
    for B:=1 to length(tncdata) DO
      IF  (tncdata[b] IN [#32,#13,#10,#7,'a'..'z','A'..'Z','0'..'9',
      '','','','','','','','?','!',',','.']) THEN inc(w);
    str(length(tncdata),ein_s);
    IF NOT MoniBin THEN
      IF (((w/length(tncdata))*100)<70) THEN tncdata:='[BIN '+ein_s+']'+#13;
    WriteMoniBuf(TncData,fmondata,2)
  END
  (*
   * Hier werden IP Header dekodiert...
   *)
  ELSE
  IF (head.pid=$CC) AND (MoniTCPIP) THEN
  BEGIN
    tcpip.dekodeframe(tncdata,l,r);
    WriteMoniBuf(l+#13,fmondata,1);
    WriteMoniBuf(r+#13,fmondata,2);
  END;
  (*
   * Waren die Daten 256 Bytes lang, folgt die Sonderbehandlung
   * fr das 256te Byte... (jaja, das dumme Pascal :-)
   *)
  IF Ovf THEN
  BEGIN
    IF copy(tncdata,1,4)<>'[BIN' THEN
      IF OvfChar=#13 THEN WriteMoniBuf(OvFChar,fmondata,2)
       else  WriteMoniBuf(OvFChar+#13,fmondata,2);
  END ELSE
   IF TncData[length(TncData)]<>#13 THEN
     WriteMoniBuf(#13,fmondata,2);
  { $ENDIF}
END;
CONST StupidPoll:BYTE=1;MoniPOLL:BOOLEAN=TRUE;
      Altchan:BYTE=1;
{$IFDEF WA8DED}
CONST Last_L_Poll:LONGINT=0;
PROCEDURE PollTNC;
VAR  ChannelStr    : STRING[4];
     st:STRING[20];
     ByteArr       : ByteArray;
     ByteElemente  : BYTE;  
BEGIN
   (* Den Status der Verbindung abfragen und im KS[] speichern. Wird
    * in der Statuszeile angezeigt
    *)
      IF (KS[channel]<>NIL) AND ((exacttime-Last_L_Poll>300)) THEN
      BEGIN
        Last_L_Poll:=exacttime;
        ST:=SendCmd(channel,'L');
        String2ByteArr(st,ByteArr,ByteElemente);
        KS[channel]^.Unack:=ByteArr[3]+ByteArr[4];
        KS[channel]^.Tries:=ByteArr[5];
        KS[channel]^.Lstate:=ByteArr[6];
	 DrawStatus1; 
      END;

      (*

       * Im extended Hostmode auf Kanal 255 pollen, da kommt ein ASCIIz
       * zurck, der die Kanalnummern der Kanle, enthlt, bei denen
       * Daten vorliegen. Und zwar um 1 erhht, wegen der zero-termination
       *)
      IF xHost THEN
      BEGIN
        TncData:=SendCmd(255,'G');
        If length(tncdata)=1 THEN
          Pollchan:=PRED(Byte(TncData[1]));
        IF length(tncdata)>1 THEN
          IF Pollchan=PRED(BYTE(TncData[1])) THEN
            PollChan:=PRED(BYTE(TncData[2])) ELSE
            PollChan:=PRED(BYTE(TncData[1]));
        IF Length(TncData)=0 THEN pollchan:=0;
      END ELSE
      BEGIN
        (*
         * Ohne extended Hostmode einfach die Kanle der Reihe nach
         * durchgehen (ghn)
         *)
       IF MONIPOLL THEN 
       BEGIN
         POLLCHAN:=0;
         MONIPOLL:=FALSE;
       END ELSE 
       BEGIN
          MONIPOLL:=TRUE;  
          IF RANDOM(5)<3 THEN
          BEGIN
             (*StupidPoll:=PollChan;*)
             PollChan:=AltChan;
             REPEAT
               inc(altchan);
               if altchan>tncchan then altchan:=1;
             UNTIL (POLLCHAN=Altchan) OR (KS[altchan]<>NIL);
              PollChan:=AltChan;
          END ELSE 
          BEGIN
            INC(StupidPoll);
            IF StupidPoll>TNCChan Then StupidPoll:=1; 
            PollChan:=StupidPoll;
          END;    
       END;
      END;

      { * Die Daten abholen:}
      TncData:=sendcmd(PollChan,'G ');
      Str(Pollchan,Channelstr);
      CASE Result OF
         0: BEGIN END; {Es liegt nichts vor}
         1,2, {sollte hier nicht auftauchen}
         3:BEGIN     {Es liegt eine Statusmeldung vor}
               (*
                * Erstmal als Pop-Up Fenster ausgeben
                *)
               PopUp(TncData);
               IF PollChan>0 THEN
                 WRiteBuf(PollChan,#13+tncData+#13,fqsotx,1)
               ELSE
                 WriteMoniBuf(#13+TncData+#13,fqsotx,1);
               IF copy(TncData,1,11)=copy('CONNECT REQUE',1,11) THEN
                 Write(#7) ELSE
               IF Copy(TncData,1,14)=copy('('+Channelstr+') CONNECTED ',1,14) THEN
                 MCUTLIB2.HandleConnect(pollchan,TncData) ELSE
               IF Copy(TncData,1,9)=copy('('+Channelstr+') DISCO',1,9) THEN
                 MCUTLIB2.HandleDiscon(pollchan,TncData) else
               IF Copy(TncData,1,11)=copy('('+Channelstr+') LINK FA',1,11) THEN
                 MCUTLIB2.HandleDiscon(pollchan,TncData) else
               IF Copy(TncData,1,9)=copy('('+Channelstr+') BUSY ',1,9) THEN
                 MCUTLIB2.HandleDiscon(pollchan,TncData) else
               IF Copy(TncData,1,11)='('+Channelstr+') LINK R' THEN
                 Write(#7) else
               IF Copy(TncData,1,10)='('+Channelstr+') FRAME' THEN
                 Write(#7);
              END;
        4,5:BEGIN     {ein Monitor Header}
              Header:=TNCData;
              SplitMoniHead(TncData);
              WriteMoniBuf(TncData+#13,fmonhead,1);
            END;
          6:BEGIN     {Monitor Daten}
              HandleTncDataMoni;
             END;
           7:HandleTncDataQSO(pollchan);  {QSO Daten}
    END; {CASE Result}
END;
{$ENDIF}

(* Setmonitor aktiviert den Monitor, unabhaengig ob FlexNet oder
 * Hostmode
 *)
PROCEDURE SetMonitor;
VAR
  {$IFDEF FLEXNET}
     T:pTrace;
  {$ENDIF}
  b:BYTE;
  S:STRING[10];
BEGIN
  {$IFDEF WA8DED}
  IF (device=0) THEN
  BEGIN
    S:='MC';
    IF (monitor_typ AND MON_i)<>0 THEN
      S:=S+'I';
    IF (monitor_typ AND MON_ui)<>0 THEN
      S:=S+'U';
    IF (monitor_typ AND MON_ctl)<>0 THEN
      S:=S+'S';
    IF monitor_chans=0 THEN S:='MN';
    SendCmd(0,S);
  END;
  {$ENDIF}
  {$IFDEF FLEXNET}
  IF (device=1) THEN
  BEGIN
    New(t);
    fillchar(t^,SizeOf(tTrace),0);
    IF (monitor_typ and mon_ctl)=0 THEN
      t^.typfilter:=t^.typfilter OR TRACETYP_NO_S;
    t^.trxfilter:=3;
    t^.ch_mask:=monitor_chans;
    if monitor_chans=0 THEN t^.trxfilter:=0;
    l2_set_monitor(T);
    dispose(t);
  END;
  {$ENDIF}
END;





{$IFDEF FLEXNET}
(* Einen Pascal-String in das FlexNet-Format umwandeln
 *)

PROCEDURE MkFlexCall(SCall:STRING10;VAR FCall:tFlxCall);
VAR B,SSID:BYTE;Err:INTEGER;
LABEL X,Y;
BEGIN
  SSID:=0;
  Fillchar(FCall,SizeOf(TFlxCall),0);
  FOR B:=1 TO Length(Scall) DO
  BEGIN
    IF Scall[B]='-' THEN GOTO X;
    FCall[b-1]:=Scall[b];
  END;
  GOTO Y;
 X:
  VAL(Copy(SCall,B+1,255),SSID,ERR);
 Y:
  FCall[6]:=Char(SSID+ord('0'));
END;

(* Ist eigentlich Teil von FLXAPP, war dort aber fehlerhaft, deswegen
 * hier neu implementiert
 *)

FUNCTION l2_pconnect(Source,Destination:STRING):WORD;
BEGIN
  Addchar(Source,#0);
  AddChar(Destination,#0);
  l2_pconnect:=l2_connect(PCHAR(@Source[1]),Pchar(@Destination[1]));
END;


(* Auch ein FlexApp-Ersatz, wandelt ein FlexCall in einen String.
 * Tnx to DG9EP
 *)

FUNCTION MkCallStr (FCall:tFlxCall):String;
{* Quick & dirty - aber was soll ein 586 unter DOS sonst machen... *}
  VAR s,s2 : STRING[9];
      i : WORD;
  LABEL x;
BEGIN
 s := '';
 FOR i := 0 TO 5 DO
   IF FCall[i]<=' ' THEN goto x
                    ELSE s:=s+FCall[i];

x:
 IF FCall[6] > '0' THEN
   BEGIN
   Str( Ord(Fcall[6])-48, s2);
   s := s + '-' + s2;
   END;
 MkCallStr := s;
END;

CONST _call:STRING='';
      lastcalltime:LONGINT=0;
      lastcall:BYTE=1;
      ch_call:BOOLEAN=FALSE;

(* Hier findet die ganze FlexNetterei statt.
 * Monitor-Daten abholen
 * QSO-Daten abholen
 * QSO-Status abfragen
 * Eingehende Connects auswerten
 *)
   
PROCEDURE DoFlexNet;
VAR B,b2    : BYTE;daten:pInfo;
    Frame   : pFrame;
    HeadStr : STRING;tmp1,tmp2,tmp3:STRING[10];
    qsonum  : WORD;
    T	    : pTrace;acall:tFlxCall;
   call	    : pFlxCall;
   _unack,_tries,_state:BYTE;
LABEL ende;
BEGIN
   call:=@acall;
   (* FlxNet-States in Hostmode-States umwandeln...
    *)
   IF (KS[channel]<>NIL) AND (KS[channel]^.stream<>0) THEN
   WITH KS[channel]^ DO
   BEGIN
      _unack:=Unack;_tries:=Tries;_state:=lstate;
     Unack:=l2_unack(ks[channel]^.stream);
     Tries:=l2_tries(KS[channel]^.stream);
     b:=l2_state(stream);
     b2:=b AND $F8;
     b:=b AND $7;
     CASE b OF
        0:Lstate:=0;
        1:Lstate:=0;
        2:Lstate:=1;
        3:Lstate:=2;
        4:lstate:=3;
        5:lstate:=4;
        6:lstate:=5;
        7:lstate:=6;
     END;
     IF (B2 AND 8)<>0 THEN
     BEGIN
       IF lstate=4 THEN
         lstate:=7 ELSE
       IF lstate=6 THEN
         lstate:=10 ELSE
       IF lstate=5 THEN
         lstate:=13;
     END;
     IF (B2 AND 16) <> 0 THEN
     BEGIN
       IF lstate=4 THEN
         lstate:=8 ELSE
       IF lstate=6 THEN
         lstate:=11 ELSE
       IF lstate=7 THEN
         lstate:=9 ELSE
       IF lstate=10 THEN
         lstate:=12 ELSE
       IF lstate=5 THEN
         lstate:=14 ELSE
       IF lstate=13 THEN
         lstate:=15;
     END;
     if (unack<>_unack) or (tries<>_tries) or (lstate<>_state) THEN
       IF consolestate=CONS_TERM THEN DrawStatus1; 
   END;

  (* hier wird geprft, ob angestossene connects erfolg hatten..
  *)

  OVF:=FALSE;
  FOR B:=1 TO 255 DO
    IF (KS[b]<>NIL) AND (KS[b]^.LOOP=0) AND ((KS[b]^.FLAGS AND KS_CRONTASK)=0) THEN
    BEGIN
      CASE l2_state(KS[b]^.Stream) OF
         0:IF (KS[b]^.Stream<>0) THEN
           BEGIN
             Str(b,tmp1);
             TncData:='0:('+tmp1+') FAILURE WITH ?????';
             PopUp(tncdata);
             HandleDiscon(b,TncData);
             WriteBuf(b,#13+TncData+#13,fQSOtx,1);
             MCUTisIDLE:=FALSE;
             exit;
           END;
         1:IF  (KS[b]^.Stream<>0) THEN
           BEGIN
             Str(b,tmp1);
             Frame:=l2_get_f(KS[b]^.Stream);
             IF (KS[b]^.LinkState=0) THEN
               TncData:='0:'+tmp1+'BUSY fm '+MkCallStr(frame^.dest)
             ELSE
             BEGIN
               TncData:='0:('+tmp1+') DISCONNECTED fm '+mkCallStr(Frame^.dest);
             END;
             HandleDiscon(b,TncData);
             PopUp(tncdata);
             WriteBuf(b,#13+TncData+#13,fqsotx,1);
             MCUTisIDLE:=FALSE;
             exit;
           END;
        5..255:
           IF (KS[b]^.LinkState=0) AND (KS[b]^.Stream<>0)  THEN
           BEGIN
             Frame:=l2_get_f(KS[b]^.Stream);
             str(Frame^.Kanal,tmp1);
             str(b,tmp2);
             KS[b]^.LinkState:=1;
             tncdata:=tmp1+':('+tmp2+') CONNECTED to '+mkCallStr(Frame^.dest);
             handleConnect(b,tncdata);
             WriteBuf(b,#13+TncData+#13,fqsotx,1);
             MCUTisIDLE:=FALSE;
             exit;
           END;
      END;
    END;
  (* erst wird geguckt, ob auf einer verbindung, die besteht,
   * daten eingegangen sind
   *)
  B:=POLLCHAN;
  REPEAT
    INC(PollChan);
    IF KS[PollChan]<>NIL THEN
    BEGIN
      IF (KS[PollChan]^.Stream>0) AND (KS[PollChan]^.LinkState>0) THEN
      BEGIN
        daten:=l2_get_i(KS[PollChan]^.Stream);
        IF daten<>NIL THEN
        BEGIN
          IF daten^.length=256 THEN
          BEGIN
            OVFCHAR:=daten^.text[256];
            OVF:=TRUE;
            MOVE(daten^.text,TncData[1],255);
            TncData[0]:=#255;
          END ELSE
          BEGIN
            OVF:=FALSE;
            TncData[0]:=Char(daten^.Length);
            MOVE(daten^.text,TncData[1],Daten^.length);
          END;
          l2_i_ack(KS[PollChan]^.Stream);
          HandleTncDataQSO(PollChan);
          MCUTisIDLE:=FALSE;
          exit;
        END;
      END;
    END;
  UNTIL  (B=PollChan);
  (* dann wird der Monitor ausgewertet...
   *)
  IF monitor_chans>0 THEN
  BEGIN
    IF not l2_chk_monitor THEN
    BEGIN
      SetMonitor;
    END;
    Frame:=l2_get_monitor;
    IF Frame<>NIL THEN
    WITH Frame^ DO
    BEGIN
      (* einen Header Aehnlich WA8DED generieren *)
      MCUTisIDLE:=FALSE;
      Head.fmc:=MkCallStr(Source);
      head.ToC:=MkCallStr(Dest);
      head.ns:=ns;
      head.nr:=nr;
      IF Digis>0 THEN head.toc:=head.toc+' via';
      FOR B:=1 TO Digis DO
      BEGIN
        head.toc:=head.toc+' '+MkCallStr(Digi[b]);
        IF b=nextdigi THEN
          head.toc:=head.toc+'*';
      END;
      STR(kanal,tmp1);
      head.typ:=typ;
      IF tx=0 THEN tmp1:='R'+tmp1 ELSE tmp1:='T'+tmp1;
      str(txdelay,tmp2);
       head.txd:=txdelay;
      head.len:=textlen;
      tmp3:=tmp1+'('+tmp2+'):';
      HeadStr:='fm '+head.FmC+' to '+head.toc+' ctl';
      CASE typ OF
        Fr_I    :BEGIN
                   str(nr,tmp1);str(ns,tmp2);
                   HeadStr:=HeadStr+' I'+tmp1+tmp2;
                   head.ns:=ns;
                 END;
        Fr_RR   :BEGIN
                   str(nr,tmp1);;
                   HeadStr:=HeadStr+' RR'+tmp1;
                 END;
        Fr_RNR  :BEGIN
                   str(nr,tmp1);;
                   HeadStr:=HeadStr+' RNR'+tmp1;
                 END;
        Fr_REJ  : BEGIN
                    str(nr,tmp1);;
                    HeadStr:=HeadStr+' REJ'+tmp1;
                  END;
        Fr_SABM : BEGIN
                    HeadStr:=HeadStr+' SABM';
                  END;
        Fr_DISC : HeadStr:=HeadStr+' DISC';
        Fr_DM   : HeadStr:=HeadStr+' DM';
        Fr_UA   : HeadStr:=HeadStr+' UA';
        Fr_FRMR : HeadStr:=HeadStr+' FRMR';
        Fr_UI   : HeadStr:=HeadStr+' UI';
      END;
      IF Frame^.axv2 THEN
      BEGIN
        IF (frame^.pf) and (frame^.cmd) THEN
          HeadStr:=headStr+'+' ELSE
        IF (frame^.pf) and (not frame^.cmd) THEN
          HeadStr:=headStr+'-' ELSE
        IF (NOT frame^.pf) and (NOT frame^.cmd) THEN
          HeadStr:=headStr+'v' ELSE
        IF (NOT frame^.pf) and (frame^.cmd) THEN
          HeadStr:=headStr+'^';
      END;
      IF (typ=Fr_i) OR (typ=fr_ui) THEN
        HeadStr:=HeadStr+' pid '+xhex(pid);
      IF frame^.dama=1 THEN
        headStr:=headstr+' [DAMA]';
      Header:=HeadSTr;
      HeadStr:=tmp3+HeadStr;
      IF Frame^.QsoNum>0 THEN
      BEGIN
        str(qsonum,tmp1);
        HeadStr:=HeadStr+' ('+tmp1;
        IF Partner_Num>0 THEN
        BEGIN
          str(partner_num,tmp1);
          HeadStr:=HeadStr+'/'+tmp1;
        END;
        INC(HeadStr[0]);
        HeadStr[Length(headStr)]:=')';
      END;
      head.pid:=pid;
      head.port:=kanal;
      {$IFDEF Mx}
      WriteMoniBuf(tmp3+':',fmonhead,1);
      {$ELSE}
      WriteMoniBuf(headstr+#13,fmonhead,1);
      {$ENDIF}
      OVF:=False;
      IF typ IN [fr_i,Fr_ui,fr_frmr] THEN
      BEGIN
        IF textlen=256 THEN
        BEGIN
          OVFCHAR:=text^[255];
          OVF:=TRUE;
          MOVE(text^,TncData[1],255);
          TncData[0]:=#255;
        END ELSE
        IF (textlen<256) AND (textlen>0) THEN
        BEGIN
          TncData[0]:=Char(textlen);
          MOVE(text^,TncData[1],textlen);
        END ELSE
          TncData:='[Frame too long]';
        HandleTncDataMoni;
      END
       ELSE
       BEGIN
         HandleSpy(head.ns,head.nr,head.fmc,head.toc,tncdata,0);
         DumpMoni(header,tncdata,0);
       END;  
      l2_ack_monitor;
      exit;
    END;
  END;
  (* dann wird geschaut, ob connects eingetroffen sind
   *)
    IF lastcall=1 THEN _call:=mycall
      {$IFDEF BOX}
      ELSE if lastcall=2 THEN _call:=boxcall
      {$ENDIF}
      {$IFDEF CONVERS}
      ELSE IF lastcall=3 THEN _call:=convcall
      {$ENDIF}
      ;
  MkFlexCall(_call,acall);
  tmp1:=_call;inc(tmp1[0]);
  tmp1[length(tmp1)]:=#0;
(*  qsonum:=l2_get_sabm(pchar(@tmp1[1])); *)
  qsonum:=l2_pget_sabm(_call);
  str(qsonum,tmp2);
(*  prints(1,1,tmp1+' '+tmp2+'  ',112);  *)
  IF QSOnum>0 THEN
  BEGIN
    MCUTisIDLE:=FALSE;
    if lastcall=1 THEN
      B:=1 ELSE b:=succ(maxterminal);
    if lastcall=1 THEN BEGIN
      REPEAT
       inc(b);
      UNTIL (KS[b]=NIL) OR (b=maxTerminal);
    END ELSE
    BEGIN
      REPEAT
       dec(b);
      UNTIL (KS[b]=NIL) OR (b=1);
    END;
    IF KS[b]=NIL THEN
    BEGIN
      Frame:=l2_get_f(qsonum);
      if mycall<>MkCallStr(Frame^.Source) THEN exit;
      (*
       * Wenn das Call in der BudList steht, dann "totstellen"
       *)
      if (POS(MkCallStr(Frame^.Dest)+' ',BudList)>0) OR
         (POS(CutSSID(MkCallStr(Frame^.Dest))+' ',BudList)>0) OR
         (POS(MkCallStr(Frame^.Dest)+'-0 ',BudList)>0)  THEN
      BEGIN
        goto ende;
      END;
      (*
       * Wenn das Call in der LinkListe steht, schicken wir ein
       * DM, fr den FlexNet Linktest...
       *)
      if (POS(MkCallStr(Frame^.Dest)+' ',LinkList)>0) OR
         (POS(CutSSID(MkCallStr(Frame^.Dest))+' ',LinkList)>0) OR
         (POS(MkCallStr(Frame^.Dest)+'-0 ',LinkList)>0)  THEN
      BEGIN
        l2_sabm_dm(qsonum);
        goto ende;
      END;
      str(Frame^.Kanal,tmp1);
      str(b,tmp2);
      Mcall[b]^:=_call;
      tncdata:=tmp1+':('+tmp2+') CONNECTED to '+mkCallStr(Frame^.dest);
      handleConnect(b,tncdata);
      IF KS[b]=NIL THEN
      BEGIN
        Write(#7);
        l2_sabm_dm(qsonum);
        goto ende;
      END;
      WriteBuf(b,#13+TncData+#13,fqsotx,1);
      KS[b]^.LinkState:=1;
      KS[b]^.Stream:=qsonum;
      l2_sabmresp(qsonum);
      goto ende;
    END ELSE
    BEGIN
      Write(#7);
      l2_sabm_dm(qsonum);
    END;
  END;
ende:
  inc(lastcall);
  {$IFNDEF BOX} if lastcall=2 then inc(lastcall); {$ENDIF}
  {$IFNDEF CONVERS} if lastcall=3 then lastcall:=1; {$ENDIF}
  if lastcall=4 then lastcall:=1;
END;
{$ENDIF}

PROCEDURE DoSendChannels(B:BYTE);
VAR typ:BYTE;
   
    Numread       : {$IFDEF FPK} LONGINT {$ELSE} INTEGER {$ENDIF};
    SendeBereit   : BOOLEAN;
    FERTIG        : BOOLEAN;
    ByteArr       : ByteArray;
    ByteElemente,by  : BYTE;
    SR:SEARCHREC;
BEGIN
  IF (KS[B]^.SendMode>0) or (KS[B]^.SendQueue<>NIL) or
     (KS[b]^.SendRest[0]>#0) THEN
  BEGIN
    MCUTisIDLE:=FALSE;
    KS[B]^.IdleSince:=CurrIxTime;
    IF (((KS[b]^.FLAGS AND KS_CRONTASK)=0) AND (KS[b]^.loop=0)) THEN
    BEGIN
      IF Device=0 THEN
      BEGIN
        {$IFDEF WA8DED}
        TncData:=SendCmd(B,'L');
        String2ByteArr(TncData,ByteArr,ByteElemente);
        SendeBereit:=((byteARR[3]<KS[b]^.maxframe) AND
                     (ByteArr[6] IN [1..6,11,14])
                     (* fr TFEMU: *)
                     AND (BYTEarr[4]<KS[b]^.MaxFrame));
        {$ENDIF}
      END ELSE
      IF Device=1 THEN
      BEGIN
        {$IFDEF FLEXNET}
        SendeBereit:=(l2_unack(KS[b]^.Stream)<KS[b]^.MaxFrame) AND
                     (* ((l2_state(KS[b]^.Stream) AND $10) = 0) AND *)
                     l2_ialloc(KS[b]^.Stream,KS[b]^.paclen+1);
        {$ENDIF}
      END;
    END;
    {NotSend < MaxFrame ??}
    IF SendeBereit OR (KS[b]^.LOOP>0)
       OR ((KS[b]^.FLAGS AND KS_CRONTask)<>0) THEN
    BEGIN
      FERTIG:=TRUE; {Es wurden Daten ausgegeben}
      CASE KS[B]^.SendMode OF
        0:BEGIN
            IF KS[b]^.SendQueue<>NIL THEN
            BEGIN
              PopQueue(KS[B]^.SendQueue,Typ,TncData);
              KS[b]^.TxW:=KS[b]^.TxW-BYTE(TncData[0]);
	       IF KS[b]^.txw<0 THEN KS[b]^.txw:=0;
            END
            ELSE
            BEGIN
              TncData:=KS[b]^.SendRest;
              KS[b]^.Sendrest:='';
              Typ:=0;
            END;
            CASE Typ OF
               0:BEGIN
                   IF KS[b]^.TXUmlautTable<=UmlautTableAnz THEN
                   BEGIN
                     FOR c:= 1 TO Length(TncData) DO
                       TNCData[c]:=UmlautTable[KS[b]^.TXUmlautTable]^[byte(Tncdata[c])];
                   END;
                   IF KS[b]^.LOOP>0 THEN
                   BEGIN
                     IF KS[b]^.RXUmlautTable<=UmlautTableAnz THEN
                     BEGIN
                       FOR c:= 1 TO Length(TncData) DO
                         TNCData[c]:=UmlautTable[KS[b]^.RXUmlautTable]^[byte(Tncdata[c])];
                     END;
                     IF (B>maxTerminal) AND ((KS[b]^.FLAGS AND KS_SHOWDATA)<>0) THEN
                        WriteBuf(KS[b]^.LOOP,TNCdata,fqsorx,2);
                     PutRQ(KS[b]^.LOOP);
                     KS[KS[b]^.LOOP]^.ReceiveRest:=HilfStr;
                   END ELSE
                   IF (KS[b]^.FLAGS AND KS_CRONTASK)=0 THEN
                     SendData(b,TncData);
                   KBytes_TX:=KBytes_TX+Byte(TncData[0]);
                   KS[b]^.TxBy:=KS[b]^.TxBy+(BYTE(TncData[0]));
                   IF (B<=MaxTerminal) AND termecho THEN
                     WriteBuf(b,TncData,fqsotx,1);
                 END;
               1:BEGIN
                   Assign(KS[B]^.SendFile,TncData);
                   {$I-}
                   Reset(KS[B]^.SendFile,1);
                   IF IOResult=0 THEN
                   BEGIN
                     FindFirst(tncdata,anyfile,sr);
                     KS[b]^.expected:=sr.size;
                     KS[b]^.transferred:=0;
                     KS[b]^.transferstart:=currixtime;
                     KS[B]^.SendMode:=1;
                     IF find(TncData,PATH_SEP,L,R) THEN
                       KS[B]^.FileName:=R
                     ELSE
                       KS[B]^.FileName:=TNCData;
                   END;
                   {$I+}
                 END;
               2:BEGIN
                   Assign(KS[B]^.SendFile,TncData);
                   {$I-}
		  
                   Reset(KS[B]^.SendFile,1);
                   IF IOResult=0 THEN
                   BEGIN
                     FindFirst(tncdata,anyfile,sr);
                     KS[b]^.expected:=sr.size;
                     KS[b]^.transferred:=0;
                     KS[b]^.transferstart:=currixtime;
                     KS[B]^.SendMode:=2;
                     IF find(TncData,PATH_SEP,L,R) THEN
                       KS[B]^.FileName:=R
                     ELSE
                       KS[B]^.FileName:=TNCData;
		   END ELSE
		   BEGIN
		      PopUp('I/O-Error');
		      IF KS[b]^.status=16 THEN
			 KS[b]^.status:=KS[b]^.laststatus;
		   END;   
                   {$I+}
                 END;
            END;
          END;
        1:BEGIN   {Text Datei ausgeben}
            {$I-}
            Blockread(KS[B]^.SendFile,TncData[1],KS[B]^.Paclen,numread);
            IF inoutres<>0 THEN
            BEGIN
              str(ioresult,tncdata);
              PutData(b,'I/O-Error '+TNCData+#13);
              Close(KS[B]^.SendFile);
              inoutres:=0;
              KS[B]^.SendMode:=0;
              EXIT;
            END;
            TncData[0]:=char(numread);
            {LF's und ^Z ausfiltern:}
            (* iad, apr 97: jetzt werden auch unix-files korrekt ausgegeben.. *)
            by:=POS(''+#10,TNCDATA);
            WHILE by>0 DO 
	    BEGIN
	      {$IFNDEF linux} 
              IF TNCData[by-1]=#13 THEN
                Delete(TncData,Pos(''+#10,TncData),1)
	      ELSE
{$ENDIF}
		 TNCdata[by]:=#13;
              by:=POS(''+#10,TNCDATA);
            END;
            WHILE Pos(''+#26,TncData)>0 DO Delete(TncData,Pos(''+#26,TncData),1);
            INC(KS[b]^.transferred,byte(tncdata[0]));
            KBytes_TX:=KBytes_TX+Byte(TncData[0]);
            KS[b]^.TxBy:=KS[b]^.TxBy+(BYTE(TncData[0]));
            IF KS[b]^.LOOP>0 THEN
            BEGIN
              IF (B>maxTerminal) AND ((KS[b]^.FLAGS AND KS_SHOWDATA)<>0)  THEN
                 WriteBuf(KS[b]^.LOOP,TNCdata,fqsorx,2);
              PutRQ(KS[b]^.LOOP);
            END ELSE
            IF (KS[b]^.FLAGS AND KS_CRONTASK)=0 THEN
              SendData(b,TncData);
            IF (b<=MaxTerminal) AND termecho THEN
              WriteBuf(b,TncData,fqsotx,1);
            IF Numread<KS[B]^.Paclen THEN
            BEGIN
              Close(KS[B]^.SendFile);
              KS[B]^.SendMode:=0;
            END;
          END;
        2:BEGIN   {Binr Datei Ausgeben}
            Blockread(KS[B]^.SendFile,TncData[1],KS[B]^.Paclen,numread);
            IF inoutres<>0 THEN
            BEGIN
              str(ioresult,tncdata);
              PutData(b,'I/O-Error '+TNCData+#13);
              Close(KS[B]^.SendFile);
              inoutres:=0;
              KS[B]^.SendMode:=0;
              EXIT;
            END;

            TncData[0]:=char(numread);
            INC(KS[b]^.transferred,numread);
            KBytes_TX:=KBytes_TX+Byte(TncData[0]);
            KS[b]^.TxBy:=KS[b]^.TxBy+(BYTE(TncData[0]));
            IF KS[b]^.status=16 THEN
            IF KS[b]^.LOOP>0 THEN
            BEGIN
              PutRQ(KS[b]^.LOOP);
            END ELSE
            IF (KS[b]^.FLAGS AND KS_CRONTASK)=0 THEN
              SendData(b,TncData);
            IF Numread<KS[B]^.Paclen THEN
            BEGIN
              Close(KS[B]^.SendFile);
              KS[B]^.SendMode:=0;
              IF KS[b]^.status=16 THEN
              BEGIN
                BinResults(B,KS[b]^.AutoBinData^.crc,KS[b]^.AutoBinData^.crc);
                KS[b]^.Status:=KS[b]^.LastStatus;
                DISPOSE(KS[b]^.AutoBinData);
                KS[b]^.AUtoBinData:=NIL;
              END;
            END;

          END;
         (*
          * An dieser Stelle wurden die Sendmodes 3-4 entfernt, da
          * diese doch nicht benutzt werden. Evtl knnte man hier
          * aber das YAPPsend fr F6FBB S&F reinschmeissen.
          *)
      END; {CASE KS[B]^.sendmode OF}
       DrawStatus2;
    END; {IF ByteArr ...}
  END ELSE   {IF KS[B]^.sendmode>0 OR queue<>NIL}
    IF (KS[b]^.FLAGS AND KS_DISCREQ)<>0 THEN
    BEGIN
      IF KS[b]^.LOOP>0 THEN
      BEGIN
        DiscLoop(b);
      END ELSE
      BEGIN
        {$IFDEF WA8DED}
        IF device=0 THEN
          sendcmd(b,'D');
        {$ENDIF}
        {$IFDEF FLEXNET}
        IF device=1 THEN
          l2_stop_qso(KS[b]^.stream);
        {$ENDIF}
        KS[b]^.FLAGS:=KS[b]^.FLAGS AND NOT KS_DiscReq;
     END;
    END;
END;
PROCEDURE SendUnproto(VAR src,dst,data:STRING);
VAR B:BYTE;
BEGIN
  {$IFDEF WA8DED}
  IF device=0 THEN
  BEGIN
    sendcmd(0,'I '+src);
    sendcmd(0,'C '+dst);
     tnc.senddata(0,data);
    sendcmd(0,'I'+mycall);
    for b:=1 to TNCChan DO sendcmd(b,'I'+mcall[b]^);
  END;
  {$ENDIF}
  {$IFDEF FLEXNET}
  IF device=1 THEN
  BEGIN
    l2_psend_ui(src,dst,$f0,0,data);
  END;
  {$ENDIF}
END;      
BEGIN
  fillchar(mhliste,256*SizeOf(pointer),0);
  {$IFDEF BB}
  fillchar(bbarr,101*SizeOf(BBEntry),0);
{$ENDIF}
END.



















