(****************************************************************************)
(*    MCUT - Mailbox, Convers and Terminal for Amateur Packet-Radio         *)
(*    Copyright (C) 1993-1997                                               *)
(*              Hans-Peter Zorn (DG4IAD), Mannheim                          *)
(*              Jochen Sarrazin (DG6VJ), Mnster                            *)
(*                                                                          *)
(*    Credits to:                                                           *)
(*                                                                          *)
(*    MCUTs Online Help (ONLHELP.PAS)                                       *)
(*    Copyright (C) 1995 Johann Hanne, DG4MMI                               *)
(*    MCUTs Directory Browser (DMCUT.PAS)                                   *)
(*    Copyright (C) 1996 Rainer Walsdorf, DG2FEV                            *)
(*    CRC and STRING-Handling (WGTCRC.PAS, MYSTRING.PAS)                    *)
(*    Copyright (C) 1995 Gerd Mitlaender, DG8NDY                            *)
(*    (Gerd donated the code to the free software community)                *)
(*    Huffman Compression (COMPUNIT.PAS)                                    *)
(*    Copyright (C) Sigi Kluger, DK4NB and Gerd Mitlaender, DG8NDY          *)
(*    (above code is freeware)                                              *)
(*    DX-Cluster support taken from                                         *)
(*    TOP 1.52 Copyright (C) DF8MT,DL1BHO (some code in MCUTTERM.PAS)       *)
(*    (TOP is ALAS-licenced, which is very similar to the GPL)              *)
(*    QTH-Computation in DX-Cluster-Support                                 *)
(*    from QTHBER.PAS by Gerd-Michael Ritter, DL5FBD                        *)
(*    (QTHBER is donated to the public domain)                              *)
(*    Unixtime-Computation (TOOLBOX.PAS)                                    *)
(*    from DigiPoint (DPBox) Copyright (C) Joachim Schurig, DL8HBS          *)
(*    some code is taken from the SWAG (public domain) and other            *)
(*    public domain resources.                                              *)
(*                                                                          *)
(*    This program is free software; you can redistribute it and/or modify  *)
(*    it under the terms of the GNU General Public License as published by  *)
(*    the Free Software Foundation; either version 2 of the License, or     *)
(*    (at your option) any later version.                                   *)
(*                                                                          *)
(*    This program is distributed in the hope that it will be useful,       *)
(*    but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*    GNU General Public License for more details.                          *)
(*                                                                          *)
(*    You should have received a copy of the GNU General Public License     *)
(*    along with this program; if not, write to the Free Software           *)
(*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             *)
(****************************************************************************)

PROGRAM MCUT;
{$D+,L+,G+}
{$M 30384,0,655360}

(*************************************************************************)
(* an dieser Stelle werden ein paar DEFINES abgefragt, um Fehler zu      *)
(* vermeiden. (iad, dez 95)                                              *)
(*************************************************************************)

{$IFDEF CONVNETZ}

  {$IFNDEF CONVERS}
    {$DEFINE CONVERS}
  {$ENDIF}

{$ENDIF}


(***************************************************************************)
(*                  fuer die Hauptschleife bentigte Units                  *)
(***************************************************************************)

USES
{$IFDEF OVR}
     (*
      * Initialisierung des Overlay-Managers von TP, ausserdem
      * check ob 286 vorhanden ist.
      *)
     MCUTovr,
{$ENDIF}
{$IFDEF LINUX}
Linux,
{$ENDIF}
     (*
      * Die naechsten zwei Unit enthalten ein buntes Mischmasch
      * von allerlei wichtigen Dingen, stammen aus der Zeit, als
      * ich noch nicht strukturiert programmiert habe.
      *)
     MCUTlib,
     MCUTlib2,
     (*
      * Hier sind die //-Befehle drin!
      *)
     MCUTREM,
     (*
      * Toolbox enthlt allgemein ntzliche Routinen (auch fuer andere
      * Programme, ist nicht auf MCUT angewiesen)
      *)
     Toolbox,
     (*
      * Die Verwaltung von USRDAT.MCT fr das Terminal
      *)
     termUser,
     (*
      * Hier sind alle ganzganz wichtigen globalen Variablen fuer das
      * ganze Programm drin.
      *)
     IADVAR,
     (*
      * Hm, keine ahnung was das ist ;-)
      *)
     CRT,
     (*
      * Jochens superschnelle Video-Ausgabe.
      *)
     video,
     {$IFDEF WA8DED}
     (*
      * Wegen v24Close
      *)
     V24DRV,
     {$ENDIF}
     {$IFDEF BOX}
       (*
        * Dreh und Angelpunkt der Mailbox, von dort wird in den
        * Rest der BOX verzweigt.
        *)
       BoxMain,
       (*
        * Ein paar von Jochens Routinen sind auch fuers Terminal
        * ganz nuetzlich...
        *)
       BoxUtil,
     {$ENDIF}
       (*
        * Diverse Dinge des Terminals, die nicht so schnell sein
        * mssen (overlay)
        *)
       Term_o,
       (*
        * Routinen fr Dialogboxen
        *)
       Input,
       (*
        * Routinen frs Terminal, die schnell sein mssen,
        * z.b. HandleKey;
        *)
       MCUTTerm,
       (*
        * Hier wird die Confifuration eingelesen und gespeichert.
        *)
       quickset,
       (*
        * Hier sind alle Bildschirmausgaben (ausser Dialogboxen)
        * drin
        *)
       SCREEN,
       (*
        * no comment
        *)
       DOS,
       (*
        * Gerd, DG8NDY's superschnelle asm STRING unit, mit
        * freundlicher genehmigung (mndlich)
        *)
       mystring,
       (*
        * Unit fr //COMPRESS ebenfalls aus DG8NDY's WinGT
        *)
       COMPUNIT,
       {$IFDEF HELP}
       (*
        * DG4MMI's Online Hilfe
        *)
       OnlHelp,
       {$ENDIF}
       (*
        * Dekodierung von TCP/IP-Frames. Jetzt Code von Jochen.
        *)
       tcpip,
       (*
        * Fr SetMemTop, aus TurboVision.
        *)
{$IFNDEF FPK}
       Memory,
{$ENDIF}
       (*
        * Exportiert XREADKEY und XKEYPRESSED zum abspielen/aufnehmen
        * von Makros.
        *)
       keymakro,
       (*
        * Hier ist die Programm-Initialisierung/Deinitialisierung drin.
        * (InitMCUT/DoneMCUT)
        *)
       STARTUP,
       (*
        * Erkennung verschiedener Remote-Systeme und Passwort-Prompts
        *)
       TERMSCAN,
       (*
        * Diverse Dialogbox-Definitionen
        *)
       DIALOG1,
       DIALOG2,
{$IFNDEF FPK}
XMS,
{$ENDIF}
       Script,
     {$IFDEF EDITOR}
       (*
        * Der Editor
        *)
       EDITOR,
     {$ENDIF}
       (*
        * Ansteuerung von TNC und PC/FlexNet
        *)
       PACKET
     {$IFDEF CONVNETZ}
        (*
         * Routinen fr den vernetzten PingPong Convers, wird hier wegen
         * SendPings gebraucht
         *)
       ,ConvHost
     {$ENDIF}
     {$IFDEF CONVNEU}
       (*
        * Das gibt mal Jochens neues Convers-Netz-Protokoll
        *)
     ,CONVHNEU
     {$ENDIF};



(***************************************************************************)
(*                  Diese Units kommen ins Overlay                         *)
(***************************************************************************)

{$IFDEF OVR}
  {$O STARTUP}
  {$O MCUTLIB2}
  {$O MCUTREM}
  {$O QUICKSET}
  {$O MCUTMEN}
  {$O TERM_O}
  {$O HPUI}
  {$O INPUT}
  {$O MENUE}
  {$O TERMUSER}
  {$O DIALOG1}
  {$O DIALOG2}
  {$O RESTORE}
  {$IFDEF BOX}
    {$O BOXGARB}
    {$O BOXSTART}
    {$O BOXIMP}
    {$O BOXCMD}
    {$O BOXOCMD}
    {$O BOXSEND}
    {$O BOXSF}
    {$O BOXSFFBB}
    {$O PGP}
  {$ENDIF}
  {$IFDEF EDITOR}
    {$O EDITOR}
  {$ENDIF}
  {$IFDEF CONVERS}
    {$O CONVERS}
  {$ENDIF}  
{$ENDIF}

(*
 * Wann wurde das letzte mal Mail Importiert ?
 *)

CONST
   last_newmail:LONGINT=0;
   last_sf:LONGINT=0;
   ScriptChan:BYTE=1;

VAR B,TYP:BYTE;
    FERTIG:BOOLEAN;
    Data:STRING;
    ASMHelp:WORD;
(***************************************************************************)
(* Sodele, jetzt gehts endlich los mit dem eigentlichen Programm!          *)
(* int main(int argc;char *argv[]); ;-)
(***************************************************************************)
CONST _T:BOOLEAN=FALSE;
{$IFDEF LINUX}
VAR Trec : TimeVal;
   FDS	 : FDSet;
    {$ENDIF}
BEGIN
  (*
   * Hier findet die eigentliche Initialisierung statt!
   *)
  STARTUP.InitMCUT;
  (*
   *  So, eine grosse Schleife, nix Multitasking oder Eventsteuerung
   *)
  LastKeyPressed:=CurrIxTime;
   REPEAT
    	  {$IFNDEF linux}
      IF (ConsoleState=CONS_TERM) AND NOT CRTSaveAktiv THEN
	  WITH vorschreib[channel]^ DO
            XGotoXY(x,pvorschreib+y-1-offs);
          {$ENDIF}
  
    MCUTisIDLE:=TRUE;
    (*
     * Anzahl der Schleifendurchlufe, fr Auslastungsmessung und
     * Priorittensteuerung
     *)
    INC(cnt_rnds);
    {$IFDEF WA8DED}
    {----------------------------------------------------------------------
     Abschnitt: Daten vom TNC holen und in die Empfangs-
                Warteschlange einreihen.
     ----------------------------------------------------------------------}
    IF ((cnt_rnds MOD (Poll_Prio))=0) AND (DEVICE=0) THEN
          PACKET.PollTNC;
    {$ENDIF}
    {$IFDEF FLEXNET}
    IF device=1 THEN
    BEGIN
      PACKET.DoFlexNet;
    END;
    {$ENDIF}
    IF (cnt_rnds MOD (Handle_Prio))=0 THEN
    BEGIN
      B:=ScriptChan;
      fertig:=false;
      REPEAT
        IF B=255 THEN b:=1 ELSE
        INC(B);
        IF Scripts[b]<>NIL THEN
        BEGIN
          fertig:=true;
          HandleScript(b,'');
        END;
      UNTIL fertig OR (b=scriptchan);
      scriptchan:=b;
      {-----------------------------------------------------------------------
       Abschnitt: Daten aus der Empfangswarteschlange an die MCUT Module
                  ausgeben. (Handle Aufrufen)
       -----------------------------------------------------------------------}
      B:=HandleChan;
      Fertig:=False;
      REPEAT
        INC(B);
        IF B=255 THEN B:=0;
        IF KS[B]<>NIL THEN
        BEGIN
          IF KS[b]^.sleepuntil<=currixtime THEN
          BEGIN
            WHILE (KS[B]^.ReceiveQueue<>NIL) AND ((KS[b]^.FLAGS AND KS_ReceiveReady)<>0) DO
            BEGIN
              FERTIG:=TRUE;
              PopQueue(KS[B]^.ReceiveQueue,Typ,data);
              KS[b]^.RxW:=KS[b]^.RxW-(BYTE(data[0]));
	       IF KS[b]^.rxw<0 THEN KS[B]^.rxw:=0;
              KS[b]^.RxBy:=KS[b]^.RxBy+(BYTE(data[0]));
              KBytes_RX:=KBytes_RX+Byte(data[0]);
              Handle(B,data);
              IF (SaveMode[b]=1) AND ((KS[b]^.FLAGS AND KS_CRONTask)=0) THEN
              BEGIN
                inc(KS[b]^.transferred,length(data));
                IF data[length(data)] IN [#13,#10] THEN
                BEGIN
                  DEC(byte(data[0]));
                  WriteLn(SaveFile[b]^,data);
                END ELSE
                  Write(SaveFile[b]^,data);
                IF IOResult<>0 THEN
                BEGIN
                  PopUp('I/O-Error');
                  SaveMode[b]:=0;
                  Close(SaveFile[b]^);
                  IF IORESULT<>0 THEN;
                  Dispose(SaveFile[b]);
                END;
              END;
            END;
            IF (KS[B]^.ReceiveRest<>'') and (KS[b]^.ReceiveQueue=NIL) THEN
              PwScan(b,KS[b]^.ReceiveRest,TRUE);
            IF ((KS[B]^.FLAGS AND KS_LineMode)=0) and (KS[B]^.ReceiveRest<>'') and (KS[b]^.ReceiveQueue=NIL) THEN
            BEGIN
              FERTIG:=TRUE;
              Handle(B,KS[B]^.ReceiveRest);
              KBytes_RX:=KBytes_RX+Byte(KS[b]^.ReceiveRest[0]);
              {$I-}
              IF (SaveMode[b]=1)  AND ((KS[b]^.FLAGS AND KS_CRONTask)=0) THEN
                Write(SaveFile[b]^,KS[b]^.ReceiveRest);
              IF IOResult<>0 THEN
              BEGIN
                PopUp('I/O-Error');
                SaveMode[b]:=0;
                Close(SaveFile[b]^);
                IF IORESULT<>0 THEN;
                Dispose(SaveFile[b]);
              END;
              KS[B]^.ReceiveRest:='';
            END ELSE
            IF KS[B]^.Prio>0 THEN
            BEGIN
              ein_s:='';
              Handle(B,ein_s);
            END ELSE
            IF (KS[b]^.FLAGS AND KS_CRONTask)<>0 THEN
            BEGIN
              HandleDiscon(b,'');
            END;
          END;
        END;
      UNTIL FERTIG OR (B=HandleChan);
    END;
    {------- Daten an Module geben ---- ENDE }
    {-----------------------------------------------------------------------
     Abschnitt: Schauen auf welchem Kanal Daten zum Senden vorliegen,
                berprfen, ob das TNC auf diesem Kanal Daten aufnehmen
                kann, Daten an TNC ausgeben.
     ------------------------------------------------------------------------}
    IF (Cnt_Rnds MOD Send_Prio)=0 THEN
    BEGIN
      B:=SendChan;
      fertig:=False;
      REPEAT
        INC(B);
        IF B=255 THEN B:=0;
        IF KS[B]<>NIL THEN
        BEGIN
          Packet.DoSendChannels(b);
          Fertig:=TRUE;
        END; {IF KS[B]<>NIL }
      UNTIL  (B=SendChan) or Fertig;
      SendChan:=B;
    END;

    (***********************************************************************)
    (*        Es folgen diverse zeitgesteuerte AKtionen (iad, dez 95)      *)
    (***********************************************************************)
    long:=currixtime;
    IF (CRTSave>0) AND ((long-LastKeyPressed)>60*CRTSave) THEN
    BEGIN
      IF NOT CrtSaveAktiv THEN
      BEGIN
        CRTSaveAktiv:=TRUE;
        ReDrawSCreen; 
      END;
    END;
    (*
     * System Auslastung messen, (iad, feb 95)
     *)
    IF (long-last_mess)>10 THEN
    BEGIN
      Through_RX:=ROUND((KBytes_RX)/(long-last_mess));
      Through_TX:=ROUND((KBytes_TX)/(long-last_mess));
      KBytes_RX:=0;
      KBytes_TX:=0;
      Last_Rnds:=ROUND(Cnt_Rnds/(long-last_mess));
      IF Last_Rnds>Max_Rnds THEN
        Max_Rnds:=Last_Rnds;
      Cnt_Rnds:=0;
      SysLoad:=ROUND(((max_Rnds-Last_rnds)/Max_rnds)*100);
      Last_Mess:=long;
    END;
    {$IFDEF CONVNETZ}
    (*
     * Den Convers am leben erhalten, damit er PINGEN und PONGEN kann
     * (iad, dez 95)
     *)
    IF (long-lastping)>10 THEN
    BEGIN
      lastping:=long;
      sendpings;
    END;
   {$ENDIF}
   {$IFDEF BOX}
    (*
     * IMPORT aufrufen, alle 5 Minuten. (wenn keine crontab verwendet wird)
     * iad, mar 96
     *)
    IF ((long-last_newmail)>300) AND (box_is_running) THEN
    BEGIN
       Box_NewMail;
      last_newmail:=long;
    END;
    IF ((long-last_sf)>30*60) AND (box_is_running) THEN
    BEGIN
      Auto_SF_Poll;
      last_sf:=long;
    END;
    {$ENDIF}
    
    {------ Daten ans TNC senden ------- ENDE   }
    {------------------------------------------------------------------------
     Abschnitt: Tastatur abfragen
     ------------------------------------------------------------------------}
    (*
     * Wenn ein PopUp-Fenster lange genug offen war, wird das nchste
     * in der Queue angezeigt oder selbiges geschlossen
     * iad, vor langer zeit.
     *)
    IF PopUP_aktiv THEN
    BEGIN
      IF (long-popup_start)>=popup_duration THEN
        PopNext;
    END;
    (*
     * Tastatur-Makro-Aufnahme starten/beenden, wenn shift-shift
     * gedrckt wurde.
     * iad, mar 96
     *)
{$IFNDEF LINUX}
     IF shift(true) AND shift(false) THEN
        IF keymakro.status=1 THEN
          SaveKeyMakro
        ELSE IF keymakro.status=0 THEN
          Aufnehmen;
{$ENDIF}
     (*    IF (cnt_rnds MOD 4)=0 THEN *)
    IF XKeyPressed THEN
      DoKeyBoard;
    {------- Tastatur Abfragen ------- ENDE}
    {$IFDEF BOX}
    (*
     * Hier wird die Box am leben erhalten, wenn irgendwas im Hintergrund
     * ausgegeben werden soll (READ,CHECK,LIST), wie gesagt, kein
     * Multitasking
     *)
    Box_Send_Queue;
    {$ENDIF}
    {------------------------------------------------------------------------
     Abschnitt: Bildschirm ausgeben
     ------------------------------------------------------------------------}
    IF (cnt_rnds MOD (Screen_Prio))=0 THEN
    BEGIN
      (*
       * Wenn kein PopUp-Window offen ist...
       *)
      IF ScreenWriteOK THEN
      BEGIN
        (* Im normalen Terminal-Modus ...
         *)
        IF ConsoleState=0 THEN
	BEGIN
	  {$IFNDEF linux}
	  WITH vorschreib[channel]^ DO
            XGotoXY(x,pvorschreib+y-1-offs);
          {$ENDIF}
	  {$IFNDEF LINUX} 
          DrawStatus1;
          DrawStatus2;
          DrawVorschreib;
	  {$ENDIF} 
	  WITH vorschreib[channel]^ DO
            XGotoXY(x,pvorschreib+y-1-offs);
 
        END;
        {$IFDEF EDITOR}
        (* Beim Editor *)
        IF ConsoleState=1 THEN
          EditSetCurs;
        {$ENDIF}
      END;
    END;
    {------- Bildschirm Ausgeben ------- ENDE}
{$IFNDEF FPK}
     IF Windows95Close AND NOt ClosingInProgress THEN
     BEGIN
	ASM
	MOV AX,$168F
	MOV DH,1
	MOV DL,0
	INT $2F
	MOV ASMHelp,AX
     END;
      (*
       *  Wenn die Option CLOSE im System-Men des Windows-Fensters
       *  aktiviert wurde, dann fahren wir MCUT sauber herunter.
       *)
     IF ASMHelp<>$168F THEN
     BEGIN
	StartUp.DoneMCUT;
	ASM
	MOV AX,$168F
	MOV DH,2
	MOV DL,0
	INT $2f
        END;
        Halt;
     END;
END;
   {$ENDIF}
    (*
     * Whrend dem letzten Schleifendurchlauf haben wir nix
     * gemacht, also beenden wir mal unseren TimeSlice falls Windows
     * oder OS/2 aktiv ist...
     *)
    {
    IF MCUTisIDLE THEN
    BEGIN
      ASM
        MOV AX,$1680
        INT $2F
        MOV ASMHelp,AX
      END;
      (*
       * Aha, der call wird untersttzt...
       *)
      IF ASMHelp=0 THEN
      BEGIN
        Poll_Prio:=254;
        Send_Prio:=254;
        Handle_Prio:=254;
      END;
    END; }
    UpdateScreen;
   {$IFDEF LINUX}
   fillchar(trec,sizeof(timeval),0);
   trec.usec:=70;
   fd_zero(fds);
   fd_set(0,FDS);
   select(2,@FDS,NIL,NIL,@Trec);
{$ENDIF}    
  UNTIL MCUT_ENDE;
  STARTUP.DoneMCUT;
END.














