(****************************************************************************)
(* Diverse Routinen fr MCUT.                                               *)
(* Zentrale Handle-Prozedur, Monitor-Splitting, Fehlerbehandlung            *)
(* Sollte mit der Zeit aufgelst werden.                                    *)
(* Darf nicht als Overlay deklariert werden                                 *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(****************************************************************************)


UNIT MCUTLIB;

INTERFACE


PROCEDURE AutoBin(c:BYTE;Bhead,savepath:STRING);
PROCEDURE handle(ch:BYTE;s:STRING);
PROCEDURE GiveP(c:BYTE);
FUNCTION NewFileName(c:BYTE;path:STRING;VAR name:STRING):BOOLEAN;

IMPLEMENTATION

uses script,toolbox,iadvar,
     mcutlib2,termuser,termscan,
     screen,
     mcutterm,
     {$IFDEF BOX}
     BoxMain,
     {$ENDIF}
     {$IFDEF CONVERS}
     convers,
     {$ENDIF}
     mystring,
     {$IFDEF WA8DED}
     TNC,
     {$ENDIF}
     dos;




PROCEDURE GiveP(c:BYTE);
BEGIN
  PutData(c,ExpandTermMacros(c,promptstr));
END;


FUNCTION NewFileName(c:BYTE;path:STRING;VAR name:STRING):BOOLEAN;
VAR W:WORD;err:integer;SR:SearchRec;
BEGIN
  W:=0;
  FindFirst(sevenpath+cutssid(KS[c]^.call)+'.'+xhex(W),anyfile,sr);
  WHILE (doserror=0) and (W<$FFF) DO
  BEGIN
    INC(W);
    FindFirst(sevenpath+cutssid(KS[c]^.call)+'.'+XHEX(W),anyfile,sr);
  END;
  IF W=$FFF THEN
  BEGIN
    NewFilename:=FALSE;
    Exit;
    Dispose(KS[c]^.AutoBinData);
    KS[c]^.AutoBinData:=NIL;
    KS[c]^.Status:=KS[c]^.LastStatus;
    PutData(c,'#NO# - too many files'+#13);
    EXIT;
  END ELSE
    Name:=CutSSID(KS[c]^.Call)+'.'+Xhex(w);
END;

PROCEDURE AutoBin(c:BYTE;Bhead,savepath:STRING);

VAR S,S2          : STRING;
       b          : BYTE;
    BFile         : STRING;
    aCRC          : WORD;
    aSize,FTime   : LONGINT;
    Pos_in_Bhead,
    Element_to_get: BYTE;
    err           : INTEGER;
    sr:searchrec;
BEGIN
  IF bhead[1]<>'#' THEN exit;
  IF POS('#BIN#',bhead)=1 THEN
  BEGIN
    Element_to_get:=0;{size}
    s:='';
    ASize:=0;
    ACRC:=0;
    FTime:=0;
    BFile:='';
    if bhead[length(bhead)]=#13 THEN dec(byte(bhead[0]));
    addchar(bhead,'#');
    FOR Pos_In_BHead := 6 TO LENGTH(BHead) DO
      IF ((BHead[Pos_In_Bhead]>='0') AND (Bhead[Pos_in_bhead]<='9')) OR
	((BHead[Pos_In_Bhead]>='A') AND (Bhead[Pos_in_bhead]<='Z')) OR
	((BHead[Pos_In_Bhead]>='a') AND (Bhead[Pos_in_bhead]<='z')) OR
	((BHead[Pos_In_Bhead] IN ['/','\','.','_','-','!',':'])) THEN
      BEGIN
	
	 S:=S+BHead[Pos_In_Bhead];
      END
      ELSE
      BEGIN	 
	
	 IF Bhead[pos_in_bhead] IN ['|','#', '$'] THEN
	 BEGIN
	    CASE Element_to_Get OF
	    0 : BEGIN
		  val(s,Asize,err);
		  IF (BHead[pos_in_bhead]='#') and
		    (BHead[succ(pos_in_bhead)] IN ['|','$'] )THEN
		    inc(pos_in_bhead);
		END;
	    1 : BEGIN
		  val(s,aCRC,err);
		  IF (BHead[pos_in_bhead]='#') and
		    (BHead[succ(pos_in_bhead)] IN ['|','$'] )THEN
		    inc(pos_in_bhead);
		END;
	    2 : BEGIN
		  val('$'+s,Ftime,err);
		  IF (BHead[pos_in_bhead]='#') and
		    (BHead[succ(pos_in_bhead)] IN ['|','$'] )THEN
		    inc(pos_in_bhead);
		END;
	    3 : BEGIN
		  BFile:=s;
		END;
	  END;
	  IF err>0 THEN
	  BEGIN
	    CASE element_to_get OF
	      0	: PutData(c,'#NO# (Error in BIN Header :size)'#13);
	      1	: PutData(c,'#NO# (Error in BIN Header :crc)'#13);
	      2	: PutData(c,'#NO# (Error in BIN Header :time)'#13);
	      3	: PutData(c,'#NO# (Error in BIN Header :name)'#13);
	    END;
	    KS[c]^.status:=KS[c]^.LastStatus;
	    EXIT;
	  END;
	  s:='';
	  CASE BHead[Pos_In_BHead] OF
	    '|'	: Element_To_Get:=1;
	    '$'	: Element_to_Get:=2;
	    '#'	: Element_To_Get:=3;
	  END;	
	END;
    END;
     IF s<>'' THEN bfile:=S;
    MakeFnClean(bfile);
    
    IF KS[c]^.AutoBinData=NIL THEN
    BEGIN
      NEW(KS[c]^.AutoBinData);
      WITH KS[c]^.AutoBinData^ DO
      BEGIN
        FileName:=sevenpath+BFile;
        CRC:=aCRC;
        expected:=Asize;
        received:=0;
        KS[c]^.expected:=asize;
        KS[c]^.transferred:=0;
        KS[c]^.filename:=Bfile;
        KS[c]^.transferstart:=currixtime;
      END;
    END ELSE
    BEGIN
      IF KS[c]^.AutoBinData^.FileName<>'' THEN
       BFile:=KS[c]^.AutoBinData^.Filename
      ELSE exit;
      WITH KS[c]^.AutoBinData^ DO
      BEGIN
        CRC:=aCRC;
        expected:=Asize;
        received:=0;
        KS[c]^.expected:=asize;
        KS[c]^.transferred:=0;
              KS[c]^.filename:=Bfile;
        KS[c]^.transferstart:=currixtime;
      END;

    END;
    IF (Bfile='') THEN    {wenn kein FileName bertragen wurde, dann einen}
    BEGIN                 {vom typ CALL.nr erzeugen}
      IF NOT NewFileName(c,savpath,BFILE) THEN
      BEGIN
        Dispose(KS[c]^.AutoBinData);
        KS[c]^.AutoBinData:=NIL;
        KS[c]^.Status:=KS[c]^.LastStatus;
        PutData(c,'#NO# - too many files'+#13);
        EXIT;
      END;
      KS[c]^.filename:=Bfile;
      KS[c]^.AutobinData^.FileName:=sevenpath+Bfile;
    END;
    IF aSize>Diskfree(0) THEN
    BEGIN
      PutData(c,'#NO# (Disk full)'+#13);
      Dispose(KS[c]^.AutoBinData);
      KS[c]^.AutoBinData:=NIL;
      KS[c]^.Status := KS[c]^.LastStatus;
      EXIT;
    END;
    KS[c]^.FLAGS:= KS[c]^.FLAGS AND NOT KS_LineMode;
    KS[c]^.Status:=14;
    KS[c]^.autobindata^.starttime:=currixtime;
    Findfirst(KS[c]^.AutoBinData^.FileName,anyfile,sr);
    IF Doserror=0 THEN
    BEGIN
      PutData(c,'#NO# - File already exists'+#13);
      Dispose(KS[c]^.AutoBinData);
      KS[c]^.AutoBinData:=NIL;
      KS[c]^.Status := KS[c]^.LastStatus;
    END ELSE
    BEGIN
      {$I-}
      Assign(KS[c]^.AutoBinData^.Binfile,KS[c]^.AutoBinData^.FileName);
      Rewrite(KS[c]^.AutoBinData^.BinFile,1);
      IF IOResult<>0 THEN
      BEGIN
        PutData(c,'#NO# - I/O error'+#13);
        Dispose(KS[c]^.AutoBinData);
        KS[c]^.AutoBinData:=NIL;
        KS[c]^.Status := KS[c]^.LastStatus;
      END ELSE
      BEGIN
        KS[c]^.FLAGS:= KS[c]^.FLAGS AND NOT KS_LineMode;
        KS[c]^.FLAGS:= KS[c]^.FLAGS AND NOT KS_SHOWDATA;
        KS[c]^.Status:=14;
        PutData(c,'#OK#'+#13);
      END;
    END;
  END ELSE
  IF (POS('#ABORT#',Bhead)=1) AND (KS[c]^.AutoBinData<>NIL) THEN
  BEGIN
   PutData(c,'AUTOBIN-Receive aborted'+#13);
   Dispose(KS[c]^.AutoBinData);
   KS[c]^.FLAGS:= KS[c]^.FLAGS OR KS_LineMode;
   KS[c]^.FLAGS:= KS[c]^.FLAGS OR KS_SHOWDATA;
   KS[c]^.AutoBinData:=NIL;
   KS[c]^.status:=KS[c]^.LastStatus;
  END;
END;



PROCEDURE handle( ch:BYTE;s:STRING);
VAR W:WORD;

 PROCEDURE EndWrite;
 BEGIN
   CLOSE(KS[ch]^.Datei^);
   KS[CH]^.Status:=KS[CH]^.LastStatus;
   DISPOSE(KS[ch]^.Datei);
   KS[ch]^.Datei:=NIL;
   PutData(CH,'File saved.'+#13);
   GiveP(ch);
 END;

BEGIN
w:=0;
IF Scripts[ch]<>NIL THEN handlescriptdata(ch,s);
case KS[ch]^.status of
  5:BEGIN
      W:=POS(#26,s);
      IF W>1 THEN
      BEGIN
        Write(KS[ch]^.datei^,COPY(s,1,w-1));
        endWrite;
      END ELSE
       IF W=1 THEN
         EndWrite
       ELSE
         BEGIN
           W:=POS('***END',GROSS(s));
           IF W>1 THEN
           BEGIN
             Write(KS[ch]^.Datei^,COPY(s,1,w-1));
             endWrite;
           END ELSE
             IF W=1 THEN
               EndWrite
             ELSE
               IF s[Length(s)]=#13 THEN
                 WriteLn(KS[ch]^.Datei^,copy(s,1,length(s)-1))
               ELSE
                 Write(KS[ch]^.Datei^,s)
         END;
     END;
  {$IFDEF CONVERS}
  6:HandleConv(ch ,s);
  {$ENDIF}
  7:HandleTerm(ch,s);
  13:BEGIN
       AutoBin(ch,s,SavPath);
      END;
  15:with KS[ch]^.AutobinData^ DO
      BEGIN
        IF copy(s,1,4)='#OK#' THEN
        BEGIN
          KS[ch]^.status:=16;
          PutBinFile(ch,KS[ch]^.AutoBinData^.FileName);
          KS[ch]^.AutoBinData^.starttime:=currIxTime;
        END ELSE
        IF (copy(s,1,4)='#NO#') or (copy(s,1,7)='#ABORT#') THEN
        BEGIN
          KS[ch]^.status:=KS[ch]^.Laststatus;
          Dispose(KS[ch]^.AutoBinData);
          KS[ch]^.AutoBinData:=NIL;
        END;
      END;
   16:BEGIN
        IF copy(s,1,7)='#ABORT#' THEN
        BEGIN
          Close(KS[ch]^.SendFile);
          KS[ch]^.SendMode:=0;
          PutData(ch,'AUTOBIN-Transfer aborted by receiver'+#13);
          KS[ch]^.status:=KS[ch]^.Laststatus;
          Dispose(KS[ch]^.AutoBinData);
          KS[ch]^.AutoBinData:=NIL;
        END;
      END;
   14:with KS[ch]^ DO
      BEGIN
       IF pos('#ABORT#',s)>0 THEN
       BEGIN
         PutData(ch,'AUTOBIN abgebrochen'+#13);
         close(autobinData^.binfile);
         erase(AutoBinData^.binfile);
         dispose(autobindata);
         autobindata:=NIL;
         FLAGS := FLAGS OR KS_linemode;
         FLAGS:=FLAGS OR KS_SHOWDATA;
         status:=laststatus;
         exit;
       END;
       IF (autobindata^.received+length(s) < (autobindata^.expected)) THEN
       BEGIN
          Blockwrite(autobindata^.binfile,s[1],length(s));
          inc(AutoBinData^.received,length(s));
          inc(transferred,length(s));
       END ELSE
       with autobindata^ do
       BEGIN
          Blockwrite(binfile,s[1],expected-received);
          inc(transferred,expected-received);
          close(binfile);
          w:=makeCRC(filename);
          IF CRC>0 THEN
          IF W<>CRC THEN
          BEGIN
            erase(binfile);
            BinResults(ch,crc,w);
            IF KS[ch]^.laststatus=7 THEN
              PopUp('AUTOBIN to '+call+': CRC Error');
          END ELSE
          BEGIN
            str(crc,s);
            BinResults(ch,crc,w);
            IF laststatus=7 THEN
               PopUp('AUTOBIN to '+call+': Transfer OK');
          END;
          status:=Laststatus;
          Dispose(KS[ch]^.AutoBinData);
          KS[ch]^.AutoBinData:=NIL;
          FLAGS:=FLAGS OR KS_linemode;
          FLAGS:=FLAGS OR KS_SHOWDATA;
       END;
     END;
   25:BEGIN
        DoRouting(ch,s);
      END;
   {$IFDEF BOX}
   50,51,52,53,59,60:HandleBox(ch,s);
   {$ENDIF}
   {$IFDEF CONVERS}
   100..149:HandleConv(ch,s);
   {$ENDIF}
 END;
END;


END.









