(****************************************************************************)
(* Diverse Routinen fr MCUT.                                               *)
(* Unter anderem                                                            *)
(*   * Routinen zum Abarbeiten von Connects/Disconnects                     *)
(*                                                                          *)
(* Die Unit darf als Overlay deklariert werden.                             *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(*                                                                          *)
(****************************************************************************)

{$F+}
UNIT MCUTLIB2;

INTERFACE
USES iadvar;

FUNCTION ExpandTermMacros(ch:byte;var tmpstr:string):STRING;
PROCEDURE SendTermMacroFile(ch:BYTE;name:STRING);


{PROCEDURE PlayString(S:STRING);
 Spielt eine folge von freq,delay,freq,delay,freq,delay
 auf dem Speaker ab}

PROCEDURE PlayString(S:STRING);


{FUNCTION MakeConnect(mycall,connect_call,status):BYTE
 Sucht einen freien Kanal, setzt MyCall MY, und connected das Ziel in s.
 Alloziiert einen KS und setzt status. Falls kein Speicher, oder
 kein Kanal mehr frei, wird 0 zurckgegeben, ansonsten der die Kanalnummer
 }
FUNCTION MakeConnect(my,s:String;status:BYTE):BYTE;

{PROCEDURE HandleDiscon(Kanal,Tnc_Meldung)
 Wird von Kern aufgerufen, wenn ein BUSY,LINKFAILURE oder DISCONNECT
 eintrifft. Dealloziert verwendeten Speicher, lscht vorhandene
 Warteschlangen.
 Sollte *NICHT* von anderen Programmteilen aufgerufen werden}
PROCEDURE HandleDiscon(ch:byte;TncStr:STRING);

{PROCEDURE HandleConnect(Kanalnummer,TNC_Meldung)
 Wird vom Kern, und von Make_Loop in TERM_O aufgerufen, behandelt
 eintreffende Verbindungen (Speicher anfordern, Ctext senden, Status
 setzen etc.
 Sollte *NICHT* von anderen Programmteilen aufgerufen werden.}
PROCEDURE HandleConnect(ch:byte;Tncstr:string);



{FUNCTION MakeCRC(Dateiname):WORD
 Gibt den AUTOBIN-CRC der Datei "dateiname" zurck.
 Die existienz der Datei sollte vor dem Aufruf berprft werden}
FUNCTION  makeCRC( VAR Zeile : STRING ):WORD;


{PROCEDURE DoMenu(MenueNummer)
 DoMenu aktiviert das Pulldown-Menue. MenueNummer bestimmt, welcher
 eintrag in der MenZeile geffnet werden soll}
PROCEDURE DoMenu(b:byte);

{FUNCTION testcommand(KanalNummer,BefehlsZeile,KommandoListe)
 Diese Funktion untersucht, ob der erste Token in "BefehlsZeile"
 mit einem der Token in der verketteten Liste "KommandoListe" bereinstimmt.
 Wenn der Token in der Befehlszeile krzer ist, als der in der Liste,
 wird nur bis zur Lnge	des krzeren Tokens verglichen. Ausserdem wird
 KS[c]^.Level und der Level des Kommandos in der KommandoListe verglichen.
 Wenn ein Eintrag gefunden wird, bei die Token bereinstimmen und der Level
 des  Eintrags <= KS[c]^.Level ist, wird die Nummer des Eintrages zurckgegeben,
 ansonsten 0}
FUNCTION  testcommand(c:BYTE;s:STRING;cmdlist:pcmd):WORD;
PROCEDURE BinResults(c:byte;crc1,crc2:LONGINT);
PROCEDURE Dosshell;
IMPLEMENTATION


USES
     {$IFNDEF LINUX}
     memory,
     {$ENDIF}
     {$IFDEF WA8DED}
     V24DRV,
     {$ENDIF}
     crt,
     toolbox,
     dos,
     TERMUSER,
     mcutmen,
     hpui,
     menue,
     input,
     term_o,
     mcutbuf,
     {$IFDEF BOX}
     BoxMain,
     pgp,
     {$ENDIF}
     {$IFDEF CONVERS}
     convers,
     {$ENDIF}
     Screen,
     {$IFDEF WA8DED}
     tnc,
     {$ENDIF}
     {$IFDEF FLEXNET}
     flxapp,
     {$ENDIF}
     mystring,
     quickset,
     termscan,
     {$IFDEF EDITOR}
     editor,
     {$ENDIF}
     {$IFDEF HELP}
     onlhelp,
     {$ENDIF}
     video,
     dialog1,
     dialog2,
     packet,
     wgtcrc
     ;



VAR  numread  : WORD;
       C      : BYTE;
       ton    : WORD;
           l,r:STRING;

CONST

      recurs: BYTE=10;



FUNCTION testcommand(c:BYTE;s:STRING;cmdlist:pcmd):WORD;
VAR acmd:pcmd;w,w1,w2:WORD;datestr:STRING;
    i: INTEGER;
    ok: BOOLEAN;
    hlp: STRING;

BEGIN
   testcommand:=0;
   acmd:=cmdlist;
   IF s[length(s)]=#13 THEN dec(BYTE(s[0]));
   WHILE (s[1]=' ') AND (s[0]>#0) DO s:=copy(s,2,255);
   w:=0;
   s:=gross(s);
   IF pos(' ',s)>0 THEN s:=copy(s,1,pos(' ',s)-1);
   IF s='' THEN exit;
   WHILE (acmd<>NIL) AND (w=0) DO
   BEGIN
     IF s=copy(acmd^.cmd,1,length(s)) THEN
       IF (KS[c]^.lev>=acmd^.lev) THEN
       BEGIN
         w:=acmd^.nr;
       END;
     acmd:=acmd^.next;
   END;
   testcommand:=w;
END;


PROCEDURE PlayString(S:STRING);
VAR ton:WORD;
BEGIN
  WHILE (pos(',',s)>0) AND (NOT keypressed) AND (klingel) DO
  BEGIN
    val(copy(s,1,Pos(',',s)-1),ton,err);
    s:=copy(s,pos(',',s)+1,255);
    IF ton=0 THEN nosound ELSE
    sound(ton);
    val(copy(s,1,Pos(',',s)-1),ton,err);
    s:=copy(s,pos(',',s)+1,255);
    delay(ton);
  END;
  nosound;
END;

PROCEDURE showbuf(c:BYTE);
BEGIN
  QSObuf[c]^.goend;
END;


PROCEDURE DosShell;
VAR a,a1:STRING[5];res:WORD;
BEGIN
   {$IFNDEF linux}
    fill(1,1,_spalten,_zeilen,' ',0);
    cursor(2);
    SetMemTop(HeapPtr);
    Gotoxy(1,1);
    TextAttr:=7;
    SWAPVECTORS;
    EXEC(GetEnv('COMSPEC'),'/C CLS');
    WriteLn('Type EXIT to return to MCUT');
    EXEC(GetEnv('COMSPEC'),'');
    SWAPVECTORS;
    SetMemTop(HeapEnd);
    asm  {BLINK aus!}
      mov ax,$1003
      mov bx,0
      int $10
    end;
    setvmode(EGAVGAFONT);
    RedrawScreen;
   {$ENDIF}
END;

PROCEDURE DoMenu(b:byte);
VAR result:WORD;
BEGIN
  Cursor(0);
  result:=GetEvent(b);
  Cursor(2);
  case result of
    101:sendTextDlg;
    102:receiveText;
    103:mcutendedlg;
    104:dosshell;
    105:ReceiveAutoDlg;
    106:SendautoDlg;
    {$IFDEF EDITOR}
    107:BEGIN
          StartEditor;
        END;
    {$ENDIF}
    201:IF KS[channel]<> NIL THEN
          KanalSettingsDlg;
    202:IF KS[channel]=NIL THEN
        ConnLoop(channel,boxcall);
    203:IF KS[channel]=NIL THEN
        ConnLoop(channel,mycall);
    204: WITH Vorschreib[channel]^ DO
         BEGIN
            IF y<10 THEN
              INC(y) ELSE
            BEGIN
              FOR B:=1 TO 9 DO buf[b]:=buf[b+1];
              buf[10]:='';
            END;
            IF (y>4) AND ((y-offs)>4) THEN offs:=y-4;
            Buf[y]:=GenPwd(channel);
        END;
    205:PopUp('Noch nich implementiert'); {link-hold}
    207:UserSettingsDlg;
    206:UmlautSettingsDlg;
    301:PopUp('Noch nich implementiert');  {s&f aufnehmen}
    302:PopUp('Noch nich implementiert');  {reorg}
    402:GeneralSettingsDlg;
    403:PathSettingsDlg;
    404:TerminalSettingsDlg;
    405:TNCSettingsDlg;
    406:ReadConfig;
    407:WriteConfig;
    408:PrioDlg;
    409:MonitorDlg;
    410:FlexNetDlg;
    411:ScreenDlg;
    412:DefaultRemotesDlg;
    {$IFDEF HELP}
    501:BEGIN

           LoadHelpFile('MCUT.HLP');
           IF HelpIndex THEN
           BEGIN
             LastConsoleState:=ConsoleState;
             ConsoleState:=6;
           END ELSE
             onlhelp.releasememory;
        END;
    502:BEGIN
          LoadHelpFile('MCUT.HLP');
          IF ViewHelp('TERM_ALLG') THEN
          BEGIN
            LastConsoleState:=ConsoleState;
            ConsoleState:=6;
          END ELSE
           onlhelp.releasememory;
        END;
    503:BEGIN
          LoadHelpFile('MCUT.HLP');
          IF ViewHelp('BOX_ALLG') THEN
          BEGIN
            LastConsoleState:=ConsoleState;
            ConsoleState:=6;
          END ELSE
            onlhelp.releasememory;
        END;
    504:BEGIN
          IF SelectHelpFile THEN
          BEGIN
            LastConsoleState:=ConsoleState;
            ConsoleState:=5;
          END ELSE onlhelp.releasememory;;
        END;

    505..510:PopUp('Noch nich implementiert'); {Hilfe}
    {$ENDIF}
    {$IFDEF PGP}
    601:pgpsetDlg;
    602:PGPSendPKDlg;
    603:PGPGenKeyDlg;
    604:PGPCertifyDlg;
    605:PGPEditTrustDlg;
    {$ENDIF}
  END;
END;


FUNCTION makeCRC( VAR Zeile : STRING ):WORD;
VAR F:FILE;numread,CRC:WORD;S:STRING;
BEGIN
  CRC:=0;
  ASSIGN(f,zeile);
  {$I-}
  RESET(F,1);
  IF IORESULT<>0 THEN exit;
  REPEAT
    BlockRead(F,S[1],255,numread);
    S[0]:=char(numread);
    { $IFNDEF linux}
     CRC:=BuildStringCRC(S,CRC);
    { $ENDIF}
  UNTIL numread<255;
  CLOSE(F);
  MakeCRC:=CRC;
END;


PROCEDURE HandleDiscon(ch:byte;TncStr:STRING);
VAR B:BYTE;
BEGIN
  IF KS[CH]=NIL Then EXIT;
  {---! }
  IF KS[ch]^.status=7 THEN PlayString(discbell);
  If (ch=channel) AND (ConsoleState=4) AND (which_dialog IN [4,12]) THEN
    DLgDone(False);
  IF (KS[ch]^.status IN [14,16]) and (KS[ch]^.AutoBinData<>NIL) THEN
  BEGIN
    Close(KS[ch]^.AutoBinData^.BinFile);
    IF KS[ch]^.status=14 THEN
      erase(KS[ch]^.AutoBinData^.binfile);
  END;
  {$IFDEF WA8DED}
  IF device=0 THEN
    SendCMD(ch,'I '+MCall[ch]^);
  {$ENDIF}
  {$I-}
  {Logeintrag machen:}
  IF (KS[ch]^.FLAGS AND KS_CRONTask)=0 THEN
  BEGIN
    APPEND(logfile);
    IF IOResult=0 THEN
    BEGIN
      Writeln(logfile,MCall[ch]^,' ':(10-byte(mcall[ch]^[0])),'<> ',KS[ch]^.Call,
      ' ':(10-byte(KS[ch]^.call[0])),' ',copy(DTDateStr(Unix2Pack(KS[ch]^.Create)),1,6),' ',
      copy(DTTimeStr(Unix2Pack(KS[ch]^.Create)),1,5),' - ',copy(DTTimeStr(Unix2Pack(currIXtime)),1,5),
      KS[ch]^.RXby:10,KS[ch]^.TXBy:10,'   (',KS[ch]^.status,')');
      Close(logfile);
    END ELSE Write(#7);
  END;
  {$IFDEF BOX}
  IF (KS[ch]^.status>=50) and (KS[CH]^.status<100) THEN Box_Disc(ch);
  {$ENDIF}
  {$IFDEF CONVERS}
  IF (KS[ch]^.status=6) OR (KS[ch]^.Status IN [100..110]) THEN
     ConvDisconnect(ch);
  {$ENDIF}
  IF (KS[ch]^.status=5) THEN
  BEGIN
    Close(KS[ch]^.Datei^);
    Erase(KS[ch]^.Datei^);
    DISPOSE(KS[ch]^.Datei);
  END;
  IF KS[ch]^.ConnScriptData<>NIL THEN
  BEGIN
    PurgeQueue(KS[ch]^.ConnScriptData^.Script);
    Dispose(KS[ch]^.ConnScriptData);
  END;
  {$IFDEF CONVERS}
  IF KS[ch]^.Convdata<>NIL THEN
    Dispose(KS[ch]^.ConvData);
  {$ENDIF}
  IF KS[ch]^.AutoBinData<>NIL THEN
    Dispose(KS[ch]^.AutoBinData);
  {$IFDEF BOX}
  IF KS[ch]^.BoxData<>NIL THEN
    Dispose(KS[ch]^.BoxData);
  {$ENDIF}
  PurgeQueue(KS[ch]^.SendQueue);
  PurgeQueue(KS[ch]^.ReceiveQueue);
  IF KS[ch]^.SendMode>0 THEN
    Close(KS[ch]^.SendFile);
  IF (KS[ch]^.PGPFlags AND PGP_SAVING_MSG)<>0 THEN BEGIN
    Close(KS[ch]^.PGPSave^);
    erase(KS[ch]^.PGPSave^);
    DISPOSE(KS[ch]^.PGPSave);
  END;  
  Dispose(KS[ch]);
  KS[ch]:=NIL;
END;


PROCEDURE HandleConnect(ch:byte;TncStr:string);
VAR Hlp,s      : STRING;
    B          : BYTE;
    lastmytime,
    lastmydate : LONGINT;
    err        : INTEGER;
BEGIN
   {if (device=0) AND (ch>tncchan) THEN exit;}
   IF mcall[ch]=NIL THEN exit;
  IF KS[ch]=NIL THEN
  BEGIN
    NewKS(ch);
    KS[ch]^.FLAGS:=KS[ch]^.FLAGS AND NOT KS_OWNCON;
  END;
  TncStr:=copy(TncStr,pos('to',TncStr)+3,255);
  IF pos(':',copy(TncStr,3,255))>0 THEN
  BEGIN
    WHILE (TncStr[length(TncStr)]<>'-') DO dec(byte(TncStr[0]));
    dec(byte(TncStr[0]));dec(byte(TncStr[0]));
  END;
  IF pos('via',TncStr)>0 THEN
    KS[ch]^.call:=copy(TncStr,1,pos(' via',TncStr)-1)
  ELSE
    KS[ch]^.call:=TncStr;
  IF KS[ch]^.call[2]=':' THEN
  BEGIN
    KS[ch]^.port:=ord(TncStr[1])-48;
    KS[ch]^.call:=copy(KS[ch]^.call,3,255)
  END
  ELSE KS[ch]^.port:=0;
  IF TncStr[length(TncStr)]=' ' THEN
    DEC(BYTE(KS[ch]^.call[0]));
  LoadTermUser(ch);
  IF KS[ch]^.Status=25 THEN
  BEGIN
    DoRouting(ch,'!!!-**HANDLE$%');
    exit;
  END;
  {$IFDEF CONVNETZ}
  IF KS[ch]^.Status=102 THEN
  BEGIN
    StartConv(ch,'');
    exit;
  END;
  {$ENDIF}
  IF KS[ch]^.Status=60 THEN exit;
  IF KS[ch]^.status=9 THEN
  BEGIN
    BEGIN
      PutData(KS[ch]^.crosschan,'*** connected to '+KS[ch]^.call+#13);
    END;
  END ELSE
  BEGIN
     with KS[ch]^ DO
     BEGIN
       IF (mcall[ch]^=BoxCall) THEN
        {$IFDEF BOX}
        status:=50
        {$ELSE}
        status:=7
        {$ENDIF}
       ELSE IF mcall[ch]^=NodeCall THEN
        status:=12
       ELSE
       {$IFDEF CONVERS}
         IF mCall[ch]^=Gross(convcall) THEN
           STartConv(ch,'')
         ELSE
       {$ENDIF}
          status:=7;
       IF (KS[ch]^.FLAGS AND KS_OWNCON)<>0 THEN status:=7;
     END;
     str(ch,s);
     IF (KS[ch]^.FLAGS AND KS_OWNCON)=0 THEN
     BEGIN
       IF KS[ch]^.lev=0 THEN
       BEGIN
         {$IFDEF WA8DED}
         IF device=0 THEN
         BEGIN      
           sendCmd(ch,'d');
           sendcmd(ch,'d');
         END;
         {$ENDIF}
         {$IFDEF FLEXNET}
         if device=1 THEN
           l2_kill_qso(KS[ch]^.Stream);
         {$ENDIF}
         exit;
       END;
       {$IFDEF BOX}
       IF KS[ch]^.status=50 THEN
       BEGIN
         Box_Login(ch);
       END ELSE
       {$ENDIF}
       IF KS[ch]^.status=7 THEN
       BEGIN
         PutData(ch,'{MCUT-'+version+'-C');
         IF (KS[ch]^.FLAGS AND KS_UNKNOWN)<>0 THEN
           PutData(ch,'?');
         PutData(ch,'}'+#13);
         SendTermMacroFile(ch,textpath+'ctext');
       END
       ELSE
       IF KS[ch]^.status=12 THEN
       BEGIN
         SendTermMacroFile(ch,textpath+'nctext');
       END;
    END;
    IF (KS[ch]^.status=7) THEN
    BEGIN
      PlayString(conbell);
    END;
  END;
END;


FUNCTION ExpandTermMacros(ch:byte;var tmpstr:string):STRING;
VAR s:STRING;
    s1,s2:STRING[10];
    i:integer;
    anz,b:BYTE;
    OK:BOOLEAN;
    lint,ti:LONGINT;
    U:TTermUserRec;
BEGIN
   s:='';
   i:=1;
   WHILE i <= LENGTH(tmpstr) DO BEGIN
     IF tmpstr[i]='%' THEN BEGIN
       inc(i);
       CASE UpCase(tmpstr[i]) OF
         'R': S := S + KS[ch]^.RemPath;
         '3': BEGIN
                U.CALL:=KS[ch]^.Call;
                GetTermUser(U);
                S:= S + U.NetzWerk;
              END;
         '4': BEGIN
                U.CALL:=KS[ch]^.Call;
                GetTermUser(U);
                S:= S + U.Einstieg;
              END;
         '5': BEGIN
                STR(KS[ch]^.TYP,s1);
                S:= S + s1;
              END;
         '6': BEGIN
                S:= S + KS[ch]^.path;
              END;
         '7': BEGIN
                STR(KS[ch]^.MaxFrame,s1);
                S:= S + s1;
              END;
         '8': BEGIN
                STR(KS[ch]^.PacLen,s1);
                S:= S + s1;
              END;
         '9': BEGIN
                STR(KS[ch]^.TxW,s1);
                S:= S + s1;
              END;
         '>': BEGIN
                STR(KS[ch]^.TxBy,s1);
                S:= S + s1;
              END;
         '<': BEGIN
                STR(KS[ch]^.RxBy,s1);
                S:= S + s1;
              END;
         'X': IF KS[ch]^.COMPRESS>0 THEN
              BEGIN
                STR(ROUND((KS[ch]^.CompTx/KS[ch]^.TxBy)*100),s1);
                STR(ROUND((KS[ch]^.CompRx/KS[ch]^.RxBy)*100),s2);
                S:= S + s1+'% TX/'+s2+'% RX';
              END;
         '_': S := S + #13;       {linefeed}
         '%': S := S + '%';                   {%-Zeichen}
         'M': S := S + MyCall;      {Terminal-Rufzeichen}
         'U': BEGIN
                anz := 0;
                FOR b := 0 TO 255 DO BEGIN
                  IF KS[b] <> NIL THEN BEGIN
                    IF (KS[b]^.status IN [1..49]) THEN Anz := Anz + 1;
                  END;
                END;
                STR(anz,S1);
                S := S + S1;
              END;
         'C': S := S + KS[ch]^.Call; {User-Call}
         'V': S := S + Version;                  {Versions-Nummer}
         '1': BEGIN                              {System-Load}
                STR(SysLoad,S1);
                S := S + S1;
              END;
         'T': BEGIN {Zeit}
                S := S + DtTimeStr(unix2pack(currixtime));
              END;
         'D': BEGIN {Datum}
                S := S + DtDateStr(unix2pack(currixtime));
              END;
         'N': IF KS[ch]^.Name='' THEN S:=S + CutSSID(KS[ch]^.CALL)
                                 ELSE S:=S +KS[ch]^.Name;

         'K': BEGIN
                S := S + ConvertByteToString(ch);
              END;
         '2': BEGIN
                ti:=currixtime-starttime;
                S:=S+MkTStr(ti);

             END;
       END;
     END
     ELSE S := S + tmpstr[i];
     inc(i);
   END;
   expandtermmacros:=s;
END;

PROCEDURE SendTermMacroFile(ch:BYTE;name:STRING);
VAR f:TEXT;size:WORD;s:string;
BEGIN
  ASSIGN(f,name);
  {$I-}
  RESET(F);
  size:=0;
  IF IORESULT<>0 THEN
  BEGIN
   PutData(ch,'unable to open '+name+#13);
   Exit;
  END;
  WHILE (NOT EOF(f)) AND (size<10000) DO
  BEGIN
    READLN(F,s);
    PutData(ch,ExpandTermMacros(ch,s)+#13);
    INC(size,succ(length(s)));
  END;
  close(F);
END;


FUNCTION MakeConnect(my,s:String;status:BYTE):BYTE;
VAR B:BYTE;L,R,HLP:STRING;
BEGIN
  MakeConnect:=0;
  FOR B:= MaxTerminal DownTo 1 DO
  IF KS[b]=NIL THEN
  BEGIN
    IF NOT NewKS(b) THEN
     exit;
    KS[b]^.FLAGS:=KS[b]^.FLAGS OR KS_OWNCON;
    IF s[1]='!' THEN
    BEGIN
      KS[b]^.status:=status;
      S:=copy(s,2,255);
      IF Find(S,' ',L,R) THEN
      BEGIN
        IF find(R,' ',S,R) THEN
        BEGIN
          HLP:=L;
          L:=S;
          S:=HLP;
        END ELSE
        BEGIN
          S:=L;
          L:=R;
          R:='';
        END;
      END ELSE
      BEGIN
        L:='';R:='';
      END;
      IF NOT InitRouter(b,my,S,L,R) THEN
      BEGIN
        DISPOSE(KS[b]);
        KS[b]:=NIL;
        MakeConnect:=0;
      END ELSE
        MakeConnect:=b;
      exit;
    END;
    {$IFDEF WA8DED}
    IF device=0 THEN
    BEGIN
      SendCMD(b,'I '+my);
      SendCMD(b,'C '+s);
      KS[b]^.Status:=status;
      MakeConnect:=B;
      EXIT;
    END;
    {$ENDIF}
    {$IFDEF FLEXNET}
    KS[b]^.Stream:=l2_pconnect(my,s);
    KS[b]^.Status:=status;
    MakeConnect:=B;
    EXIT;
    {$ENDIF}
  END;
END;

PROCEDURE BinResults(c:byte;crc1,crc2:LONGINT);
VAR S,s2:STRING;
BEGIN
  S:='<MCUT>: ';
  IF (KS[c]<>NIL) THEN
  BEGIN
    WITH KS[c]^ DO
    BEGIN
      IF CRC1>0 THEN
      BEGIN
        IF CRC1=CRC2 THEN
        BEGIN
          S:=S+' Autobin OK, CRC= ';
          str(crc1,s2);
          S:=S+s2;
        END ELSE
        BEGIN
          S:=S+' Autobin-CRC failed. CRC1=';
          Str(crc1,s2);
          S:=S+S2+' CRC2=';
          Str(crc2,s2);
          S:=S+S2;
        END;
      END ELSE
      BEGIN
       S:=S+' Textsave OK';
      END;
      S:=S+', Size= ';
      str(transferred,s2);
      s:=s+s2+', Speed=';
      str(round(transferred/SUCC(currixtime-transferstart)),s2);
      S:=S+s2+' cps, Time='+MkTstr(currixtime-transferstart)+#13;
    END;
  END;
  IF (KS[c]^.FLAGS AND KS_BBS=0) THEN
    PutData(c,s)
  ELSE
  IF C<=MaxTerminal THEN
    WriteBuf(c,s,fqsotx,1);
END;

END.

