(****************************************************************************)
(* Auswertung der Tastatureingaben im Terminal von MCUT.                    *)
(* Diese Unit sollte nicht als Overlay deklariert werden                    *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(*                                                                          *)
(****************************************************************************)

UNIT MCUTTERM;

INTERFACE
USES IADVAR;

PROCEDURE HandleTerm(ch:BYTE;S:STRING);
PROCEDURE HandleTermKey;
PROCEDURE DoKeyboard;

IMPLEMENTATION
USES CRT,MCUTLIB2,TOOLBOX,MCUTLIB,SCREEN,HPUI,MCUTREM,KEYMAKRO,
     {$IFDEF WA8DED}
     TNC,
     {$ENDIF}
     TERM_O,
     {$IFDEF HELP}
     ONLHELP,
     {$ENDIF}
     {$IFDEF EDITOR}
     EDITOR,
     {$ENDIF}
     {$IFDEF BOX}
     PGP,
     {$ENDIF}
     MENUE,INPUT,QUICKSET,VIDEO,
     PRINTER,
     MYSTRING,TERMUSER,termscan,DIALOG1,DIALOG2,DMCUT,DOS,
     {$IFNDEF FPK}
     MEMORY,
     {$ENDIF}
     SPYNEW,BBSLIST,MH,UNPROTO;


{$IFDEF TOP_DXC}
TYPE
   {$IFDEF FPK}
   real=real;
   {$ELSE}
   real=real;
   {$ENDIF}

PROCEDURE VAL(	  S : STRING;VAR R:REAL;code:INTEGER);
VAR L : LONGINT;W:WORD;B,B1:BYTE;
BEGIN
   s:=ltrim(rtrim(s));
   b:=length(s)-pos('.',s);
   if pos('.',s)>0 THEN DELETE(S,Pos('.',s),1);
   system.val(S,L,W);
   R:=L;
   FOR B1:=1 to B DO R:=R/10;
END;

Const  

         SZ1              = 23;
         SZ2              = 24;
         SZL              = 14;
         ESC              = #27;
         M1               = #13;
         M2               = #13 + #13;
         M3               = #13 + #13 + #13;
         B1               = ' ';
         B2               = B1 + B1;
         B3               = B1 + B1 + B1;
         BS               = '\';
         DP               = ':';
         LZ               = '#';
         LRK              = '(';
         RRK              = ')';
         LSK              = '<';
         RSK              = '>';
         Pipe             = '|';
         Pkt              = '.';
         GPkt             = '';
         Km               = ',';
         DpS              = '//';
         Star             = '*** ';
         Plus             = '+++ ';

(***********************************************************)
(* Procedure Entfernung_Richtung                           *)
(* Die Prozedur dient zur Berechnung von Entfernung und    *)
(* Richtung bei gegebenen geografischen Koordinaten im     *)
(* Gradmass.                                               *)
(* Ergebnis sind Entfernung in Kilometern und Richtung in  *)
(* Grad von QTH1 nach QTH2.                                *)
(* O1,N1 Oestliche Laenge,Noerdliche Breite von QTH1       *)
(* O2,N2 Oestliche Laenge,Noerdliche Breite von QTH2       *)
(***********************************************************)

Procedure Entfernung_Richtung (O1,N1,O2,N2 : REAL; Var Entfernung,Richtung : REAL);
Const PI = 3.1415926;
Var   EW,RV : REAL;

  Function GSIN(WINKEL : REAL) : REAL;
  Begin
    GSIN := SIN(Winkel*PI/180);
  End;

  Function GCOS(WINKEL : REAL) : REAL;
  Begin
    GCOS:=COS(Winkel*PI/180);
  End;

  Function ARCGCOS(COSINUS : REAL) : REAL;
  Var ARCBOG : REAL;
  Begin
    if COSINUS >= 1 then ARCGCOS := 0 else
      if COSINUS <= -1 then ARCGCOS := 180 else
        begin
          ARCBOG  := PI/2-ARCTAN(COSINUS/(SQRT(1-SQR(COSINUS))));
          ARCGCOS := ARCBOG*180/PI;
        end;
  End;


Begin
  EW := arcgcos(gsin(n1)*gsin(n2)+gcos(n1)*gcos(n2)*gcos(o2-o1));
  Entfernung := 40009/360*EW;

  RV := arcgcos((gsin(n2)-gsin(n1)*gcos(ew))/(gcos(n1)*gsin(ew)));
  if gsin(o2-o1) >= 0  then Richtung := RV;
  if gsin(o2-o1) <  0  then Richtung := 360-RV;
End;


(***********************************************************)
(* Procedure NEU_IN_WINKEL                                 *)
(* Diese Procedure dient zum Umwandeln eines neuen QTH-    *)
(* kenners in geografische Laenge und Breite               *)
(* I        Indexvariable fuer Feldzuweisung               *)
(* OESLAE   Oestliche Laenge als Gleitkommawinkel          *)
(* NOEBRE   Noerdliche Breite als Gleitkommawinkel         *)
(* QTHKENN  QTH-Kenner als STRING                          *)
(* WIINFO[6] Feld der QTH-Kennerindexziffern               *)
(* ASCKOR[6] Hilfsfeld zur ASCII-Indexziffernumrechnung    *)
(* Maske [6] Hilfsfeld zur Grossschrifteinstellung         *)
(***********************************************************)

Procedure NEU_IN_WINKEL(QTHKENN :STR20; Var OESLAE,NOEBRE : REAL);
Const   ASCKOR : Array [1..6] of Byte = (065,065,048,048,065,065);
        MASKE  : Array [1..6] of Byte = (223,223,255,255,223,223);

Var i      : Byte;
    WIINFO : Array [1..6] of Byte;

Begin
  for i := 1 to 6 do WIINFO[i]:=(ORD(qthkenn[i]) AND MASKE[i])-ASCKOR[i];

  OESLAE := -180 + WIINFO[1] * 20 + WIINFO[3] * 2 + WIINFO[5]/12+1/24;
  NOEBRE :=  -90 + WIINFO[2] * 10 + WIINFO[4] * 1 + WIINFO[6]/24+1/48;
End;



(***********************************************************)
(* Procedure GRAD_UMW                                      *)
(* Diese Procedure wandelt eine als String uebergebene     *)
(* geografische Koordinate im Format +GGG:MM:SS/-GG:MM:SS  *)
(* mit Unterlaengen +GG:MM und -GG in die entsprechenden   *)
(* Gleitkommawinkel um.  (Oestl. Laenge/Noerd. Breite)     *)
(* Uebergeben wird der Koordinatenstr. und zurueck werden  *)
(* die Gleitkommawinkel und eine Statusvariable uebergeben *)
(* Ist diese False so ist ein Formatfehler entdeckt worden *)
(* und die uebergebenen Winkelparameter undefiniert.       *)
(* QTHKENN     Koordinatenstring                           *)
(* OESLAE      Oestliche Laenge als REAL-Zahl              *)
(* NOEBRE      Noerdliche Breite als REAL-Zahl             *)
(* STATUS      TRUE Umwandlung erfolgreich vorgenommen     *)
(*             FALSE Formatfehler entdeckt oder Bereichs-  *)
(*                   fehler der Koordinatenwinkel          *)
(* MENGE       Definition des Stringmengentyps             *)
(* REFERENZ    Gueltige Elementemenge von QTHKENN          *)
(* RASTER      Feld der gueltigen Formatraster von QTHKENN *)
(* I           Index fuer Feldzugriffe                     *)
(* P           Position des Trennzeichens '/' in QTHKENN   *)
(*             und Kontrollvariable fuer VAL-Funktion      *)
(* OES,NOE     String der oestlichen Laenge,noerdl. Breite *)
(*             zur Umwandlung in den Gleitkommawinkel      *)
(* VERGLEICH   Strukturabbild von QTHKENN zur Format-      *)
(*             pruefung des Koordinatenstrings             *)
(* LAENGE      Laenge von QTHKENN fuer Abfrageschleifen    *)
(***********************************************************)

Procedure GRAD_UMW (QTHKENN          :STRING;
                   VAR OESLAE,NOEBRE :REAL;
                   VAR STATUS        :BOOLEAN);

  (***********************************************************)
  (* FUNCTION GMS_UMW                                        *)
  (* Die Funktion dient zur Umwandlung des Laengen und       *)
  (* Breitengradstring in den entsprechenden Gleitkommawinkel*)
  (* GMS      Stringteil mit Winkelinformation +GG:MM:SS     *)
  (* UMWAND   Gleitkommawinkel                               *)
  (* REST     Teilstring fuer Entnahme der GG,MM,SS-Info     *)
  (* POSI     Position des Trennzeichens DP in REST         *)
  (* VORZEI   Vorzeichenfaktor des Winkels +1 oder -1        *)
  (* I        Potenz des Minuten und Sekundenfaktors zur     *)
  (*          BASIS 60 fuer Gleitkommawinkelberechnung       *)
  (* D        Fehlerposition fuer VAL-Procedure              *)
  (* Teil     Enthaelt Ziffernfaktor fuer Grad,Min.,Sekunden *)
  (* Summe    Teil- und Endsumme des Gleitkommawinkels       *)
  (***********************************************************)

  Function GMS_UMW (GMS : Str20) : Real;

  Var REST   : STRING;
      POSI   : BYTE;
      VORZEI : ShortInt;
      I      : BYTE;
     
      D      : INTEGER;
      Teil   : REAL;
      SUMME  : REAL;

  BEGIN
    I := 0;
    SUMME := 0;
    REST := GMS;
    IF GMS[1]='-' then VORZEI := -1     
                  else VORZEI := 1;     

    Repeat
      Val(REST,TEIL,D);
      IF D <> 0 then Val((COPY(REST,1,D-1)),TEIL,D);

      IF i = 0 then SUMME := TEIL
               else SUMME := SUMME+VORZEI*TEIL/(EXP(LN(60)*i));
      inc(i);

      POSI := pos(DP,REST);
      REST := copy(REST,POSI+1,(LENGTH(REST)-POSI));
    Until POSI = 0;
    GMS_UMW := SUMME
  End;


Type  MENGE = Set of Char;
Const REFERENZ : MENGE = ['0'..'9','+','-','/',':',Pkt ];

      RASTER   : Array [1..12] of string

                = ('VZ:Z:Z/VZ:Z:Z' , 'VZ:Z:Z/VZ:Z' , 'VZ:Z:Z/VZ' ,
                     'VZ:Z/VZ:Z:Z' ,   'VZ:Z/VZ:Z' ,   'VZ:Z/VZ' ,
                       'VZ/VZ:Z:Z' ,     'VZ/VZ:Z' ,     'VZ/VZ' ,
                       'VZ.Z/VZ.Z' ,     'VZ/VZ.Z' ,   'VZ.Z/VZ');

Var   i         : Byte;
      P         : Integer;
      OES,NOE,
      VERGLEICH : String;
      LAENGE    : Byte;

Begin
(* 1. Stringformat und Zeichengueltigkeit ueberpruefen     *)
(* 2. Wenn gueltig in Gleitkommawinkel umwandeln und       *)
(*    danach Gueltigkeitspruefung der Winkel vornehmen     *)
(* 3. Wenn auch das in Ordnung Winkel und STATUS=TRUE      *)

  LAENGE := LENGTH(QTHKENN);
  IF LAENGE <= 20 THEN
    BEGIN

      (* Ueberpruefung von Format und Inhalt der Stringinformation *)

      VERGLEICH:='';
      For I:=1 to LAENGE do
        BEGIN
          IF NOT(QTHKENN[I] IN REFERENZ)     THEN VERGLEICH:=VERGLEICH+'?'

          ELSE

            BEGIN
              IF QTHKENN[I] IN ['+','-']     THEN VERGLEICH:=VERGLEICH+'V';
              IF QTHKENN[I] ='/'             THEN VERGLEICH:=VERGLEICH+'/';
              IF QTHKENN[I] =':'             THEN VERGLEICH:=VERGLEICH+':' ;
              IF QTHKENN[I] =Pkt              THEN VERGLEICH:=VERGLEICH+Pkt ;
              IF QTHKENN[I] IN ['0'..'9']    THEN
                BEGIN
                  P:=LENGTH(VERGLEICH);
                  IF VERGLEICH[P]<>'Z'      THEN VERGLEICH:=VERGLEICH+'Z';
                END;
            END;

          END;

        (* Vorzeichenkennungen fuer Schreibfaule nachtragen *)

        IF VERGLEICH[1]='Z' THEN Insert('V',VERGLEICH,1);
        P:=Pos('/',VERGLEICH)+1;
        IF VERGLEICH[P]='Z' THEN Insert('V',VERGLEICH,P);

        (* Abfrage ob Vergleichsraster einem der gueltigen *)
        (* Raster entspricht                               *)

            STATUS:=False;
            FOR I:=1 to 12 do
              STATUS:=STATUS OR (VERGLEICH = RASTER[I]);

    END

  ELSE STATUS := FALSE;

  (* 3. Zeichenkette in Koordinaten umwandeln wenn in Ordnung *)

  IF STATUS THEN
  BEGIN
    P:=POS('/',QTHKENN);
    OES:=Copy(QTHKENN,1,P-1);
    NOE:=Copy(QTHKENN,P+1,(LAENGE-P));
    IF POS(Pkt ,OES) > 0 THEN VAL(OES,OESLAE,P)
                        ELSE OESLAE := GMS_UMW(OES);
    IF POS(Pkt ,NOE) > 0 THEN VAL(NOE,NOEBRE,P)
                        ELSE NOEBRE := GMS_UMW(NOE);
    IF ABS(NOEBRE) > 90  THEN STATUS  := False;
    IF ABS(OESLAE) > 180 THEN STATUS := False;
  END;

END;



Procedure QTH_ENTFG_RICHTG (QTH1,QTH2 : Str20;
                            var ENTFG,
                                RICHTG : REAL;
                            var STATUS : Boolean);

Var QTH        : Array[1..2] of Str20;
    Winkel     : Array[1..4] OF Real;
    I          : Byte;
    K          : ShortInt;
    LAENGE     : Byte;

BEGIN
  QTH[1] := QTH1;
  QTH[2] := QTH2;
  K := -1;
  STATUS := true;

  for i := 1 to 2 do if STATUS then
  begin
    LAENGE := length(QTH[I]);
    K := K + 2;
    if QTH[I][1] in ['+','-','0'..'9'] then
    begin
      GRAD_UMW(QTH[I],WINKEL[K],WINKEL[K+1],STATUS);
    end else if LAENGE = 6 then
    begin
      NEU_IN_WINKEL(QTH[I],WINKEL[K],WINKEL[K+1]);
    end else STATUS:=False;
  end;

  if STATUS then
    ENTFERNUNG_RICHTUNG(WINKEL[1],WINKEL[2],WINKEL[3],WINKEL[4],ENTFG,RICHTG);
End;

var parmanz,parmpos:word;
Function ParmStr  (Nr : Byte; VC : char; Zeile : String) : String ;
Var      i,i1,
         i2,i3 : Byte;
         Hstr  : String;
Begin
  if Zeile > '' then
  begin
    i2 := 0;
    i3 := 254;
    While (ord(Zeile[0]) > 0) and (Zeile[1] = VC) do
    begin
      delete(Zeile,1,1);
      inc(i2);
    end;

    Hstr := '';
    i1 := 1;
    for i := 1 to Ord(Zeile[0]) do
    begin
      if Nr = i1 then if Zeile[i] <> VC then
      begin
        Hstr := Hstr + Zeile[i];
        i3 := i;
      end;
      if (Zeile[i] = VC) and (Zeile[i-1] <> VC) then inc(i1);
    end;
    While (Hstr[0] > #0) and (Hstr[Ord(Hstr[0])] = ' ') do Hstr[0] := Chr(Ord(Hstr[0])-1);
    While (Hstr[0] > #0) and (Hstr[1] = ' ') do delete(Hstr,1,1);
    ParmAnz := i1;
    ParmPos := Byte(i3 + i2 - length(Hstr) + 1);
    ParmStr := Hstr;
  end else
  begin
    ParmAnz := 0;
    ParmPos := 0;
    ParmStr := '';
  end;
End;


Procedure Compute_QTH ( Var Zeile : String );
Const   DXC = 'DXC.DAT';

Var     f    : system.Text;
        Flag : Boolean;
        i,l,
        AnzP : Byte;
        Diff : ShortInt;
        Entf,
        Azim : Real;

        Dstr : String[3];
        Sstr : String[6];
        Tstr : String[8];
        Fstr : String[13];
        QTH  : String[20];
        Nstr : String[40];
        Lstr,
        Rstr,
        Hstr : String;
Begin
  Hstr := ParmStr(3,' ',Zeile);
  if Hstr[length(Hstr)] = ':' then
  begin
    Flag := false;
    Assign(f,qrvpath + DXC);
    Reset(f);
    IF IOResult=0 THEN
    begin
      Readln(f,Hstr);
      QTH := ParmStr(4,' ',Hstr);
      Fstr := ParmStr(5,' ',Zeile);
      l := 0;
      While not Eof(f) do
      begin
        Readln(f,Hstr);
        Lstr := ParmStr(1,':',Hstr);
        Sstr := ParmStr(1,Km,Lstr);
        ParmAnz := AnzP;
        i := 0;
        Repeat
          inc(i);
          Sstr := ParmStr(i,Km,Lstr);
          if (pos(Sstr,Fstr) = 1) and (ord(Sstr[0]) > l) then
          begin
            Flag := true;
            l := ord(Sstr[0]);
            Rstr := Hstr;
          end;
        Until i >= AnzP;
      end;
      Close(f); IF IORESULT=0 THEN;
     
      if Flag then
      begin
        Lstr := ParmStr(1,':',Rstr);
        Zeile := EFillStr(27,' ',ParmStr(2,':',Rstr));
        Zeile := Zeile + 'Zone' + ':' + SFillStr(3,' ',ParmStr(3,':',Rstr)) + B2 + 'Dist' + ':';
        Lstr := ParmStr(4,':',Rstr);
        Dstr := ParmStr(3,';',Lstr);
        i := pos(Pkt,Dstr);
        if i > 0 then Dstr := copy(Dstr,1,i-1);
        Diff := ShortInt(str_int(Dstr));
        Tstr := Uhrzeit;
        Tstr := UtcZeit;
        i := str_int(copy(Tstr,1,2));
        i := i + 24 + Diff;
        While i > 23 do i := i - 24;
        Tstr := SFillStr(2,'0',int_str(i)) + ':' + copy(Tstr,4,2);
        QTH_ENTFG_RICHTG(QTH,ParmStr(2,';',Lstr) + '/' +
                             ParmStr(1,';',Lstr),Entf,Azim,Flag);
        if Flag then
        begin
          Zeile := Zeile + SFillStr(6,' ',int_str(Round(Entf))) + ' ' + 'km' + B3 + 'Beam' + ':' +
                           SFillStr(4,' ',int_str(Round(Azim))) + '' +
                           B3 + '(' + Tstr + ')';
        end;
      end else Zeile := '';
    end else WishDXC := false;
  end else Zeile := '';
End;
{$ENDIF}

(*
 *  Diese Prozedur verarbeitet alle Tastatur-Eingaben im normalen
 *  Terminalmodus, wird von HandleKeyBoard aufgerufen (s.u.)
 *)

PROCEDURE HandleTermKey;
VAR taste    : char;
        B,old: BYTE;
    Hilfstr  : STRING[80];
    HilfByte : BYTE;
        S    : STrinG;
BEGIN
  (* Tastencode lesen (entweder von KeyBoard oder aus Makro, siehe
   * KEYMACRO.XReadKey
   *)
   Taste:=XReadKey;

  (*
   * Handelt es sich um einen Hotkey ?
   * Wenn ja, Makro laden (KEYMAKRO.PAS), und ursprngliche
   * funktion nicht ausfhren (durch exit).
   *)
  IF taste<>#0 THEN
     IF KmacAscii(taste) THEN
	Exit;
   CASE Taste OF
     (*
     * Bei Eingabe von ESC wird im aktuellen Vorschreib-Fenster
     * am Anfang der aktuellen Zeile ein : eingefgt, wenn keines
     * dort stand, ansonsten wird es wieder entfernt.
     * (Befehlsmodus)
      *)
     #27	  : 
     WITH vorschreib[channel]^ DO
     BEGIN
	IF (buf[y][1]=':') and (buf[y][0]>#0) THEN
	BEGIN
	   delete(buf[y],1,1);
	   IF X>1 THEN DEC(X);
	END
	ELSE
	BEGIN
	   insert(':',buf[y],1);
	   IF X<80 THEN inc(x);
	END;
	prints(1,pvorschreib+y-1-offs,buf[y],fvorschreib);	
     END;
     (*
      * Backspace/^H:
      * Letztes Zeichen lschen.
      *)
     #8		  : {Backspace}
     WITH Vorschreib[channel]^ DO
       IF x>1 THEN
       BEGIN
	  DEC(x);
	  Delete(buf[y],x,1);
	  prints(x,pvorschreib+y-1-offs,copy(buf[y],x,255)+' ',fvorschreib);	
	 
 
       END;
     
     (*
     * ^Y
     * Die aktuelle Zeile komplett lschen.
      *)
     #25	  : {Control-Y}
     WITH Vorschreib[channel]^ DO
     BEGIN
	prints(1,pvorschreib+y-1-offs,stringD(' ',length(buf[y])),fvorschreib);	

	buf[y]:='';
	x:=1;
	
     END;
     (*
     * CR:
     * Wenn das erste Zeichen ein : ist, dann die Zeile als Befehl
     * auswerten, ansonsten die Zeile abschicken, wenn eine Verbindung
     * besteht.
      *)
     #13	  : {Return}
     WITH Vorschreib[channel]^ DO
     BEGIN
	X:=1;
	IF (Buf[y][1]=':') and (Length(buf[y])>0) THEN
	BEGIN
	   s:=copy(buf[y],2,255);
	   InterPret_cmd(channel,s,0);
	END
	ELSE
	BEGIN
	   PutData(channel,Buf[y]+#13);
           (* Druckausgabe... nicht getestet... *)
	   IF PRINTING=channel THEN
	   BEGIN
	   BEGIN
	      WriteLn(lst,buf[y]);
	      IF IORESULT<>0 THEN
	      BEGIN
		 PopUP('Printer not ready, printing aborted');
		 PRINTING:=0;
	      END;
	   END;
	   END;       
	END;  
	IF y<10 THEN
	   INC(y) ELSE
	   BEGIN
	      FOR B:=1 TO 9 DO buf[b]:=buf[b+1];
	      Buf[y]:='';
	   END;
	(*
	 * HoldCmdMode ist 1, wenn der Anwender wuenscht, da der
	 * Befehlsmodus nach eingabe eines Befehle aktiv bleibt.
	 *)
	IF (HoldCmdMode>0) AND (buf[pred(y)][1]=':') AND (buf[y]='') THEN
	BEGIN
	   BUF[y]:=':';
	   x:=2;
	END ELSE
	   IF (KS[channel]<>NIL) AND (buf[y]='') THEN
	      buf[y]:=KS[channel]^.prefix;
	x:=succ(length(buf[y]));
	IF (y>4) AND ((y-offs)>4) THEN offs:=y-4;
	DrawVorschreib;
     END;
     (*
     * Alle sonstigen Zeichen werden direkt in den Vorschreib-Puffer
      * eingefgt.
     *)
#1..#7,#9..#12,#14..#24,#26,#28..#255 : BEGIN
	WITH Vorschreib[channel]^ DO
	BEGIN
	   IF ins_mode THEN
	   BEGIN
	      Insert(taste,buf[y],x);
	      prints(x,pvorschreib+y-1-offs,copy(buf[y],x,255),fvorschreib);	
	      inc(x);
	   END
	   ELSE
	   BEGIN
	      buf[y][x]:=taste;
	      IF x>Length(buf[y]) THEN
		 x:=Length(buf[y]);
	      prints(x,pvorschreib+y-1-offs,copy(buf[y],x,255),fvorschreib);	
	      inc(x);
	   END;
	   (*
	    * Wenn die Zeile laenger als 74 Zeichen geworden ist,
	    * dann wird ein Zeilenvorschub ausgelst.
	    *)
	   IF (length(buf[y])>74) and (buf[y][length(buf[y])]<>' ') THEN
	   BEGIN
	      B:=length(buf[y]);
	      WHILE (buf[y][b]<>' ') and (B>1) DO DEC(B);
	      IF B>1 THEN
	      BEGIN
		 HilfStr:=Copy(buf[y],b+1,255);
		 delete(buf[y],b,255);
		 putdata(channel,buf[y]+#13);
		 IF Y<10 THEN
		    INC(Y) ELSE
		       FOR B:=1 TO Y-1 DO buf[b]:=buf[b+1];
		 IF (KS[channel]<>NIL) THEN
		    buf[y]:=KS[channel]^.prefix+HilfStr ELSE
		       buf[y]:=hilfstr;
		 x:=length(buf[y])+1;
		 IF (y>4) AND ((y-offs)>4) THEN offs:=y-4;
		 DrawVorschreib;

	      END;
	   END;
	   IF length(buf[y])=80 THEN
	   BEGIN
	      X:=1;
	      IF y<10 THEN
		 INC(y) ELSE
		 BEGIN
                 FOR B:=1 TO 9 DO buf[b]:=buf[b+1];
		    buf[10]:=KS[channel]^.prefix;
		 END;
	       DrawVorschreib;

	   END;
	END;
     END;
    (*
     * Sondertasten:
     *)
     #0		  : BEGIN
	taste:=XReadKey;
	(*
	 * ALT-* aktiviert die Pulldownmenues.
	 * Das Array hotkeys[] ist in MCUTMEN.PAS initialisiert.
	 *)
	IF taste=hotkeys[1] THEN DoMenu(1) ELSE
	   IF TASTE=hotkeys[2] THEN DoMenu(2) ELSE
             IF taste=hotkeys[3] THEN DoMenu(3) ELSE
		IF taste=hotkeys[4] THEN DoMenu(4) ELSE
		   IF taste=hotkeys[5] THEN DoMenu(5) ELSE
                    IF taste=hotkeys[6] THEN DoMenu(6) ELSE
		       CASE Taste OF
			 (*
            * ALT-M:
            * Schaltet in den Monitor-Modus um.
            *)
           #50:BEGIN
                 ConsoleState:=CONS_MONI;
	        {$IFNDEF linux}
                 video.Fill(1,pqsowin+bigmoniwinsize+1,80,_zeilen,' ',0);
                {$ENDIF}
	         MoniBuf^.resize(pqsowin,pqsowin+bigmoniwinsize);
                 MoniBuf^.showbuf;
               END;
           (*
            * ->
            * Cursor nach rechts verschieben.
            *)
           #77:{Pfeil rechts}
               WITH Vorschreib[channel]^ DO
               IF X<length(buf[y])+1 THEN INC(x);
           (*
            * <-
            * Cursor nach links verschieben.
            *)
           #75:{Pfeil links}
               WITH Vorschreib[channel]^ DO
               IF X>1 THEN DEC(x);
           (*
            * HOME/POS1
            * Cursor in erste Spalte setzen
            *)
           #71:{POS1}
               WITH Vorschreib[channel]^ DO
                 X:=1;
           (*
            * END
            * Cursor ans ende des Eingabestrings setzen
            *)
           #79:{END}
               WITH Vorschreib[channel]^ DO
                 X:=Length(buf[y])+1;
           (*
            * Pfeil abwrts
            * EIne Zeile runter
            *)
           #80:{pfeil unten}
               WITH Vorschreib[channel]^ DO
               BEGIN
                 IF y<10 THEN inc(y);
                 IF (y>4) AND ((y-offs)>4) THEN
		 BEGIN   
		    offs:=y-4;
		    DrawVorschreib;
		 END;
                 IF X>(Length(buf[y])+1) THEN
                   x:=length(buf[y])+1;
               END;
           (*
            * Pfeil aufwrts
            * Eine Zeile hoch
            *)
           #72:{pfeil oben}
               WITH Vorschreib[channel]^ DO
               BEGIN
                 IF Y>1 THEN
                 BEGIN
                   DEC(y);
                   IF (y<7) AND (y<=offs) THEN
                   BEGIN
		      offs:=y-1;
		      DrawVorschreib;
		   END;   
                 END;
                 IF X>(Length(buf[y])+1) THEN
                   x:=length(buf[y])+1;
               END;
           (*
            * PGUP
            * Im Scrollbuffer aufwrts bewegen, wenn shift
            * gedrckt ist, eine Zeile, sonst eine Seite.
            *)
           #73:{pgup}
               IF ScreenWriteOk THEN
		  {$IFNDEF LINUX}
		  IF shift(true) or shift(false) THEN
                   QSObuf[channel]^.PageUp(1)
		  ELSE
		  {$ENDIF}   
                   QSObuf[channel]^.PageUp(qsowinsize-1);
           (*
            * PGDN
            * Im Scrollbuffer abwrts
            *)
           #81:{pgDn}
               IF ScreenWriteOk THEN
                 {$IFNDEF LINUX}
		 IF shift(true) or shift(false) THEN
                   QSObuf[channel]^.PageDown(1)
		 ELSE
		 {$ENDIF}   
                   QSObuf[channel]^.PageDown(qsowinsize-1);

           (*
            * INS/EINFG
            * Zwischen Einfuege/Ueberschreib-Modus umschalten und
            * den Cursor entsprechend ndern
            *)
           #82:{insert}
               BEGIN
                 ins_mode:=NOT ins_mode;
                 IF ins_mode THEN Cursor(2) ELSE
                  Cursor(1);
               END;
           (*
            * DEL/ENTF
            * Das Zeichen ber dem Cusror lschen
            *)
           #83:{del}
               WITH Vorschreib[channel]^ DO
               BEGIN
                 Delete(buf[y],x,1);
		 prints(x,pvorschreib+y-1-offs,copy(buf[y],x,255)+' ',fvorschreib);	
               END;
           #115:{strg-rechts}    inc(flexnet_getsabm_delay);
           #116:{STRG-links}    dec(Flexnet_getsabm_delay);
           (*
            * Die Kombination aus STRG- und F-Taste schickt eine
            * Text-Datei aus dem Texte-Verzeichnis aus.
            * Dabei werden Makros expandiert.
            *)
           #94..#103:{Strg-F1 bis STRG-F10}
                     Begin
                       str(byte(taste)-93,hilfStr);
                       {help(channel,'F'+HilfStr,'FIXTEXT');}
                       SendTermMacroFile(channel,textpath+'F'+hilfstr);
                      end;
           (*
            * F-Tasten
            * Zwischen den Kanlen umschalten
            *)
           #$54..#$5D:BEGIN
                        {PrintS(1,1,'bah!',7);READLN; }
                        current_spy:=byte(taste)-$53;
                        if consolestate<>CONS_SPY THEN
                        BEGIN
                          startspymode;
                        END;  
                        spyredraw;
                    END;
           #59..#68:{F1-F10}
		       Begin
		{$IFNDEF LINUX}	  
                      IF shift(true) or shift(false) THEN
                      BEGIN
                      END  
		      ELSE
		{$ENDIF}	 
                      BEGIN
                        hilfbyte:=byte(taste)-58;
                        old:=channel;
                        IF ((channel mod 10)=hilfbyte) OR ((channel mod 10=0) AND (hilfbyte=10)) THEN
                        BEGIN
                          IF (channel+10) >maxterminal THEN
                            channel:=hilfbyte
                          ELSE
                            inc(channel,10);
                        END ELSE
                        BEGIN
                          Channel:=(channel div 10)*10+hilfbyte;
                          IF Channel>maxterminal THEN
                            channel:=hilfbyte;
                        END;
                        IF channel>maxterminal THEN
                          channel:=old;
                        IF KS[channel]<>NIL THEN
                           KS[channel]^.FLAGS:=KS[channel]^.FLAGS AND NOT KS_CHANGED;
                        Drawbuf;
			 DrawVorschreib;DrawStatus1;DrawStatus2; 
                      END;  
                    end;
            #45:MCUTEndeDlg;

         END;
      END;
  END;
END;


(*
 * Wenn das grosse Monitorfenster aktiv ist, werden hier die
 * Tastatureingaben abgearbeitet.
 *)

PROCEDURE MoniHandleKey;
VAR taste:CHAR;
BEGIN
  (*
   * Tastaturcode einlesen, via KEYMACRO.PAS
   *)
  taste:=Xreadkey;
  CASE taste OF
    (*
     * ESC und CR kehren auf den zuletzt benutzten Kanal
     * zurck.
     *)
    #27,#13:BEGIN
          ConsoleState:=0;
          MoniBuf^.Resize(pmoni,pmoni+moniwinsize);
          Redrawscreen;
        END;
    (*
     * Save-File ffnen
     *)
    'S':BEGIN
          (* MoniSaveDlg; *)
        END;
    (*
     * Einstellungen
     *)
    'O':BEGIN
          (* MoniSettingsDlg *)
        END;
    (*
     * Sondertasten
     *)
    #0:BEGIN
        taste:=Xreadkey;
        CASE taste OF
         (* Scrollen *)
         #80:{pfeil unten}
               MoniBuf^.PageDown(1);
         #72:{pfeil oben}
               MoniBuf^.PageUp(1);
         #73:{pgup}
             IF ScreenWriteOk THEN
                 MoniBuf^.PageUp(bigmoniwinsize);
         #81:{pgDn}
             IF ScreenWriteOk THEN
                 MoniBuf^.PageDown(bigmoniwinsize);
         #59..#68:{F1-F10}
                Begin
                 IF (byte(taste)-58) <= MaxTerminal THEN
                   Channel:=byte(taste)-58;
                   ConsoleState:=0;
                   MoniBuf^.Resize(pmoni,pmoni+moniwinsize);
                   Redrawscreen;
                END;

       END;
    END;
  END;
END;

(*
 * Hierher verzweigt das Hauptprogramm MCUT.PAS, wenn ein
 * Tastaturereignis vorliegt, oder noch Zeichen im Makropuffer
 * vorliegen.
 *)

PROCEDURE DoKeyboard;
VAR d:STRING;
BEGIN
  IF XKeyPressed THEN MCUTisIDLE:=FALSE;
  IF PopUP_aktiv THEN
  BEGIN
    IF (long-popup_start)>=1 THEN
      PopNext;
  END ELSE
  Case ConsoleState OF
    CONS_TERM: HandleTermKey;
    {$IFDEF EDITOR}
    CONS_EDIT: EditHandleKey;
    {$ENDIF}
    {3: HandleMHKey;  }
    CONS_DIALOG:
       BEGIN
         DlgHandleKey;
         IF ConsoleState<>4 THEN
         CASE which_dialog OF
           0  : {Setup_Dlg_done};
           1:SendAutoDlg_Auswert;
           2  : ReceiveTextDlg_Auswert;
           3  : SendTextDlg_Auswert;
           4  : KanalSettingsDlg_Auswert;
           5  : ReceiveAutoDlg_Auswert;
           6  : TNCSettingsDlg_Auswert;
           7  : GeneralSettingsDlg_Auswert;
           8  : PathSettingsDlg_Auswert;
           9  : TerminalSettingsDlg_Auswert;
          11  : MCUTEndeDlg_Auswert;
          12  : UmlautSettingsDlg_Auswert;
          13  : CallChangeDlg_Auswert;
          14  : UserSettingsDlg_Auswert;
          15  : UserSettingsDlg2_Auswert;
          16  : UserSettingsRemotesDlg_Auswert;
          {$IFDEF EDITOR}
          18  : EditLadenDlg_AUswert;
          19  : EditSaveAsDlg_Auswert;
          20  : EditKillDlg_Auswert;
          22  : EditPostDlg_Auswert;
          {$ENDIF}
          21  : ReceiveOverWriteDlg_AusWert;
          23  : PrioDlg_Auswert;
          24  : MonitorDlg_Auswert;
          25  : FlexNetDlg_Auswert;
          26  : ScreenDlg_Auswert;
          {$IFDEF PGP}
          30  : PGPsetDlg_Auswert;
          31  : PGPSendPkDlg_Auswert;
          32  : PGPEditTrustDlg_Auswert;
          33  : PGPCertifyDlg_Auswert;
          {$ENDIF}
	   34 : ;
         END;
       END;
    {$IFDEF HELP}
    CONS_HELP:
      IF NOT HelpHandleKey THEN
      BEGIN
        IF HelpIndex THEN
        BEGIN
          ConsoleState:=6;
        END ELSE
        BEGIN
          Write(#7#7);
          ConsoleState:=LastConsoleState;
          PopNext;
          onlhelp.releasememory;
        END;
      END;
    6:IF NOT HelpHandleKey THEN
      BEGIN
        ConsoleState:=LastConsoleState;
        Redrawscreen;
        PopNext;
        onlhelp.releasememory;
      END;
    {$ENDIF}
    7:BEGIN
      END;
    (*
     * Monitor...
     *)
    CONS_MONI:MoniHandleKey;
    CONS_DIR:IF NOT GETDIRECTORY(d) THEN
      BEGIN
        IF D<>'<ESC>' THEN
        BEGIN
          DlgData[1]:=D;
          CASE Which_FileSelect OF
            1:SendAutoDlg_Auswert;
            2:ReceiveAutoDlg_Auswert;
            3:ReceiveTextDlg_Auswert;
            4:SendTextDlg_Auswert;
          END;
        END;
        ConsoleState:=LastConsoleState;
      END;
    CONS_MH:MHHandleKey;  
    CONS_UNPROTO:UnProtoHandleKey;
    CONS_SPY:SPYHandleKey;
    CONS_BBSLIST:BBSLISTHandleKey;
  END;
END;

(*
 * Diese Routine ueberprueft, ob eine connect/reconnect Meldung eingetroffen
 * ist, und wenn ja, ob sie akzeptiert werden soll.
 *)

FUNCTION CheckCon(c:byte;s:string):BOOLEAN;
VAR b:BYTE;tmp:string[30];err:integer;
BEGIN
  CheckCon:=FALSE;
  (*
   * Sollen bei der aktuellen Gegenstation connect-meldungen
   * ausgewertet werden?
   *)
  IF (KS[c]^.FLAGS AND KS_CONNECT) <> 0 THEN
  BEGIN
    B:=POS('onnected to ',s);
    IF (b>0) AND (POS('econnected',s)=0) THEN
    BEGIN
      (*
       * Idents rausfiltern.
       *)
      tmp:=gross(copy(s,b+12,255));
      if pos(' ',tmp)>0 THEN
        tmp:=copy(tmp,1,pos(' ',tmp)-1);
      if pos(':',tmp)>0 THEN
        tmp:=copy(tmp,pos(':',tmp)+1,255);
      WHILE (tmp[0]>#0) AND (NOT (tmp[length(tmp)] IN ['0'..'9','A'..'Z','-'])) DO dec(byte(tmp[0]));

      (*
       * Falls es sich um ein Rufzeichen handelt,
       * - KS^.Path erweitern (hier wird auch der TYP abgespeichert, in ASCII
       * - Die neuen Userdaten laden
       *)

      IF checkcall(cutssid(tmp)) THEN
      BEGIN
        KS[c]^.path:=KS[c]^.path+KS[c]^.Call+'='+ConvertByteToString(KS[c]^.typ)+' ';
        KS[c]^.typ:=0;
        KS[c]^.call:=tmp;
        CheckCon:=TRUE;
        LoadTermUser(c);
      END;
      exit;
    END;
  END;
  IF (KS[c]^.FLAGS AND KS_RECONNECT) <> 0 THEN
  BEGIN
    B:=POS('econnected to ',s);
    IF (b>0) THEN
    BEGIN
      tmp:=copy(s,b+14,255);
      if pos(' ',tmp)>0 THEN
        tmp:=copy(tmp,1,pos(' ',tmp)-1);
      if pos(':',tmp)>0 THEN
        tmp:=copy(tmp,pos(' ',tmp)-1,255);
      WHILE (tmp[0]>#0) AND (NOT (tmp[length(tmp)] IN ['0'..'9','A'..'Z','-'])) DO dec(byte(tmp[0]));
      B:=POS(tmp+'=',KS[c]^.Path);

      (*
       * Wenn es sich um ein gueltiges Rufzeichen handelt,
       * - Gucken, ob in KS^.Path
       * - Typ wiederherstellen
       * - Flags wieder entsprechend anpassen
       * - Calls hinter dem aktuellen Call aus dem Pfad lschen
       *)

      IF (checkcall(cutssid(tmp)) AND (b>0)) THEN
      BEGIN
        KS[c]^.call:=tmp;
        tmp:=copy(KS[c]^.path,b-3,2);
	 system.val(tmp,ks[c]^.typ,err);
        KS[c]^.path:=copy(ks[c]^.path,1,b-1);
        CheckCon:=TRUE;
        LoadTermUser(c);
      END;
    END;
  END;
END;



PROCEDURE HandleTerm(ch:BYTE;S:STRING);
VAR B:BYTE;hlp:STRING;po:BYTE;l:LONGINT;f:FILE;
BEGIN
{$I-}
(* iad, dez '96: Printing. Not tested, as I don't own a printer *)
IF PRINTING=ch THEN
BEGIN
  IF NOT ((KS[ch]^.FLAGS AND KS_7PSAVE)<>0) THEN
  BEGIN
     WriteLn(lst,copy(s,1,length(s)-1));
     IF IORESULT<>0 THEN
     BEGIN
       PopUP('Printer not ready, printing aborted');
       PRINTING:=0;
     END;
   END;
END;       
IF CheckCon(ch,s) THEN
    BEGIN
      IF beep_at_connect THEN
      BEGIN
        sound(250);
        delay(75);
        sound(750);
        delay(50);
        nosound;
      END;
    END ELSE
      (* termscan.scan versucht das system der gegenseite zu
       *  identifizieren
       *)
    IF NOT termscan.scan(ch,s) THEN
(* Remote-Befehle beginnen mit // *)
    IF Copy(s,1,2)='//' THEN
    BEGIN
      s:=copy(s,3,255);
      err:=1;
      (* Wenn ein Leerzeichen im //-Befehl ist, wird ueberprueft, ob
       *  der String zwischen // und dem Leerzeichen eine Zahl ist.
       *  Es handelt sich dann um eine Nachricht, die auf einen anderen
       *  Kanal weitergegeben werden soll
       *)
      IF pos(' ',s)>0 THEN
	 system.val(copy(s,1,pos(' ',s)-1),b,err);
      str(ch,hlp);
      IF (err=0) THEN
        IF KS[b]<>NIL THEN
          IF (KS[b]^.FLAGS AND KS_BBS)=0 THEN
            PutData(b,#13+'<'+hlp+':'+KS[ch]^.Call+'> '+
              copy(s,pos(' ',s)+1,255)+#13);
      (*
       *  Wenn es keine Nachricht ist, wird es wohl ein Befehl sein,
       *  diese werden in MCUTREM.HandleNCMD geparst.
       *)       
      IF ERR>0 THEN
        HandleNcmd(s,ch);
    END ELSE
       {$IFDEF VOICE}
    IF (*VOICE*) TRUE THEN
    BEGIN
       
       IF POS('<LPC10>',S)>0 THEN
       BEGIN
	  IF ((KS[ch]^.FLAGS and FLAG_LPC10)<>0) AND (POS('<STOP>',S)<>0) THEN
	  BEGIN
	     close(KS[ch]^.LPC10File);
	     exec('lpc10','');
	  END ELSE
	  IF POS('<START>',S)>0 THEN
	  BEGIN
	     KS[ch]^.LastState:=KS[ch]^.Status;
	     KS[ch]^
	     
	  {$ENDIF}
    (* Ueberpruefung von PGP-Signaturen *)  
    IF  (SAVE_PUBLIC_KEYS OR CHECK_PGP_SIG) THEN
    BEGIN
      WITH KS[ch]^ DO
      BEGIN  
        IF ((PGPFlags AND PGP_SAVING_MSG)=0) AND
           ((POS('-----BEGIN PGP SIGNED MESSAGE-----',S)=1) OR
            (POS('-----BEGIN PGP SIGNATURE-----',S)=1)) THEN
        BEGIN
          IF PGPSave=NIL THEN NEW(PGPSave);
	  (* Einen eindeutigen dateinamen finden und eine
	   *  temporaer-Datei aufmachen.*)
          NewFileName(ch,qrvpath+'pgp'+PATH_SEP,hlp);
          ASSIGN(PGPSave^,qrvpath+'pgp'+PATH_SEP+hlp);
          REWRITE(PGPSave^);
          Writeln(PGPSave^,copy(s,1,length(s)-1));
          IF IORESULT<>0 THEN
            exit;
          PGPFlags:=PGPFlags OR PGP_SAVING_MSG;
          exit;
        END ELSE
        IF (PGPFlags AND PGP_SAVING_MSG)<>0 THEN
	BEGIN
	  (* Wir speichern erstmal jede Zeile der signierten Nachricht...*)
          WriteLn(PGPSave^,copy(s,1,length(s)-1));
	  (* ... inclusive der PGP-Tags, sobald die Signatur fertig ist..*)
          IF (POS('-----END PGP SIGNATURE-----',S)=1) THEN
	  BEGIN
	    (* .. wird die Datei geschlossen *)
            CLOSE(PGPSave^);
	    (* Evtl existiert bereits eine pgp.tmp, diese erstmal
	     * loeschen. Danach wird die temporaerdatei nach pgp.tmp
	     * umbenannt
	     *)
	     ASSIGN(f,temppath+'pgp.tmp');ERASE(f);
            IF IORESULT<>0 THEN;
	     RENAME(PGPSave^,temppath+'pgp.tmp');
            IF IORESULT<>0 THEN;
            DISPOSE(PGPSave);
            PGPSave:=NIL;
            PGPFlags:=PGPFlags AND NOT PGP_SAVING_MSG;
            ClrScr;
	    (* PGP aufrufen... *)
	     {$IFNDEF LINUX}
            SetMemTop(HeapPtr);
            SwapVectors;
            EXEC(GETENV('PGPPATH')+'PGP.EXE','+force +batchmode '+temppath+'PGP.tmp');
            SwapVectors;
            SetMemTop(HeapEnd);
            IF IORESULt<>0 THEN WRITE(#7);
	    {$ELSE}
	    (* !! fixme, pgp koennte auch woanders stehen *)
	     exec('/usr/bin/pgp','+force +batchmode '+temppath+'pgp.tmp');
	     {$ENDIF}
            WriteLn('Press any key to continue or wait 10 Seconds');
            l:=currixtime;
            REPEAT UNTIL (currixtime-l>10) OR (xkeypressed);
            IF xkeypressed THEN if xreadkey=#0 THEN xreadkey;
            Redrawscreen;
          END;
          exit;
        END;
      END;
    END;
    (* Wenn eine Mailbox erkannt wurde, wird nach CHECK und LIST
     *  Ausgaben gescannt *)
    IF (KS[Ch]^.FLAGS AND KS_BBS)<>0 THEN
        BEGIN
          BBSListHandle(S);
        END;
    IF (KS[ch]^.FLAGS AND KS_autosave)<>0 THEN
    BEGIN
      KS[ch]^.Laststatus:=7;
      IF (KS[ch]^.FLAGS AND KS_7psave)=0  THEN
      autobin(ch,s,savpath);
      po:=pos(' stop_7+.',s);
      IF po=1 THEN
        IF (savemode[ch]>0) AND ((KS[ch]^.FLAGS AND KS_7psave)<>0)THEN
        BEGIN
          WriteLn(savefile[ch]^,s);
          close(savefile[ch]^);
          IF KS[ch]^.AutoBinData<>NIL THEN
          BEGIN
            dispose(KS[ch]^.AutoBinData);
            KS[ch]^.AutoBinData:=NIL;
          END;
          BinResults(ch,0,0);
          dispose(savefile[ch]);
          savemode[ch]:=0;
          KS[ch]^.FLAGS:=KS[ch]^.FLAGS AND NOT KS_7PSAVE;
          KS[ch]^.FLAGS:= KS[ch]^.FLAGS OR KS_SHOWDATA;
          exit;
        END;
      po:=pos(' stop_text.',s);
      IF po=1 THEN
      IF (savemode[ch]>0) AND ((KS[ch]^.FLAGS AND KS_7psave)<>0) THEN
        BEGIN
          WriteLn(savefile[ch]^,s);
          close(savefile[ch]^);
          dispose(savefile[ch]);
          savemode[ch]:=0;
          BinResults(ch,0,0);
          KS[ch]^.FLAGS:=KS[ch]^.FLAGS AND NOT KS_7PSAVE;
          KS[ch]^.FLAGS:= KS[ch]^.FLAGS OR KS_SHOWDATA;
          exit;
        END;
      po:=pos(' go_7+.',s);
      IF po=1 THEN
        IF (savemode[ch]=0) THEN
        BEGIN
          po:=9;
	   system.val(copy(s,po,3),b,err);
          hlp:=ltrim(copy(s,20,8));
          find(hlp,'.',hlp,ein_s);
          hlp:=hlp+'.p'+toolbox.hex(b);
          MakeFnClean(hlp);
          ks[ch]^.filename:=klein(hlp);
          new(savefile[ch]);
          assign(savefile[ch]^,sevenpath+hlp);
          rewrite(savefile[ch]^);
          IF ioresult<>0 THEN
          BEGIN
            dispose(savefile[ch]);
            exit;
          END;
          WITH KS[ch]^ DO
	  BEGIN
	     {$IFDEF FPK}
	     toolbox.val('$'+copy(s,46,3),expected,err);
             {$ELSE}
	    val('$'+copy(s,46,3),expected,err);
	     {$ENDIF}
	     expected:=(expected+2)*70;
            transferred:=0;
            transferstart:=currixtime;
          END;
          savemode[ch]:=1;
          KS[ch]^.FLAGS:=KS[ch]^.FLAGS OR KS_7PSAVE;
          KS[ch]^.FLAGS:= KS[ch]^.FLAGS AND NOT KS_SHOWDATA;
          exit;
        END;
      po:=pos(' go_text.',s);
      IF po=1 THEN
        IF savemode[ch]=0 THEN
        BEGIN
          inc(po,10);
          hlp:=copy(s,po,length(s)-po);
          new(savefile[ch]);
          MakeFnClean(hlp);
          assign(savefile[ch]^,sevenpath+hlp);
          ks[ch]^.filename:=hlp;
          rewrite(savefile[ch]^);
          IF IOresult<>0 THEN
          BEGIN
            dispose(savefile[ch]);
            exit;
          END;
          savemode[ch]:=1;
          KS[ch]^.expected:=20000;
          KS[ch]^.transferred:=0;
          KS[ch]^.transferstart:=currixtime;
          KS[ch]^.FLAGS:=KS[ch]^.FLAGS OR KS_7PSAVE;
          KS[ch]^.FLAGS:= KS[ch]^.FLAGS OR KS_SHOWDATA;
          IF s[length(s)]=#13 THEN s:=s+#10;
          exit;
        END;
    END;
END;

END.






