(****************************************************************************)
(* Diese Unit stellt ein Interface zu den Moni* Units von DG9EP dar         *)
(* Dazu definiere ich mir einen Textdatei-Gertetreiber.                    *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(****************************************************************************)

UNIT MoniMCT;

INTERFACE
USES MCUTBUF;

(* diese Routine reicht den Aufruf eigentlich nur an Auswerten von Moni*
   weiter. Wegen der bersicht sind alle direkten schnittstellen zu DG9EP
   ausschliesslich in dieser Unit und nirgendwo anders. *)
PROCEDURE DumpMoni(header:STRING;VAR daten;len:WORD);

(* Diese Routine wird von STARTUP.InitMCUT aufgerufen und Assigned ein
    "buffer-file" mittels BufAssign *)

PROCEDURE InitMoniMCT;

(* Diese Routine verknpft ein Textfile-Handle mit einem
Scrollbuffer-Object von MCUT. Dadurch wird die einbindung in MCUT
ein kinderspiel. Spter koennte man durch einen einfachen Aufruf dieser
Routine auch noch jedem einzelnen Spy einen Scrollbuffer zuweisen.
*)
PROCEDURE BufAssign(VAR F:text;MBuf:PMBUF);

IMPLEMENTATION
USES IADVAR,MONITOR,DUMP,DOS,CRT,COMMON;

VAR
    MoniVirtualFile:TEXT;
    StrucHeader:t_hheader;

(* Es folgen als FAR deklarierte Treiber-Prozeduren fr meinen
   Textdatei-Treiber, diese werden dem FileHandle von BufAssign
   zugewiesen *)

PROCEDURE BufInOut(VAR F:text);far;
VAR S:STRING;VAR B,Sp:BYTE;
BEGIN
  WITH TextRec(F) DO
  BEGIN
    CASE mode OF
      {Was anderes sollte nicht auftreten... }
      fmOutput:
        BEGIN
          InOutRes:=0;
          S:='';
          FOR B:=0 to BufPos-1 DO
          BEGIN
            IF Buffer[b]<>#10 THEN
              S:=S+Buffer[B];
            IF Buffer[b]=#13 THEN
            BEGIN
              PMBuf(addr(UserData)^)^.WriteBuf(S,TextAttr);
              S:='';
            END;
          END;
          IF S<>'' THEN
            PMBuf(addr(UserData)^)^.WriteBuf(S,TextAttr);;
          BufEnd:=0;BufPos:=0;
        END;
     END;
  END;
END;

PROCEDURE BufFlush(VAR F:text);far;
VAR S:STRING;VAR B,Sp:WORD;
BEGIN
  WITH TextRec(F) DO
  BEGIN
    CASE mode OF
      {Was anderes sollte nicht auftreten... }
      fmOutput:
        BEGIN
          InOutRes:=0;
          S:='';
          FOR B:=0 to BufPos-1 DO
          BEGIN
            IF Buffer[b]<>#10 THEN
              S:=S+Buffer[B];
            IF Buffer[b]=#13 THEN
            BEGIN
              PMBuf(addr(UserData)^)^.WriteBuf(S,TextAttr);
              S:='';
            END;
          END;
          IF S<>'' THEN
            PMBuf(addr(UserData)^)^.WriteBuf(S,TextAttr);
          BufEnd:=0;BufPos:=0;
        END;
     END;
  END;
END;

PROCEDURE BufClose(VAR F:text);far;
BEGIN
InOutRes:=0;
END;

PROCEDURE BufOpen(VAR F:text);far;
BEGIN
  IF PMBuf(addr(TextRec(F).UserData)^)<>NIL THEN
  BEGIN
    textRec(F).Mode:=fmOutput;
    InOutRes:=0;
  END
  ELSE
  BEGIN
    WriteLn('Fehler');
    
    ExitCode:=251;
    InOutRes:=1;
  END;
END;


PROCEDURE BufAssign(VAR F:text;MBuf:PMBUF);
BEGIN
  With TextRec(F) DO
  BEGIN
    mode:=fmClosed;
    BufSize:=SizeOf(Buffer);
    BufPtr:=@Buffer;
    BufEnd:=0;
    BufPos:=0;
    OpenFunc:=@BufOpen;
    InOutFunc:=@BufInOut;
    FlushFunc:=@BufFlush;
    CloseFunc:=@BufClose;
    PMBuf(addr(UserData)^):=MBuf;
    name[0]:=#0;
  END;
END;

PROCEDURE DumpMoni(header:STRING;VAR daten;len:WORD);
VAR W:WORD;
BEGIN
  Auswerten(MoniVirtualFile, Header, t_aDaten(Daten), Len, strucHeader);
END;

PROCEDURE InitMoniMCT;
BEGIN
  BufAssign(MoniVirtualFile,MoniBuf);
  Reset(MoniVirtualFile);
  IF IORESULT<>0 THEN
  BEGIN
    WRite(#7#7);
    exit;
  END;
  TextAttr := 15;
  fShowAx      :=     TRUE;
  fShowPID     :=     TRUE;
  fAXBodyZeigen :=    TRUE; {* Info Text anzeigen *}
  fDatenBinaer :=     FALSE;

  fSpy         :=     FALsE;
  fBcRx        := NOT FALSE;
  fSpCompressDecoder := FALSE;

  fShowBC := TRUE;
END;
END.
