(****************************************************************************)
(* Bildschirmroutinen fr MCUT.                                             *)
(*                                                                          *)
(* Die Unit darf nicht als Overlay deklariert werden.                       *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(*                                                                          *)
(* IAD, feb 96                                                              *)
(****************************************************************************)

UNIT SCREEN; {Bildschirm-Routinen v. MCUT}

INTERFACE

  PROCEDURE ReDrawScreen;
  PROCEDURE DrawStatus1;
  PROCEDURE DraWStatus2;
  PROCEDURE DrawBuf;
  PROCEDURE DrawMenu;
  PROCEDURE DrawVorSchreib;
  PROCEDURE WriteBuf(c:BYTE;S:STRING;farbe:BYTE;dumm:byte);
  PROCEDURE WriteMoniBuf(S:STRING;farbe:BYTE;dumm:byte);
  PROCEDURE PopUp(s:STRING);
  PROCEDURE PopNext;

IMPLEMENTATION

USES IADVAR,Video,DOS,Toolbox,mystring,
     {$IFDEF EDITOR}
     EDITOR,
     {$ENDIF}
      HPUI,STARTUP,
      INPUT,
      CRT,DMCUT,SPYNEW,UNPROTO,MH,BBSLIST;

  (*
   *  Eine Queue in der alle PopUP() -Meldungen gespeichert werden.
   *  Sobald die letzte verschwindet, wird die naechste gezeigt (PopNext)
   *)

CONST
  PopUpQueue:PQueueRec=NIL;

(*
 *  Das ist eigentlich nur ein wrapper, der Uebersicht halber. Es
 *  wird HPUI.InitHPUI aufgerufen.
 *  Parameter: Keine
 *  Results: Keine
 *  Side-Effects: Keine
 *)
Procedure showmenu;
Begin
  InitHPUI(Menu,nil,nil);
end;


(*
 *  Die erste Statuszeile neu malen.
 *  Parameter: Keine
 *  Results: Keine
 *  Side-Efffects: Keine
 *)
PROCEDURE DrawStatus1;
VAR
   S,                (* in S wird die statuszeile aufgebaut und am stueck ausgegeben *)
   S2:STRING[80];
  B: BYTE;r1,r2,r3:REAL;long,tim:LONGINT;
BEGIN
  tim:=CurrIxTime;
  IF CRTSaveAktiv OR ((ConsoleState<>CONS_TERM) AND
			 ((ConsoleState<>CONS_DIALOG) AND (LastConsoleState=CONS_TERM))) THEN exit;
  (* Die Zeile mit Leerzeichen auffuellen *)
  fillchar(s[1],80,' ');
  IF KS[channel]<>NIL THEN
    s:=ConvertByteToString(channel)+':'+ks[channel]^.call
  ELSE
    s:=ConvertByteToString(channel)+':..........';
  (* Auf Position 14 springen *) 
  s[0]:=#14;
  IF KS[channel]<>NIL THEN
  BEGIN
    WITH KS[channel]^ DO
    BEGIN
      (* Wenn 7PLUS gespeichert wird, irgendetwas gesendet wird oder Autobin-RX
       * aktiv ist... *)
      IF ((FLAGS AND KS_7PSAVE<>0) OR (SendMode>0) OR
          (Status=14)) THEN
      BEGIN
	 (* ... wird der Fortschritts-Balken erzeugt *) 
        S:=S+'|';
        B:=round((transferred/(expected+1))*39);
        IF B>39 THEN b:=39;
        IF B<1 THEN b:=1;
        FillChar(S[16],b,'#');
        S[0]:=CHAR(16+39);
        S:=S+'|';
        IF Status=14 THEN
         S:=S+' BINRX' ELSE
        IF (FLAGS AND KS_7PSAVE)<>0 THEN
         S:=S+' 7+RX ' ELSE
        IF (sendmode=1) THEN
         S:=S+' TXTTX' ELSE
        IF (sendmode=2) THEN
         S:=S+' BINTX';
        S[0]:=#62;
        S:=S+'|';
        long:=tim;
        r1:=long-transferstart;
        r2:=transferred;
        r3:=expected;
        S:=S+MkTStr(
        ROUND((r1/(r2+1))*(r3-r2+1)));

        (*
        S:=S+' '+MkTStr(
        ROUND((tim-transferstart)/succ(transferred)*(expected-transferred)));
        *)
        S[0]:=#67;
        S:=S+'|';
        IF (LONG MOD 10)<2 THEN
        BEGIN
          STR(ROUND((r2/(r1+1))),S2);
          S:=S+S2+'cps';
        END ELSE
        IF (LONG MOD 10)<5 THEN
        BEGIN
          STR(ROUND((r2/(r3+1))*100),S2);
          S:=S+S2+'%';
        END ELSE
        IF (LONG MOD 10)<8 THEN
        BEGIN
          S:=S+MkTStr(long-transferstart);
        END ELSE
          S:=S+KS[channel]^.FileName;

      END ELSE
      BEGIN
        s:=JoinStr(s,name);
        s[0]:=#43;
        S:=S+'|';
        S:=S+ConvertByteToString(unack);
        S:=S+'|';
        S:=S+ConvertByteToString(tries);
        S:=S+'|';
        S:=S+TNCModeText[lstate];
        S:=S+'|';
        s[0]:=#70;
        IF SaveMode[channel]=1 THEN
          s[byte(s[0])]:='s'
        ELSE
          s[byte(s[0])]:='-';
        inc(byte(s[0]));
        IF compress=2 THEN
          s[byte(s[0])]:='c'
        ELSE
          s[byte(s[0])]:='-';
        inc(byte(s[0]));
        IF (FLAGS AND KS_AUTOSAVE)<>0 THEN
          s[byte(s[0])]:='a'
        ELSE
          s[byte(s[0])]:='-';
        inc(byte(s[0]));
        IF (FLAGS AND KS_7PSAVE)<>0 THEN
          s[byte(s[0])]:='7'
        ELSE
          s[byte(s[0])]:='-';
        inc(byte(s[0]));

        IF KS[channel]^.status=5 THEN
          s[byte(s[0])]:='w'
        ELSE
          s[byte(s[0])]:='-';
        IF (FLAGS AND KS_INACTIVE)<>0 THEN
          s[byte(s[0])]:='i'
        ELSE
          s[byte(s[0])]:='-';
        inc(byte(s[0]));
        IF (FLAGS AND KS_SYSOP)<>0 THEN
          s[byte(s[0])]:='!'
        ELSE
          s[byte(s[0])]:='-';
        inc(byte(s[0]));
      END;
    END;
  END ELSE
  BEGIN
    s[0]:=#70;
     IF SaveMode[channel]=1 THEN
     s[byte(s[0])]:='s'
    ELSE
      s[byte(s[0])]:='-';
    S:=S+'-----';
  END;
  s[0]:=#80;
  Prints(1,pStatus1,s,fStatusOben);
  IF (ConsoleState=CONS_DIALOG) AND (LastConsoleState=CONS_TERM) THEN DlgDraw;
END;

PROCEDURE DrawStatus2;
VAR S:STRING[80];
    S2,s3:STRING[20];
    st,mi,se,hu:word;
    b,c:byte;
BEGIN
   IF (CRTSaveAktiv) OR ((ConsoleState<>CONS_TERM) AND
			 ((ConsoleState<>CONS_DIALOG) AND (LastConsoleState=CONS_TERM))) THEN exit;
  fillchar(s[1],80,' ');
  s[0]:=#0;
  C:=0;
  For B:=1 to maxTerminal DO
  IF (KS[b]<>NIL) AND ((KS[b]^.Status>0) AND (KS[b]^.Status<50)
     AND (KS[b]^.Status<>6)) THEN
    BEGIN
      IF (KS[b]^.FLAGS AND KS_CHANGED)<>0 THEN
        Prints((c*10)+1,pstatus2,
        s+convertByteToString(b)+':'+cutssid(klein(KS[b]^.Call))+'  ',
        fstatusunten)
      ELSE
      IF (b=channel) THEN
        Prints((c*10)+1,pstatus2,
        s+convertByteToString(b)+'#'+cutssid(KS[b]^.Call)+'  ',
        (fstatusunten SHR 4)+(fstatusunten AND $F)*16)
      ELSE
        Prints((c*10)+1,pstatus2,
        s+convertByteToString(b)+':'+cutssid(KS[b]^.Call)+'  ',
        (fstatusunten));
      INC(c);
    END;
  fillchar(s[1],80,' ');
  s[0]:=#80;
  Prints((c*10)+1,pstatus2,copy(s,1,80-(c*10)),fstatusunten);
  GetDate(st,mi,se,hu);
  s2:=ConvertByteToString(se);
  AddChar(s2,'.');
  s3:=ConvertByteToString(mi);
  AddChar(s3,'.');
  s2:=s2+s3;
  AddChar(s2,'/');
  GetTime(st,mi,se,hu);
  s3:=ConvertByteToString(st);
  AddChar(s3,':') ;
  s2:=s2+s3;
  s3:=ConvertByteToString(mi);
  s2:=s2+s3;
  s2[0]:=#12;
  {Prints(68,pmenu,s2,lightgray+blue*16);}
END;

PROCEDURE DrawBuf;
BEGIN
  IF (CRTSaveAktiv) THEN exit;
  QSOBuf[channel]^.showbuf;
END;

PROCEDURE DrawVorschreib;
VAR B:BYTE;
    S:STRING[80];
BEGIN
  IF (CRTSaveAktiv) THEN exit;
  (*IF consolestate<>0 THEN exit;*)
  fillchar(s[1],80,' ');
  with vorschreib[channel]^ DO
  FOR B:=1+offs TO 4+offs DO
  BEGIN
    S[0]:=CHAR(80-BYTE(buf[B][0]));
    prints(1,pvorschreib+B-1-offs,buf[B]+s,fVorschreib);
  END;
END;

PROCEDURE DrawMenu;
BEGIN
END;

PROCEDURE ReDrawScreen;
BEGIN
  IF (CRTSaveAktiv) THEN
  BEGIN
    {video.Fill(1,1,80,_zeilen,' ',0);
    UpdateScreen;}
    exit;
  END;
  {$IFDEF EDITOR}
  IF (ConsoleState=CONS_EDIT) OR 
     ((ConsoleState=CONS_DIALOG) AND (Input.LastConsole=CONS_EDIT)) THEN
  BEGIN
   (* MoniBuf^.ShowBuf;
    DrawVorschreib;  *)
    DrawEditor;
    UpdateScreen;
  END ELSE
  {$ENDIF}
  IF (ConsoleState=CONS_TERM) OR 
     ((ConsoleState=CONS_DIALOG) AND
      (input.LastConsole=CONS_TERM)) THEN
  BEGIN
     
    DrawStatus1;
    DraWStatus2;
    DrawBuf;
    UpdateScreen;
    DrawVorSchreib;
    MoniBuf^.showbuf;
  END;
  IF (ConsoleState=CONS_MONI) OR 
    ((ConsoleState=CONS_DIALOG) AND (Input.LastConsole=CONS_MONI)) THEN
  BEGIN
    MoniBuf^.showbuf;
  END;
  IF (ConsoleState=CONS_DIR) THEN
   dmcut._fill;
  IF (ConsoleState=CONS_MH) OR 
    ((ConsoleState=CONS_DIALOG) AND (Input.LastConsole=CONS_MH)) THEN
  BEGIN
    MHReDraw;
  END;
  IF (ConsoleState=CONS_SPY) OR 
    ((ConsoleState=CONS_DIALOG) AND (Input.LastConsole=CONS_SPY)) THEN
  BEGIN
    SPYRedraw;
  END;
  IF (ConsoleState=CONS_UNPROTO) OR 
    ((ConsoleState=CONS_DIALOG) AND (Input.LastConsole=CONS_UNPROTO)) THEN
  BEGIN
    UnprotoReDraw;
  END;
  IF (ConsoleState=CONS_BBSLIST) OR 
    ((ConsoleState=CONS_DIALOG) AND (Input.LastConsole=CONS_BBSLIST)) THEN
  BEGIN
    BBSListRedraw;
  END;
  ShowMenu;
  IF ConsoleState=CONS_DIALOG THEN DlgDraw;
  UpdateScreen;
END;

PROCEDURE WriteBuf(c:BYTE;S:STRING;farbe:BYTE;dumm:byte);
CONST colchar:array[1..2] of CHAR=(#0,#255);
VAR B	: BYTE;
   fl	: BOOLEAN;
BEGIN
  IF c>MaxTerminal THEN EXIT;
  FOR B:=1 TO LENGTH(s) DO
     IF S[B]=#7 THEN S[B]:='.' ELSE
    IF S[B]=#10 THEN S[B]:='.'
{$IFDEF LINUX}
    ELSE
      IF (S[B]<#31)  AND (S[B]<>#13) AND (S[B]<>#27) THEN S[B]:='.'
    ELSE
      IF (S[B]>#128) AND (S[B]<#161) THEN S[B]:='.'
{$ENDIF}
    ;
  IF (KS[c]<>NIL) AND ((KS[c]^.Flags AND KS_7psave)=0) AND (KS[c]^.Status=7) THEN
  BEGIN
    IF (((rxclick=1)  AND ((KS[c]^.FLAGS AND KS_CHANGED) = 0) AND (channel<>c))
       OR ((rxclick=2)) AND (channel<>c))
       OR (rxclick=3) THEN
    BEGIN
      sound(100);
      delay(10);
      sound(200);
      delay(20);
      nosound;
    END;
  END;
  IF (c<>channel) and (KS[c]<>NIL) THEN
  BEGIN
    if (KS[c]^.FLAGS AND KS_CHANGED)=0 THEN
    BEGIN   
      KS[c]^.FLAGS:=KS[c]^.FLAGS OR KS_CHANGED;
      DrawStatus2;
    END ELSE KS[c]^.FLAGS:=KS[c]^.FLAGS OR KS_CHANGED;
  END;
     QSOBuf[c]^.WriteBuf(S,farbe);
  IF (CRTSaveAktiv) THEN
    exit;
  IF (Channel=C) AND ScreenWriteOk  AND ((consolestate=0)
     OR ((ConsoleState=CONS_DIALOG) AND (Input.LastConsole=0)) 
     OR ((ConsoleState=CONS_DIR) AND (LastConsoleState=CONS_TERM))
     AND NOT (ConsoleState=CONS_MONI)) THEN
    QSObuf[c]^.ShowBuf;
  IF ConsoleState=CONS_DIALOG THEN DlgDraw;
  IF ConsoleState=CONS_DIR THEN dmcut._fill;
END;

PROCEDURE WriteMoniBuf(S:STRING;farbe:BYTE;dumm:BYTE);

VAR B    : BYTE;
BEGIN
  FOR B:=1 TO LENGTH(s) DO
{$IFNDEF LINUX}    
    IF S[B]=#7 THEN S[B]:=#14 ELSE
{$ENDIF}       
    IF S[B]=#10 THEN S[B]:=#13
 {$IFDEF LINUX}
    ELSE
      IF (S[B]<#31)  AND (S[B]<>#13) AND (S[B]<>#27) THEN S[B]:='.'
    ELSE
      IF (S[B]>#128) AND (S[B]<#161) THEN S[B]:='.'
{$ENDIF}
	 ;
  MoniBuf^.WriteBuf(S,Farbe);
  IF consolestate<>1 THEN
  BEGIN
    IF (ScreenWriteOk) AND (NOT CRTSaveAktiv) THEN
      MoniBuf^.ShowBuf;
    IF ConsoleState=4 THEN DlgDraw;
  END;  
END;

PROCEDURE PopUp(s:STRING);
BEGIN
  IF popup_aktiv or (ConsoleState>4) THEN
  BEGIN
    PushQueue(PopUpQueue,0,s);
    exit;
  END;
  ScreenWriteOk:=False;
  popup_aktiv:=TRUE;
  popup_start:=currixtime;
  video.Fill(40-(length(s) DIV 2)-2,7,40+(LENGTH(s) DIV 2)+2,11,' ',fPopUp);
  Prints(40-(length(s) DIV 2),9,s,fPopUp);
END;

PROCEDURE PopNext;
VAR s:STRING;
    typ:BYTE;
BEGIN
  IF ConsoleState>4 THEN exit;
  PopUp_Aktiv:=FALSE;
  ScreenWriteOk:=TRUE;
  RedrawScreen;
  IF PopUpQueue<>NIL THEN
  BEGIN
    PopQueue(PopUpQueue,typ,s);
    PopUp(s);
  END
END;
END.
















