(****************************************************************************)
(* INIT und DONE-Routinen fr MCUT.                                         *)
(* Unter anderem                                                            *)
(*   * Programminitialisierung und -ende                                    *)
(*                                                                          *)
(* Die Unit darf als Overlay deklariert werden.                             *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(*                                                                          *)
(****************************************************************************)

{$R-}
{$UNDEF BETA}
UNIT STARTUP;

INTERFACE
USES HPUI;

  {PROCEDURE INITMCUT
    Grundlegende Programm-Initialisiertung, darf *NUR* vom Kern aufgerufen
   werden}
  PROCEDURE InitMCUT;

  {PROCEDURE DoneMCUT;
   Programm-Beendigung, Dateien schliessen, etc.
   Darf *NUR* vom Kern aufgerufen werden}
  PROCEDURE DoneMCUT;

  PROCEDURE Attach_TNC;

  Procedure InitMenu;
  Procedure Showmenu;

Var menu:Menuptr;

IMPLEMENTATION

USES MCUTBUF,QUICKSET,IADVAR,WGTCRC,
     TOOLBOX,CRT,SCREEN,MYSTRING,DOS,
     {$IFNDEF LINUX}
     MEMORY,
     {$ENDIF}
     {$IFDEF HELP}
     ONLHELP,
     {$ENDIF}
     {$IFDEF BOX}
     BOXSTART,
     {$ENDIF}
     {$IFDEF CONVERS}
     CONVERS,
     {$ENDIF}
     {$IFDEF WA8DED}
     V24DRV,TNC,
     {$ENDIF}
     {$IFDEF FLEXNET}
     FLXAPP,
     {$ENDIF}
   TERMUSER,PACKET,KEYMAKRO,DIALOG2,RESTORE,MCUTLIB2,UNPROTO
     {$IFDEF M},MoniMCT {$ENDIF};

TYPE Buftype=ARRAY[1..$FFFF] OF BYTE;
     arr=ARRAY[0..3] OF CHAR;




PROCEDURE InitUmlautTable;
VAR B:BYTE;
BEGIN
  FOR B:=0 to 15 DO
  BEGIN
    UmlautTable[b]:=NIL;
    UmlautDescription[b]:=NIL;
  END;
  New(UmlautTable[0]);
  UmlautTableAnz:=0;
  FOR B:=0 to 255 DO UmlautTable[0]^[b]:=char(b);
  new(UmlautDescription[0]);
  UmlautDescription[0]^:='IBM ASCII';
END;



PROCEDURE WriteCopyRight;
VAR l:LONGINT;
BEGIN
  WriteLN('MCUT '+version+', Copyright (C) 1993-2000 Jochen Sarrazin and Hans-Peter Zorn');
  WriteLN('With code contributed by many others, see the file CREDITS for details');
  WriteLN;
  WriteLN('  This program is free software; you can redistribute it and/or modify');
  WriteLN('  it under the terms of the GNU General Public License as published by');
  WriteLN('  the Free Software Foundation; either version 2 of the License, or');
  WriteLN('  (at your option) any later version.');
  WriteLN;  
  WriteLN('  This program is distributed in the hope that it will be useful,');
  WriteLN('  but WITHOUT ANY WARRANTY; without even the implied warranty of');
  WriteLN('  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the');
  WriteLN('  GNU General Public License for more details.');
  l:=currixtime;
  while (((currixtime-l)<6) AND NOT keypressed) DO;
END;

PROCEDURE InitVariables;
VAR B:BYTE;
BEGIN
  {FILLCHAR(KS,256*SizeOf(pointer),0);
  FILLCHAR(SAVEFILE,256*SizeOf(pointer),0);
  FILLCHAR(SaveMode,256,0);}
  FOR B:=0 TO 255 DO
  BEGIN
    KS[b]:=NIL;
    SaveFile[b]:=NIL;
    SaveMode[b]:=0;
    MCALL[b]:=NIL;
    vorschreib[b]:=NIL;
    BufSizes[b]:=6;
    Scripts[b]:=NIL;
  END;
  FILLCHAR(default_remotes,4,$FF);
  convcall:='';
  nodecall:='';
  mycall:='';
  boxcall:='';
  allocchans:=0;
  fillchar(TNCParms,16*SIzeOF(tTNCParms),0);
END;


(*****************************************************************************)
(* InitChannels;                                                             *)
(* Alloziiert/Dealloziiert Speicher fr QSO-Puffer,Vorschreib-Puffer,MYCalls *)
(* abhngig von MaxChan/AllocChans. Dabei wird jeweils versucht, AllocChan   *)
(* auf MaxChan zu erweitern, wenn nicht genug Speicher frei ist, wird soviel *)
(* alloziiert, da noch 50k frei sind                                        *)
(*****************************************************************************)

PROCEDURE InitChannels;
VAR B,C:BYTE;
BEGIN
  IF MaxTerminal<AllocChans THEN
  BEGIN
    WHILE AllocChans>MaxTerminal DO
    BEGIN
      DISPOSE(QSOBuf[AllocChans],Done);
      DISPOSE(vorschreib[AllocChans]);
      DISPOSE(mcall[AllocChans]);
    END;
  END ELSE
  IF MaxTerminal>AllocChans THEN
  BEGIN
    WriteLn('Allocated Scrollback:');
    B:=AllocChans;
    WHILE B<MaxTerminal DO
    BEGIN
      INC(B);
      IF MaxAvail<30*1024 THEN
      BEGIN
        maxTerminal:=AllocChans;
        IF Channel>MaxTerminal THEN
          Channel:=1;
        exit;
      END;
      NEW(QSOBuf[B],init(bufsizes[b],fqsotx,fqsorx,pqsowin,pqsowin+qsowinsize,BufSwapTypes));
      Write(b,':',QsoBuf[b]^.bufsize DIV 1024,'KB(');
      CASE QsoBuf[b]^.mode OF
        0:Write('CONV);');
        1:Write('XMS);');
        2:Write('EMS);');
        3:Write('UMB);');
        4:Write('FILE);');
      END;  
      NEW(Vorschreib[B]);
      WITH Vorschreib[B]^ DO
      BEGIN
        x:=1;
        y:=1;
        offs:=0;
        FOR c:=1 TO 10 DO
          buf[c]:='';
      END;
      NEW(mcall[b]);
      MCALL[b]^:=mycall;
      INC(AllocChans);
    END;
  END;
  WriteLn;
END;





PROCEDURE InitScreen;
VAR W:WORD;
BEGIN
  clrscr;
{$IFNDEF linux}
   asm  {BLINK aus!}
    mov ax,$1003
    mov bx,0
    int $10
   end;
{$ENDIF}
  setlin(hi(WindMax)+1,lo(windmax)+1);
  monibuf:=new(pmbuf,init(monibufsize,fmonhead,fmondata,pmoni,pmoni+moniwinsize,MoniBufSwapTypes));
  InitMenu;
  textattr:=fqsorx;
  StartTime:=CurrIxTime;
{$IFNDEF linux}
setvmode(EGAVGAFONT);
{$ENDIF}
redrawScreen;
  USE_CRT:=False;
END;

TYPE  str3=string[3];
CONST mon:ARRAY[1..12] OF STR3=
      ('jan','feb','mar','apr','may','jun',
       'jul','aug','sep','oct','nov','dec');

PROCEDURE OpenLogs;
VAR a,b,c:WORD;s:string[4];sr:Searchrec;
BEGIN
  {$I-}
  getdate(a,b,c,c);
  str(a,s);
  FINDFIRST(QRVPATH+'logs'+PATH_SEP+'.',anyfile,sr);
  IF DOSERROR<>0 THEN
  BEGIN
    MKDIR(QRVPATH+'logs');
    IF IORESULT <> 0 THEN;
  END;
  ASSIGN(Logfile,qrvpath+'logs'+PATH_SEP+mon[b]+s);
  APPEND(logfile);
  IF IORESULT <> 0 THEN
  BEGIN
    REWRITE(LOGFILE);
    IF IORESULT<>0 THEN;
  END;
  CLOSE(logfile);
  (* iad, sept 96: PGP-Pfad anlegen, falls nicht vorhanden *)
   FINDFIRST(QRVPATH+'pgp'+PATH_SEP+'.',anyfile,sr);
  IF DOSERROR<>0 THEN
  BEGIN
    MKDIR(QRVPATH+'pgp');
    IF IORESULT <> 0 THEN;
  END;
  (* iad, sept 96: TEMP-Pfad anlegen, falls nicht vorhanden *)
  FINDFIRST(QRVPATH+'temp'+PATH_SEP+'.',anyfile,sr);
  IF DOSERROR<>0 THEN
  BEGIN
    MKDIR(QRVPATH+'temp');
    IF IORESULT <> 0 THEN;
  END;

END;

PROCEDURE Attach_TNC;
VAR confOk,confOk2:BOOLEAN;
    b,lev:BYTE;
    hour,min,sec,hund,year,
    month,day,dow                : word;
    err:INTEGER;typ:BYTE;
    long:LONGINT;
    {$IFDEF FLEXNET}
    T:pTrace;
    {$ENDIF}
    S:STRING;
    OK:BOOLEAN;
    p:pQueueRec;
BEGIN
   {$IFDEF linux}
   if tfkiss_flag<>0 THEN typ:=DRV_TFKISS
   else typ:=DRV_SER;
   {$ENDIF}
  typ:=DRV_VJ;
  TNC_an:=FALSE;
  {$IFDEF WA8DED}
  {$IFNDEF linux}
  IF V24Install(0,0,2) THEN {TFPCX Geladen?}
  BEGIN
    SerWriteDelay:=0;
    typ:=2;
    device:=0;
  END;
  {$ELSE}
  
  IF tfkiss_flag=1 THEN
  BEGIN
     SerWriteDelay:=0;
     typ:=DRV_TFKISS;
     device:=0;
  END;
  {$ENDIF} 
  {$ENDIF}
  {$IFDEF FLEXNET}
  {IF typ=1 THEN
  BEGIN}
  flextype:=ax_init;
    IF (flextype>0) THEN
    BEGIN
      Tnc_AN:=TRUE;
      device:=1;
      setMonitor;
    END;
  {END;}
  {$ENDIF}
  {$IFDEF WA8DED}
  IF ((_comport<6) and (device=0)) and ((_comport>0)
     or (typ=DRV_TFPC) or (typ=DRV_TFKISS) or (typ=DRV_SER)) THEN
  BEGIN
    IF V24Install(_comport,portaddress,typ) THEN
    BEGIN
      IF _ComPort<5 THEN SerWriteDelay:=1;
      V24Open(_comport,_interrupt,portaddress,typ,baud);
      WHILE V24DataAvail DO
      BEGIN
        Delay(10);
        v24read;
      END;
      SendStr(#16#24'');
      delay(100);
      WHILE V24DataAvail DO
      BEGIN
        Delay(10);
        v24read ;
      END;
      Sendstr(#18#24#27'JHOST1'#13);
      delay(100);
      WHILE V24DataAvail DO
      BEGIN
        Delay(10);
        v24read;
      END;
      Tnc_An:=TRUE;
      sendcmd(0,'L'); {hostmode wirklich aktiv?}
      SendCmd(0,'U 0');
    END ELSE
      PopUp('COM '+char(_comport+48)+' not found');
    IF TNC_an THEN
    BEGIN
      gettime(hour,min,sec,hund);
      sendcmd(0,'K '+maketimestr(hour,min,sec));
      getdate(year,month,day,dow);
      SetMonitor;
      YEAR:=YEAR MOD 100;
      sendcmd(0,'K '+makedatestr(day,month,year));
    END;
  END;
  IF (_comport<6) and tnc_an and (device=0) THEN
  BEGIN
    b:=0;
    ein_s:=sendcmd(0,'C');
    multiport:=pos(':',ein_s)>0;
    p:=TncIniCmds;
    WHILE p<>NIL DO
    BEGIN
      SendCMD(0,p^.data);
      IF NOT TNC_AN THEN exit;
      p:=p^.next;
    END;
    For B:=1 To TNCchan DO
    BEGIN
      BEGIN
        IF MCALL[b]=NIL THEN new(mcall[b]);
        MCALL[b]^:=Mycall;
        {$IFDEF BOX}
           IF box_is_running THEN
           IF B> TNCChan-tfbbschans THEN MCALL[b]^:=boxcall;
        {$ENDIF}
        IF not TNC_AN THEN exit;
        sendcmd(b,'I '+mcall[b]^);
        IF not TNC_AN THEN exit;
        ein_s:=sendcmd(b,'c');
        IF not TNC_AN THEN exit;
        OK:=FALSE;
        IF pos(' CONNECTED',ein_S)=0 THEN
        BEGIN
          IF pos('via',ein_S)>0 THEN
             s:=copy(ein_S,1,pos(' via',ein_S)-1)
          ELSE
             s:=ein_S;
          IF CheckCall(s) THEN OK:=TRUE;
        END;
        IF OK THEN
        BEGIN
          NEWKS(b);
          KS[b]^.status:=7;
          IF pos('via',ein_S)>0 THEN
             KS[b]^.CALL:=copy(ein_S,1,pos(' via',ein_S)-1)
          ELSE
           KS[b]^.Call:=ein_S;
          IF ein_S[length(ein_S)]=' ' THEN dec(BYTE(KS[b]^.call[0]));
          IF KS[b]^.Call[2]=':' THEN
          BEGIN
            KS[b]^.port:=ord(KS[b]^.Call[1])-48;
            KS[b]^.Call:=copy(KS[b]^.Call,3,255);
          END;

          LoadTermUser(b);
        END;
      END;
    END;
  END;
  (*
   * Check, ob das TNC den extended Hostmode untersttzt...
   *)
  IF (device=0) and TNC_an THEN
  BEGIN
    IF pos('INVALID',sendcmd(255,'g'))=0 THEN
      xHOST:=TRUE
    ELSE
      xHost:=FALSE;
    IF NOT XHOST THEN
    BEGIN
      PopUp('No extended hostmode :-( Get new TNC Software (TF 2.6 or up)! SLOOOW');
    END;
  END;       
  {$ENDIF}
  IF NOT Tnc_AN THEN
  BEGIN
    PopUp('Sorry, booting offline');
    IF installing=1 THEN installing:=2;
  END;
  IF IOresult<>0 THEN Write(#7);
END;

   {$IFNDEF linux}
PROCEDURE Win95Zeuchs;
VAR Flag:WORD;
    S:STRING;
    L:LONGINT;

  PROCEDURE setTitle(VAR S1:STRING);ASSEMBLER;
  ASM
    MOV AX,$168E
    MOV DX,0
    LES DI,S1
    INT $2F
  END;

BEGIN
  Windows95CLOSE:=TRUE;
  ASM
    MOV AX,$4A33
    PUSH DS
    INT $2F
    POP DS
    MOV Flag,AX
  END;
  IF Flag=0 THEN
  BEGIN
    (*
     * Aha, MS-DOS 7...
     * Dann versuchen wir mal den Close-Menpunkt im System-Men
     * zu aktivieren, wenn das klappt, dann benutzt dieser Idiot von
     * User tatschlich Windows...
     *)
    ASM
      MOV AX,$168F
      MOV DH,0
      MOV DL,1
      INT $2F
      MOV Flag,AX
    END;
    IF Flag=0 THEN
    BEGIN
      (*
       * Soso, dieser DAU hat tatsaechlich in den Bill Gates
       * Unterstuetzungsverein eingezahlt, das belohnen wir glatt
       * mit einem schoenen Fenstertitel :)
       *)
      Windows95Close:=TRUE;
      WriteLn('LinuX for ever!');
      S:='MCUT '+version+#0;
      SetTitle(S);
    END ELSE WriteLN('DOS-Mode von W95.. auwaia...');
  END;

END;
{$endif}
  


(*****************************************************************************)
(* PROCEDURE InitMCUT                                                        *)
(* iad,jan '96. Endlich habe ich mich durchgerungen diese uralt-Prozedur     *)
(* komplett neu zu schreiben.                                                *)
(*****************************************************************************)

PROCEDURE InitMCUT;
VAR SR:SEARCHREC;
    L:LONGINT;B:BYTE;BOOT:TEXT;
BEGIN
  {$I-}
  ASSIGN(Boot,'BOOT.MCT');
  REWRITE(boot);
  (*
   * Zunchst wird erstmal CTRL-C gesperrt, sowohl im DOS als auch bei CRT
   *)
  SetCBreak(FALSE);
  CheckBreak:=FALSE;
  (*
   * Jetzt werden die Copyright-Meldungen ausgegeben
   *)
  WriteCopyRight;
  (*
   * Jetzt wird die UNIT Memory von Turbo-Pascal aktiviert
   *)
  WriteLn(boot,'Booting, memory:',memavail);
{$IFNDEF linux}
   InitMemory;  WriteLn(boot,'InitMemory, memory:',memavail);
{$ENDIF}
   InitVariables;   WriteLn(boot,'InitVariables, memory:',memavail);
  (*
   * Hier wird eine datei geffnet, in die diverse Dinge fr die
   * Fehlersuche geschreiben werden
   *)
  assign(debugfile,'debug.mct');
  {$I-}
  append(debugfile);
  IF IOresult<>0 THEN
    rewrite(debugfile);
  (*
   * Hier wird die TP ExitProc durch eine eigene ersetzt
   *)
  OldExitProc:=exitproc;
  exitproc:=@myexitproc;
  (*
   * So, jetzt knnen wir die MCUT.CFG laden
   *)
  InitUmlautTable;   WriteLn(boot,'InitUmlauts, memory:',memavail);
  ReadConfig;   WriteLn(boot,'Readconfig:',memavail);
   FINDFIRST(qrvpath+'.',directory,sr);
  IF doserror<>0 THEN
  BEGIN
    WriteLn(qrvpath+' does not exist. ');
    qrvpath:='';
  END;
  {$IFDEF BETA}
  CheckKey;
  {$ENDIF}
  (*
   *  Die Channels alloziieren.
   *)
  (* Hier rechne ich aus, wieviel EMS-Speicher ich wohl brauchen werde *)
  L:=0;
  FOR B:=1 To MaxTerminal DO
    INC(L,BufSizes[b]);
  L:=L+MoniBufSize;
  AllocSwapMem(L);   WriteLn(boot,'AllocSwapMem:',memavail);
  InitChannels;  WriteLn(boot,'InitChannels:',memavail);
  IF AllocChans=0 THEN
  BEGIN
    WriteLn('Out of Memory, terminating');
    halt;
  END;
  (*
   * LogFiles anlegen
   *)
  OpenLogs;
  (*
   * Die BOX inititalisieren
   *)
  {$IFDEF BOX}
  IF Usebox>0 THEN
  BEGIN
    InitBox;  WriteLn(boot,'InitBox:',memavail);
  END;
  {$ENDIF}
  (*
   * Convers initialisieren
   *)
  {$IFDEF CONVERS}
  IF Useconv>0 THEN
  BEGIN
    InitConv;  WriteLn(boot,'InitConvers:',memavail);
    convers_is_running:=TRUE;
  END;
  {$ENDIF}
  InitScreen;  WriteLn(boot,'InitScreen:',memavail);
  if installing=0 THEN
   Attach_TNC;  WriteLn(boot,'AttachTNC:',memavail);
  {$IFDEF HELP}
  HelpDir:=HELPPATH;
  helplines:=12;
  SetHelpColors(fhelp DIV 16, fhelp MOD 16, fhelp2, fhelpm div 16, fhelpm mod 16);
  {$ENDIF}
  (*
   * Wir fangen bei 1 an (nicht bei 0 ;-))
   *)
  HandleChan:=1;
  SendChan:=1;
  (*
   * Hier wird die Zeit der letzten Messung der Auslastung auf die
   * aktuelle Uhrzeit gesetzt.
   *)
  Last_Mess:=currixtime;
  (*
   * prioritten fr diverse programmteile, gehrt eigentlich nicht
   * hierher.
   *)
  (* Tastaturmakros laden *)
  ReadMakros; WriteLn(boot,'ReadMAKROS:',memavail);
  {$IFDEF M}
  InitMoniMCT;
  {$ENDIF}
  IF installing=1 THEN
    GeneralSettingsDlg ELSE
    IF installing=2 THEN
      TNCSettingsDlg
      ELSE ReadState;
   UnprotoInit;
   CLOSE(BOOT);
  
END;




PROCEDURE DoneMCUT;
VAR b:BYTE;w,w1,w2:word;
    f:file;confok,confok2:boolean;
    dummy:STRING[80];
    pcron:pcrondata;parafile:text;
    SR:SEARCHREC;
    p:pQueueRec;

{$IFDEF WA8DED}
LABEL weiter;
{$ENDIF}
BEGIN
  IF SaveSettings THEN
    WriteConfig;
  monitor_chans:=0;
  SetMonitor;
  WriteMakros;
  WriteState;
  {$IFDEF WA8DED}
  IF (_comport<6) AND TNC_An AND (device=0) THEN
  BEGIN
    p:=TncDeiCmds;
    WHILE p<>NIL DO
    BEGIN
      SendCMD(0,p^.data);
      IF NOT TNC_AN THEN Goto Weiter;
      p:=p^.next;
    END;
  weiter:
    SendCmd(0,'U 1');
    SendCmd(0,'U 2');
    SendCmd(0,'MN');
    SendCmd(0,'JHOST0');
    V24Close;
  END;
  {$ENDIF}
  {$IFDEF FLEXNET}
    IF device=1 THEN ax_exit;
  {$ENDIF}
   Findfirst(qrvpath+'temp'+PATH_SEP+'*.*',anyfile,sr);
  WHILE doserror=0 DO
  BEGIN
    assign(parafile,qrvpath+sr.name);
    erase(parafile);
    IF IOresult<>0 THEN;
    findnext(sr);
  END;
  {$IFNDEF linux}
  textmode(LASTMODE);
  {$ENDIF}
   USE_CRT:=TRUE;
  {$IFDEF BOX}
  box_done;
  {$ENDIF}
   {$IFNDEF linux}
  DoneMemory;
   {$ENDIF}
END;



Procedure InitMenu;

VAR S:STRING[1];alt_tab:STRING[24];B:BYTE;
Begin
  alt_tab:=#16#48#46#32#18#33#34#35#23#36#37#38#50#49#24#25#16#19#31#20#22#47#17#45#21#44;
  {s:=GetText(63,0);
  HotKeys[1]:=alt_tab[BYTE(UpCase(s[1]))-64];
  s:=GetText(67,0);
  HotKeys[2]:=alt_tab[BYTE(UpCase(s[1]))-64];
  S:=GetText(73,0);
  HotKeys[3]:=alt_tab[BYTE(UpCase(s[1]))-64];
  s:=GetText(76,0);
  HotKeys[4]:=alt_tab[BYTE(UpCase(s[1]))-64];
  Menu:=NewMenu(' ',1,
           NewMenu(Gettext(63,0),1,
             NewItem(GetText(64,0),1,101,
             NewItem(GetText(65,0),1,102,
             NewItem(GetText(87,0),1,105,
             NewItem(GetText(88,0),1,106,
             NewItem(GetText(81,0),1,104,
             NewItem(GetText(66,0),1,103,
           NewMenu(GetText(67,0),1,
             NewItem(GetText(68,0),1,201,
             NewItem(GetText(69,0),1,202,
             NewItem(GetText(70,0),1,203,
             NewItem(GetText(71,0),1,204,
             NewItem(GetText(72,0),1,205,
           NewMenu(GetText(73,0),1,
             NewItem(GetText(74,0),1,301,
             NewItem(GetText(75,0),1,302,
           NewMenu(GetText(76,0),1,
             NewSwitch(GetText(77,0),1,@klingel,
             NewItem(GetText(78,0),1,402,
             NewItem(GetText(79,0),1,403,
             NIL)))))))))))))))))))));    }
  B:=1;
  Fillchar(hotkeys,5,0);
  HotKeys[B]:=alt_tab[BYTE('F')-64];;
  INC(B);
  HotKeys[B]:=alt_tab[BYTE('C')-64];;
  INC(B);
  HotKeys[B]:=alt_tab[BYTE('O')-64];;
  INC(B);
  HotKeys[B]:=alt_tab[BYTE('H')-64];;
  INC(B);
  HotKeys[B]:=alt_tab[BYTE('P')-64];;
  INC(B);
  Menu:=NewMenu(' ',1,
           NewMenu('File',1,
             NewItem('Send',1,101,
             NewItem('Receive',1,102,
             NewItem('AutoBin RX',1,105,
             NewItem('AutoBin TX',9,106,
             NewItem('Dos-Shell',1,104,
             NewItem('Edit File',1,107,
             NewItem('Exit MCUT',2,103,
           NewMenu('Channel',1,
             NewItem('User Settings',1,207,
             NewItem('BBS-Selfconnect',1,202,
             NewItem('Terminal-Selfconnect',1,203,
             NewItem('Password',1,204,
             NewItem('Charset',1,206,
           NewMenu('Options',1,
             NewItem('Callsigns',1,402,
             NewItem('Directories',1,403,
             NewItem('Terminal',1,404,
             NewItem('TNC',2,405,
             NewItem('System internals',8,408,
             NewItem('Monitor...',1,409,
             NewItem('FlexNet...',1,410,
             NewItem('Screen...',1,411,
             NewItem('Default Remotes...',9,412,
             NewItem('Load',1,406,
             NewItem('Save',2,407,
           NewMenu('Help',1,
             NewItem('Index',1,501,
             NewItem('other (DP-) .HLP...',1,504,
           {$IFDEF BOX}
            NewMenu('PGP',1,
             NewItem('Settings...',1,601,
             NewItem('Mail/Post a public key',1,602,
             NewItem('Generate a keypair',1,603,
             NewItem('Certify a PK',1,604,
             NewItem('Edit trust parameters',1,605,
           {$ENDIF}
             NIL)))))))))))))
           {$IFDEF BOX}
             ))))))
           {$ENDIF}
             )))))))))))))))));
  InitHPUI(Menu,nil,nil);
end;

Procedure showmenu;
Begin
  InitHPUI(Menu,nil,nil);
end;

END.
