(****************************************************************************)
(* Terminal-Funktionen fr MCUT.                                            *)
(* vor allem die Dialogboxen im Terminal, die Proceduren fr                *)
(* LOOP-Connects und die zur Auswertung von ESC-Befehlen                    *)
(*                                                                          *)
(* Die Unit darf als Overlay deklariert werden.                             *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(*                                                                          *)
(****************************************************************************)

UNIT TERM_O;

{$O+,F+}
INTERFACE

TYPE STRING10=STRING[10];

  PROCEDURE Interpret_CMD(c:BYTE;var s:string;input:BYTE);
  PROCEDURE ConnLoop(C:BYTE;CALL:STRING10);
  PROCEDURE DiscLoop(C:BYTE);
  PROCEDURE SendText(C:BYTE;S:STRING);
  PROCEDURE SendAuto(C:BYTE;S:STRING);
  PROCEDURE ReceiveAuto(c:BYTE;S:STRING);
  PROCEDURE ReceiveText2(C:BYTE;S:STRING);
  PROCEDURE CloseReceive(channel:BYTE);
  PROCEDURE TextOut(C:BYTE;S:STRING);

VAR     org_str:STRING;

IMPLEMENTATION

USES IADVAR,SCRIPT,MCUTLIB2,SCREEN,CRT,
     {$IFDEF WA8DED}
     TNC,
     {$ENDIF}
     {$IFDEF FLEXNET}
     FLXAPP,
     {$ENDIF}
{$IFDEF EDITOR}
EDITOR,
{$ENDIF}
     TOOLBOX,MYSTRING,
     INPUT,DOS,MCUTLIB,TERMUSER,PACKET,TERMSCAN,DIALOG1,
{$IFNDEF linux}
     MEMORY,
{$ELSE}
   LINUX,
{$ENDIF}
SPYNEW,MH;

VAR   L,R:STRING[10];
      along:longint;err:integer;



PROCEDURE TextOut(C:BYTE;S:STRING);
BEGIN
  IF c<AllocChans THEN
    WriteBuf(c,S,fqsorx,1);
END;

PROCEDURE SendText(C:BYTE;S:STRING);
VAR sr : SEARCHREC;
    st1: STRING[10];
BEGIN
  findfirst(s,anyfile,sr);
  IF (Doserror=0) AND (channel<>0) AND ((sr.attr AND $10)=0) THEN
  BEGIN
    PutFile(c,s);
    s:=gross(s);
  END;
  IF doserror>0 THEN PopUp('File not found');
END;




PROCEDURE SendAuto(C:BYTE;S:STRING);
VAR sr : SEARCHREC;
    st1,st2: STRING[16];
BEGIN
  IF KS[c]=NIL THEN exit;
  findfirst(s,anyfile,sr);
  IF (Doserror=0) AND (c<>0) AND ((sr.attr AND $10)=0) THEN
  BEGIN
    new(KS[c]^.AutoBinData);
    KS[c]^.AutoBinData^.CRC:=makeCRC(s);
    str(KS[c]^.AutoBinData^.CRC,st1);
    str(sr.size,ein_s);
    st2:=xhex(sr.time);
    PutData(c,'#BIN#'+ein_s+'#|'+st1+'#$'+st2+'#'+s+#13);
    KS[c]^.autobindata^.filename:=s;
    KS[c]^.laststatus:=KS[c]^.status;
    KS[c]^.status:=15;
    KS[c]^.autobindata^.received:=0;
    KS[c]^.autobindata^.expected:=sr.size;
  END ELSE
    IF doserror>0 THEN PopUp('File not found');
END;

PROCEDURE ReceiveAuto(c:BYTE;S:STRING);
BEGIN
  new(KS[c]^.AutoBinData);
  KS[c]^.autobindata^.filename:=s;
  KS[c]^.laststatus:=KS[c]^.status;
  KS[c]^.status:=13;
  KS[c]^.autobindata^.received:=0;
  KS[c]^.autobindata^.expected:=0;
END;

PROCEDURE ReceiveText2(C:BYTE;S:STRING);
VAR sr:SEARCHREC;l,r:STRING;
BEGIN
  r:='';
  IF FIND(S,' ',l,r) THEN
    s:=l;
  FindFirst(s,anyfile,sr);
  IF doserror>0 THEN
    r:='!';
  IF r='' THEN
  BEGIN
    ReceiveOverWriteDlg(s);
    exit;
  END;
  New(SaveFile[c]);
  Assign(SaveFile[c]^,s);
  {$i-}
  IF R='!' THEN
    ReWrite(SaveFile[c]^) ELSE
  IF R='+' THEN
    Append(SaveFile[c]^);
  IF IOResult<>0 THEN
  BEGIN
    PopUp('I/O failure. Can'#39't open '+s);
  END else
  BEGIN
    SaveMode[c]:=1;
    s:=gross(s);
  END;
END;
PROCEDURE CloseReceive(channel:BYTE);
BEGIN
   PopUp('File Closed');
   IF (KS[channel]^.FLAGS AND KS_7PSave)<>0 THEN
   BEGIN
     KS[channel]^.FLAGS:=KS[channel]^.FLAGS AND NOT KS_7PSAVE;
     IF (KS[channel]^.AutoBinData<>NIL) AND (KS[channel]^.status=7) THEN
     BEGIN
       Dispose(KS[channel]^.AutoBinData);
       KS[channel]^.AutoBinData:=NIL
     END;
     KS[channel]^.FLAGS:=KS[channel]^.FLAGS OR KS_SHOWDATA;
   END;
   Close(SaveFile[channel]^);
   Dispose(saveFile[channel]);
   savefile[channel]:=NIL;
   SaveMode[channel]:=0;
END;

PROCEDURE COMP_CMD(c:BYTE;S:STRING);
BEGIN
  S:=FilterCRLF(S);
  IF KS[c]=NIL THEN exit;
  IF S='1' THEN
    KS[c]^.COMPRESS:=2;
  IF S='0' THEN
    KS[c]^.COMPRESS:=0;
  IF KS[c]^.STatus=7 THEN
  BEGIN
    IF S='ON' THEN
    BEGIN
      PutData(c,'//COMP 1'+#13);
      KS[c]^.COMPRESS:=1;
    END ELSE
    IF S='OFF' THEN
    BEGIN
      PutData(c,'//COMP 0'+#13);
      KS[c]^.COMPRESS:=0;
    END;
  END;
END;

PROCEDURE MONITOR_CMD(c:BYTE;S:STRING);
VAR l:LONGINT;err:INTEGER;tmp:STRING[10];
BEGIN
  IF S='' THEN
  BEGIN
    TextOut(c,'>>> MONITOR');
    IF monitor_chans=$F THEN
      TextOut(c,' ON') ELSE
      IF monitor_chans=0 THEN
        TextOut(c,' OFF') ELSE
        BEGIN
          str(monitor_chans,tmp);
          TextOut(c,' '+tmp);
        END;
    IF (monitor_typ AND MON_I)<>0 THEN
      TextOut(c,' I');
    IF (monitor_typ AND MON_CTL)<>0 THEN
      TextOut(c,' CTL');
    IF (monitor_typ AND MON_UI)<>0 THEN
      TextOut(c,' UI');
    IF (monitor_typ AND MON_TXD)<>0 THEN
      TextOut(c,' TXD');
    IF (monitor_typ AND MON_TXT)<>0 THEN
      TextOut(c,' TXT');
    TextOut(c,''+#13);
    EXIT;
  END;
  VAL(S,l,err);
  IF S='ON' THEN
    monitor_chans:=$F ELSE
  IF S='OFF' THEN
    monitor_chans:=0 ELSE
  IF err=0 THEN
    monitor_chans:=monitor_chans OR (1 SHL l) ELSE
  IF S='I' THEN
    monitor_typ:=monitor_typ OR MON_I ELSE
  IF S='NO_I' THEN
    monitor_typ:=monitor_typ AND NOT MON_I ELSE
  IF S='UI' THEN
    monitor_typ:=monitor_typ OR MON_UI ELSE
  IF S='NO_UI' THEN
    monitor_typ:=monitor_typ AND NOT MON_UI ELSE
  IF S='CTL' THEN
    monitor_typ:=monitor_typ OR MON_CTL ELSE
  IF S='NO_CTL' THEN
    monitor_typ:=monitor_typ AND NOT MON_CTL ELSE
  IF S='TXT' THEN
    monitor_typ:=monitor_typ OR MON_TXT ELSE
  IF S='NO_TXT' THEN
    monitor_typ:=monitor_typ AND NOT MON_TXT ELSE
  IF S='TXD' THEN
    monitor_typ:=monitor_typ OR MON_TXD ELSE
  IF S='NO_TXD' THEN
    monitor_typ:=monitor_typ AND NOT MON_TXD ELSE
  IF C<=MaxTerminal THEN
  BEGIN
    TextOut(c,'>>> MONITOR [ON|OFF|I|NO_I|UI|NO_UI|CTL|NO_CTL|TXT|NO_TXT|TXD|NO_TXD]'+#13);
    EXIT;
  END;
  SetMonitor;
END;



PROCEDURE ACONN_CMD(c:BYTE;S:STRING);
VAR call,einstieg,netz:STRING[20];
BEGIN
  IF KS[c]<>NIL THEN
  BEGIN
    PopUp('channel already connected');
    EXIT;
  END;
  S:=ltrim(s)+' ';
  find(s,' ',call,einstieg);
  find(einstieg,' ',einstieg,netz);
  NewKS(c);
  IF NOT InitRouter(c,mcall[c]^,call,einstieg,netz) THEN
    IF KS[c]<>NIL THEN
    BEGIN
      DISPOSE(KS[c]);
      KS[c]:=NIL;
    END;
END;

PROCEDURE PRINT_CMD(C:BYTE;S:STRING);
BEGIN
  IF PRINTING=C THEN
  BEGIN
    PopUp('Printing stopped');
    PRINTING:=0;
  END ELSE
  If PRINTING=0 THEN
  BEGIN
    PopUp('Ok, now printing');
    PRINTING:=C;
  END ELSE 
    PopUP('Printing already other channel');  
END;    

PROCEDURE PACLEN_CMD(C:BYTE;S:STRING);
BEGIN
  IF s='' THEN BEGIN
    Str(paclen,s);
    TextOut(c,'>>> global PACLEN: '+s);
    IF KS[c]<>NIL THEN
    BEGIN
      Str(Ks[c]^.paclen,s);
      TextOut(c,', on this Channel: '+s);
    END; 
    TextOut(c,''+#13);
    exit;
  END;   
  Val(s,along,err);
  IF KS[c]<>NIL THEN
  BEGIN
    KS[c]^.paclen:=along;
  END ELSE  
   paclen:=along;
END;
   
PROCEDURE TNC_CMD(C:BYTE;S:STRING);
BEGIN
  {$IFDEF WA8DED}
  IF device=0 THEN
  BEGIN
    IF s<>'' THEN
      TextOut(c,'>>> TNC:'+SendCMD(c,s)+#13)
    ELSE BEGIN
      IF TNC_AN THEN
       TextOut(c,'>>> TNC online'+#13) ELSE
       TextOut(c,'>>> TNC offline'+#13);
    END;
  END;
  {$ENDIF}
  IF device=1 THEN
    TextOut(c,'>>> You are using PC/FlexNet, not a WA8DED-TNC'+#13);
END;

PROCEDURE MYCALL_CMD(C:BYTE;S:STRING);
BEGIN
  IF S='' THEN
  BEGIN
    TextOut(c,'>>> MYCALL: '+MCall[c]^+#13);
    exit;
  END;
  mcall[c]^:=S;
  {$IFDEF WA8DED}
  IF device=0 THEN
    sendcmd(c,'I '+s);
  {$ENDIF}
END;


PROCEDURE FORCE_CMD(C:BYTE;S:STRING);
BEGIN
  IF S='' THEN
  BEGIN
    TextOut(c,'>>> FORCE <text>'+#13);
    exit;
  END;
  Handle(C,s+#13)
END;

PROCEDURE RTT_CMD(C:BYTE;S:STRING);
BEGIN
  Handle(C,'//RTT'+#13)
END;



PROCEDURE FRACK_CMD(C:BYTE;S:STRING);
BEGIN
  {$IFDEF WA8DED}
  IF device=0 THEN
  BEGIN
    IF S='' THEN
    BEGIN
      TextOut(c,'>>> FRACK: '+SendCMD(c,'F')+#13);
      exit;
    END ELSE
    BEGIN
      IF MultiPort THEN
      BEGIN
        IF FIND(s,' ',L,R) THEN
        BEGIN
          VAL(R,along,err);
          IF err>0 THEN
          BEGIN
            TextOut(c,'>>> Numerical value expected!'+#13);
            exit;
          END;
        END;
      END;
      VAL(s,along,err);
      IF err>0 THEN
      BEGIN
        TextOut(c,'>>> Numerical value expected!'+#13);
        exit;
      END;
      SendCMD(c,'F '+S);
    END;
  END;
  {$ENDIF}
  {$IFDEF FLEXNET}
  IF device=1 THEN
  BEGIN
    IF KS[c]=NIL THEN
    BEGIN
      TextOut(c,'>>> Channel not connected'+#13);
      exit;
    END;
    str(l2_frack(KS[c]^.Stream),s);
    TextOut(c,'>>> FRACK: '+s);
  END;
  {$ENDIF}
END;
PROCEDURE STAMP_CMD(C:BYTE;S:STRING);
BEGIN
  {$IFDEF WA8DED}
  IF device=0 THEN
  BEGIN
    IF S='' THEN
    BEGIN
      TextOut(c,'>>> STAMP: ');
      IF (SendCMD(c,'F')='0') THEN
        TextOut(c,' OFF'+#13) ELSE
      IF (SendCMD(c,'F')='1') THEN
        TextOut(c,' ON'+#13) ELSE
      IF (SendCMD(c,'F')='2') THEN
        TextOut(c,' ALL'+#13);
      exit;
    END ELSE
    BEGIN
      VAL(s,along,err);
      IF err>0 THEN
      BEGIN
        IF S='ON' THEN
         S:='1' ELSE
        IF S='OFF' THEN
         S:='0' ELSE
        IF S='ALL' THEN
         S:='2';
      END;
      SendCMD(c,'K '+S);
    END;
  END;
  {$ENDIF}
  {$IFDEF FLEXNET}
  IF device=1 THEN
  BEGIN
    TextOut(c,'>>> not available with PC/FlexNet'+#13);
  END;
  {$ENDIF}
END;
PROCEDURE RETRY_CMD(C:BYTE;S:STRING);
BEGIN
  {$IFDEF WA8DED}
  IF device=0 THEN
  BEGIN
    IF S='' THEN
    BEGIN
      TextOut(c,'>>> RETRY: '+SendCMD(c,'N')+#13);
      exit;
    END ELSE
    BEGIN
      VAL(s,along,err);
      IF err>0 THEN
      BEGIN
        TextOut(c,'>>> Numerical value expected!'+#13);
        exit;
      END;
      SendCMD(c,'N '+S);
    END;
  END;
  {$ENDIF}
  {$IFDEF FLEXNET}
  IF device=1 THEN
  BEGIN
    IF KS[c]=NIL THEN
    BEGIN
      TextOut(c,'>>> Channel not connected'+#13);
      exit;
    END;
    str(l2_tries(KS[c]^.Stream),s);
    TextOut(c,'>>> RETRIES: '+s);
  END;
  {$ENDIF}
END;

PROCEDURE MAXFRAME_CMD(C:BYTE;S:STRING);
BEGIN
  {$IFDEF WA8DED}
  IF device=0 THEN
  BEGIN

  END;
  {$ENDIF}
  {$IFDEF FLEXNET}
  IF device=1 THEN
  BEGIN
  END;
  {$ENDIF}
END;
(*
PROCEDURE FRACK_CMD(C:BYTE;S:STRING);
BEGIN
  {$IFDEF WA8DED}
  IF device=0 THEN
  BEGIN
  END;
  {$ENDIF}
  {$IFDEF FLEXNET}
  IF device=1 THEN
  BEGIN
  END;
  {$ENDIF}
END;
  *)

PROCEDURE PREFIX_CMD(C:BYTE;S:STRING);
BEGIN
  IF KS[c]=NIL THEN exit;
  IF s='?' THEN
     TextOut(c,'>>> PREFIX: '+KS[c]^.Prefix+#13)
   ELSE
     KS[c]^.prefix:=org_str;
END;

PROCEDURE CALL_CMD(C:BYTE;S:STRING);
BEGIN
  IF KS[c]=NIL THEN exit;
  IF s='' THEN
     TextOut(c,'>>> CALL: '+KS[c]^.call+#13)
   ELSE
   IF CheckCall(s) THEN
   BEGIN
     KS[c]^.CALL:=s;
     LoadTermUser(c);
   END ELSE
     TextOut(c,'>>> Invalid Call');
END;


PROCEDURE EU_CMD(C:BYTE;S:STRING);
VAR l,r:STRING; ok:boolean;
BEGIN
  ok:=TRUE;
  IF ConsoleState=4 THEN exit;
  s:=LTRIM(org_str);
  IF s='' THEN
     UserSettingsDlg
   ELSE
   IF not FIND(s,' ',l,r) THEN
   BEGIN
     dlg_u.call:=s;
     UserSettingsdlg2;
   END ELSE
   BEGIN
     IF checkCall(l) THEN
     BEGIN
       dlg_u.call:=l;
       find(r,' ',l,r);
     END ELSE
       IF KS[c]<>NIL THEN
         dlg_u.call:=KS[c]^.call
       ELSE exit;
     GetTermUser(dlg_u);
     r:=ltrim(r);
     l:=gross(l);
     IF l='NAME' THEN
        dlg_u.name:=r ELSE
     IF l='DIGI' THEN
        dlg_u.einstieg:=GROSS(r) ELSE
     IF l='NETWORK' THEN
        dlg_u.einstieg:=GROSS(r) ELSE
     IF l='PWD' THEN
        dlg_u.baypassword:=r ELSE
     IF l='DIR' THEN
        dlg_u.directory:=r ELSE
     IF l='DIR+' THEN
        dlg_u.directory:=dlg_u.directory+';'+r ELSE
     IF l='DIR' THEN
        dlg_u.directory:=r ELSE ok:=FALSE;
     IF OK THEN
     BEGIN
       SetTermUser(dlg_u);
       IF KS[c]<>NIL THEN
       LoadTermUser(c);
       exit;
     END;
     OK:=TRUE;
     r:=gross(r);
     IF l='CONNECT' THEN
     BEGIN
        IF (r='1') OR (r='ON') THEN
           dlg_u.flags:=dlg_u.flags OR TU_CONNECT ELSE
        IF (r='0') OR (r='OFF') THEN
           dlg_u.flags:=dlg_u.flags AND NOT TU_CONNECT;
     END ELSE
     IF l='RECONNECT' THEN
     BEGIN
        IF (r='1') OR (r='ON') THEN
           dlg_u.flags:=dlg_u.flags OR TU_RECONNECT ELSE
        IF (r='0') OR (r='OFF') THEN
           dlg_u.flags:=dlg_u.flags AND NOT TU_RECONNECT;
     END ELSE
     IF l='BBS' THEN
     BEGIN
        IF (r='1') OR (r='ON') THEN
           dlg_u.flags:=dlg_u.flags OR TU_BBS ELSE
        IF (r='0') OR (r='OFF') THEN
           dlg_u.flags:=dlg_u.flags AND NOT TU_BBS;
     END ELSE
     IF l='SENDPW' THEN
     BEGIN
        IF (r='1') OR (r='ON') THEN
           dlg_u.flags:=dlg_u.flags OR TU_SENDPW ELSE
        IF (r='0') OR (r='OFF') THEN
           dlg_u.flags:=dlg_u.flags AND NOT TU_SENDPW;
     END ELSE
     IF l='SYSOP' THEN
     BEGIN
        IF (r='1') OR (r='ON') THEN
           dlg_u.flags:=dlg_u.flags OR TU_SYSOP ELSE
        IF (r='0') OR (r='OFF') THEN
           dlg_u.flags:=dlg_u.flags AND NOT TU_SYSOP;
     END ELSE
     IF l='REMOTE' THEN
     BEGIN
        IF (r='1') OR (r='ON') THEN
           dlg_u.flags:=dlg_u.flags OR TU_REMOTE ELSE
        IF (r='0') OR (r='OFF') THEN
           dlg_u.flags:=dlg_u.flags AND NOT TU_REMOTE;
     END ELSE
     IF l='EXCLUDED' THEN
     BEGIN
        IF (r='1') OR (r='ON') THEN
           dlg_u.flags:=dlg_u.flags OR TU_EXCLUDED ELSE
        IF (r='0') OR (r='OFF') THEN
           dlg_u.flags:=dlg_u.flags AND NOT TU_EXCLUDED;
     END ELSE OK:=FALSE;
     IF OK THEN
     BEGIN
       SetTermUser(dlg_u);
       IF KS[c]<>NIL THEN
       LoadTermUser(c);
       exit;
     END;
   END;
END;


PROCEDURE QUIT_CMD(C:BYTE;S:STRING);
BEGIN
  IF S<>'!' THEN
    mcutEndeDlg ELSE
    MCUT_Ende:=TRUE;
END;

PROCEDURE STEXT_CMD(C:BYTE;S:STRING);
BEGIN
  IF KS[c]=NIL   THEN exit;
  IF S='' THEN SendTextDlg ELSE
  SendText(c,org_str);
END;

PROCEDURE SBIN_CMD(C:BYTE;S:STRING);
BEGIN
  IF KS[c]=NIL   THEN exit;
  IF KS[c]^.status=7 THEN
  BEGIN
    IF s='' THEN SendAutoDlg ELSE
    SendAuto(c,org_str);
  END ELSE
  IF KS[c]^.Status=15 THEN
  BEGIN
    KS[c]^.status:=KS[c]^.Laststatus;
    Dispose(KS[c]^.AutoBinData);
    KS[c]^.AutoBinData:=NIL;
    TextOut(c,'>>> Autobin aborted');
    PutData(c,#13+'#ABORT#'+#13);
    PutData(c,#13+'<MCUT>: AUTOBIN-Transfer aborted by sender'+#13);
  END ELSE
  IF KS[c]^.Status=16 THEN
  BEGIN
    KS[c]^.status:=KS[c]^.Laststatus;
    Dispose(KS[c]^.AutoBinData);
    KS[c]^.AutoBinData:=NIL;
    TextOut(c,'>>> Autobin aborted');
    PutData(c,#13+'#ABORT#'+#13);
    Close(KS[c]^.SendFile);
    KS[c]^.SendMode:=0;
    PutData(c,#13+'<MCUT>: AUTOBIN-Transfer aborted by sender'+#13);
  END;
END;

PROCEDURE RTEXT_CMD(C:BYTE;S:STRING);
BEGIN
  IF savemode[c]>0 THEN
  BEGIN CloseReceive(c); exit; END;
  IF S='' THEN ReceiveTextDlg ELSE
  BEGIN
     s:=org_str;
    IF NOT FIND(s,PATH_SEP,l,r) THEN
      S:=savpath+s;
    ReceiveText2(c,s);
  END;
END;

PROCEDURE RBIN_CMD(C:BYTE;S:STRING);
BEGIN
  IF KS[c]=NIL   THEN exit;
  IF KS[c]^.status=7 THEN
  BEGIN
    IF s='' THEN ReceiveAutoDlg ELSE
    ReceiveAuto(c,org_str);
  END ELSE
  IF (KS[c]^.status=13) OR (KS[c]^.Status=14) THEN
  WITH KS[c]^ DO
  BEGIN
    IF KS[c]^.Status=14 THEN
    BEGIN
      close(autobinData^.binfile);
      erase(AutoBinData^.binfile);
    END;
    IF AutoBinData<>NIL THEN
      dispose(autobindata);
    autobindata:=NIL;
    FLAGS := FLAGS OR KS_linemode;
    FLAGS:=FLAGS OR KS_SHOWDATA;
    status:=laststatus;
    TextOut(c,'>>> Autobin aborted');
    PutData(c,'#ABORT#'+#13);
    IF (FLAGS AND KS_BBS)=0 THEN
      PutData(c,'<MCUT>: AUTOBIN-Transfer aborted by receiver'+#13);
  END;
END;


PROCEDURE ABORT_CMD(C:BYTE;S:STRING);
BEGIN
  IF KS[c]=NIL THEN exit;
  CASE KS[c]^.Status OF
    15,16:SBIN_CMD(c,s);
    13,14:RBIN_CMD(c,s);
  END;
END;

(*
PROCEDURE MYCALL_CMD(C:BYTE;S:STRING);
BEGIN
  if device=1 THEN exit;
  {$IFDEF WA8DED}
  response:=sendcmd(c,'I'+S);
  Mcall[c]^:= sendcmd(c,'i');
  IF length(s)=1 THEN PopUp(mcall[c]^);
  {$ENDIF}
END;
  *)
PROCEDURE CONNECT_CMD(C:BYTE;S:STRING);
VAR response : STRING;
        ssid : BYTE;
       qsonum: WORD;
BEGIN
  {$IFDEF WA8DED}
  IF device=0 THEN
  BEGIN
    sendcmd(c,'I '+mcall[c]^);
    response:=sendcmd(c,'C'+s);
    WHILE Pos('STATION ALREADY',response)>0 DO
    BEGIN
      ein_s:=sendcmd(c,'I');
      IF FIND(ein_s,'-',L,R) THEN
        val(R,ssid,err)
      ELSE
        ssid:=0;
      INC(SSID);
      IF ssid>15 THEN
      BEGIN
        PopUp('Cannot increment SSID and Station already connected');
        exit;
      END;
      str(ssid,r);
      sendcmd(c,'I '+CUTSSID(mycall)+'-'+r);
      response:=sendcmd(c,'C'+s);
    END;
    IF RESPONSE<>'' THEN
    BEGIN
      PopUp(response);
    END ELSE
    BEGIN
      IF NOT NewKS(C) THEN
      BEGIN
        PopUp('WARNING: Not enough memory for this Operation!');
      END
      ELSE
      BEGIN
        KS[C]^.FLAGS:=KS[c]^.FLAGS OR KS_OWNCON;
      END;
    END;
    exit;
 END;
 {$ENDIF}
 {$IFDEF FLEXNET}
 IF device=1 THEN
 BEGIN
    IF KS[c]<>NIL THEN
    IF (KS[c]^.LinkState>0) OR (KS[c]^.Stream<>0) THEN
    BEGIN
      PopUp('channel already connected');
      exit;
    END;
    ein_s:=mycall;
    qsonum:=l2_Pcheck_path(ein_s,s);
    WHILE (qsonum>0) AND (l2_state(qsonum)>1) DO
    BEGIN
      IF FIND(ein_s,'-',L,R) THEN
        val(R,ssid,err)
      ELSE
      BEGIN
        l:=ein_s;
        ssid:=0;
      END;
      INC(SSID);
      IF ssid>15 THEN
      BEGIN
        PopUp('Cannot increment SSID and Station already connected');
        exit;
      END;
      str(ssid,r);
      ein_s:=l+'-'+r;
      qsonum:=l2_Pcheck_path(ein_S,s);
    END;
    NEWKS(c);
    KS[C]^.FLAGS:=KS[c]^.FLAGS OR KS_OWNCON;
    KS[c]^.Stream:=l2_pconnect(ein_s,s);
    IF KS[c]^.Stream=0 THEN
    BEGIN
      DISPOSE(KS[c]);
      KS[c]:=NIL;
      PopUp('FlexNet refused connection');
    END;
    exit;
 END;
 {$ENDIF}
END;


PROCEDURE DISCONNECT_CMD(C:BYTE;S:STRING);
BEGIN
  IF NOT TNC_AN THEN EXIT;
  {$IFDEF WA8DED}
  IF device=0 THEN sendcmd(c,'D');
  {$ENDIF}
  {$IFDEF FLEXNET}
  IF (device=1) AND (KS[c]<>NIL) THEN
  BEGIN
    l2_stop_qso(KS[c]^.Stream);
    IF (KS[c]^.FLAGS AND KS_DiscReq)<>0 THEN
      l2_cancel_qso(KS[c]^.Stream) ELSE
      INC(KS[c]^.FLAGS,KS_DISCREQ);
  END;
  {$ENDIF}
END;

PROCEDURE PUTDATA_CMD(C:BYTE;S:STRING);
BEGIN
  IF KS[c]=NIL THEN exit;
  PutData(c,org_str+#13);
END;

PROCEDURE PUTM_CMD(C:BYTE;S:STRING);
BEGIN
  IF KS[c]=NIL THEN exit;
  PutData(c,expandtermmacros(c,s)+#13);
END;  

PROCEDURE OSSHELL_CMD(C:BYTE;S:STRING);
BEGIN

END;

PROCEDURE BOX_CMD(C:BYTE;S:STRING);
BEGIN
  CONNLOOP(C,boxcall);
END;

PROCEDURE TERM_CMD(C:BYTE;S:STRING);
BEGIN
  CONNLOOP(C,mycall);
END;

PROCEDURE CLS_CMD(C:BYTE;S:STRING);
VAR B:BYTE;
BEGIN
  IF c<=MaxTerminal THEN
  BEGIN
    QsoBuf[c]^.Done;
    NEW(QSOBuf[C],init(bufsizes[C],fqsotx,fqsorx,pqsowin,pqsowin+qsowinsize,BufSwapTypes));
    WITH Vorschreib[C]^ DO
    BEGIN
      x:=1;
      y:=1;
      offs:=0;
      FOR b:=1 TO 10 DO
        buf[b]:='';
    END;
    QsoBuf[c]^.ShowBuf;
  END;
END;

PROCEDURE PRBUF_CMD(C:BYTE;S:STRING);
VAR txfile,binfile,buffile:STRING[70];
BEGIN
  IF C<=MaxTerminal THEN
  BEGIN
    IF S='' THEN
    BEGIN
      TextOut(c,'DBUF <prgname> : execute Program to process content of Scrollbuffer');
      exit;
    END;
    {$IFNDEF linux}
     cursor(2);
    {$ENDIF}
     Gotoxy(1,1);
    TextAttr:=7;
    QsoBuf[c]^.DumpBuf(temppath+'bufdump.$$$');
    txfile:=temppath+xhex(currixtime)+'.0';
    binfile:=temppath+xhex(currixtime)+'.1';
    buffile:=temppath+xhex(currixtime)+'.2';
{$IFNDEF linux}
     SetMemTop(HeapPtr);
    EXEC(GetEnv('COMSPEC'),'/c '+s+' '+TEMPpath+'bufdump.$$$'+' '+txfile+' '+
         binfile+' '+buffile);
    SetMemTop(HeapEnd);
    asm  {BLINK aus!}
      mov ax,$1003
      mov bx,0
      int $10
    end;
    setvmode(EGAVGAFONT);
{$ENDIF}
   RedrawScreen;
    IF fileda(txfile) THEN PutFile(c,txfile);
    IF fileda(binfile) THEN PutFile(c,binfile);
    IF FileDa(buffile) THEN QSOBuf[c]^.ReadFile(buffile,fQSORX);
  END;
END;
{$IFDEF EDITOR}
PROCEDURE REPLY_CMD(c:BYTE;s:STRING);
VAR z_p,s_p,anz,anz2,i,i2:WORD;f:text;
BEGIN
  anz:=0;
  QsoBuf[c]^.swapin;
  z_p:=QSOBuf[c]^.letzte_zeile_im_puffer;
  repeat
    inc(anz);
    QSOBuf[c]^.Zeile_Rueck(z_p);
    QSOBuf[c]^.Get_Zeile(z_p,s);
{    TextOut(c,s);}
    s_p:=pos('from:',klein(s));
    if s_p>0 THEN
    BEGIN
      editor.empfaenger:=copy(s,s_p+6,6);
      while pos('@',editor.empfaenger)>0 do 
	delete(editor.empfaenger,length(editor.empfaenger),1);
      editor.verteiler:=copy(s,pos('@',s)+2,10);
     while pos('(',editor.verteiler)>0 DO
        delete(editor.verteiler,length(editor.verteiler),1);
     while pos('.',editor.verteiler)>0 DO
        delete(editor.verteiler,length(editor.verteiler),1);
     anz2:=0;
     editor.title:='';
     repeat
        inc(anz2);
        QSOBuf[c]^.Zeile_Rueck(z_p);
        QSOBuf[c]^.Get_zeile(z_p,s);
        IF pos('subj:',klein(s))>0 THEN
          editor.title:='RE:'+copy(s,8,255);
     until (anz2>10) or (editor.title<>'');
    if editor.title='' then  editor.title:='RE:'; 
     i:=0;
     repeat
       inc(i);
       QSOBuf[c]^.Zeile_Vor(z_p);
       QSOBuf[c]^.Get_Zeile(z_p,s);
	textout(c,s);
     until (s='') OR (i>(anz2));
     assign(f,'reply.tmp');
     rewrite(f);
     for i2:=1 to (anz+anz2-i-1)  do
     begin
       QSOBuf[c]^.Zeile_Vor(z_p);
       QSOBuf[c]^.Get_Zeile(z_p,s);
       WriteLn(f,s);
    end;
    close(f);
    editor.load('reply.tmp','>'); 
    QSOBuf[c]^.swapout;
    exit;
   END;
 UNTIL (z_p=QSOBuf[c]^.erste_zeile_im_puffer) or (anz>100);
    QSOBuf[c]^.swapout;

END;
{$ENDIF}

FUNCTION cl(B:BYTE):STRING;
BEGIN
  CASE b OF
     1:cl:='CONNECT';
     2:cl:='DISCONNECT';
     3:cl:='MYCALL';
     4:cl:='FRACK';
     5:cl:='MHEARD';
     21:cl:='STAMP';
     7:cl:='MONITOR';
     20:cl:='RETRY';
     9:cl:='MAXFRAME';
     10:cl:='PERSIST';
     11:cl:='TXDELAY';
     12:cl:='TXTAIL';
     13:cl:='DIGIPEAT';
     14:cl:='UNATTEND';
     15:cl:='MAXCONNECT';
     16:cl:='PTT';
     17:cl:='---';
     18:cl:='RESPTIME';
     19:cl:='CHECK';
     8:cl:='RTEXT';
     6:cl:='STEXT';
     22:cl:='RBIN';
     23:cl:='SBIN';
     24:cl:='C!';
     25:cl:='---';
     26:cl:='HELP';
     27:cl:='NAME';
     28:cl:='CALL';
     29:cl:='BOX';
     30:cl:='TERM';
     31:cl:='RING';
     32:cl:='COMPRESS';
     33:cl:='EUSER';
     34:cl:='RUN';
     35:cl:='OSSHELL';
     36:cl:='QUIT';
     37:cl:='REMOTE';
     38:cl:='INACTIVE';
     39:cl:='STATUS';
     40:cl:='ACONNECT';
     41:cl:='TNC';
     42:cl:='PREFIX';
     43:cl:='ABORT';
     44:cl:='CLS';
     45:cl:='DBUF';
     46:cl:='FORCE';
     47:cl:='RTT';
     48:cl:='DO';
     49:cl:='WAIT';
     50:cl:='IF';
     51:cl:='GOTO';
     52:cl:='SET';
     53:cl:='PUTDATA';
     54:cl:='SLEEP';
     55:cl:='PRINT';
     56:cl:='PACLEN';
     57:cl:='SPY';
     58:cl:='PUTM';
     59:cl:='SAY';
    60:cl:='REPLY';

  ELSE cl:='';
  END;
END;



FUNCTION Which_Command(VAR s:string):BYTE;
VAR B:BYTE;S2:STRING20;
BEGIN
  B:=0;
  S:=FilterCRLF(S);
  S:=LTRIM(S);
  FIND(S,' ',S,ein_s);
  org_str:=ein_s;
  S:=GROSS(S);
  ein_s:=LTRIM(RTRIM(gross(ein_s)));
  REPEAT
    INC(b);
    S2:=COPY(cl(b),1,LENGTH(s));
    IF S=S2 THEN
    BEGIN
      Which_Command:=B;
      S:=ein_s;
      exit;
    END;
  UNTIL S2[0]=#0;
  Which_Command:=0;
END;




PROCEDURE DO_CMD(c:BYTE;S:STRING);
VAR F:TEXT;w:WORD;
BEGIN
  IF Scripts[c]<>NIL THEN
  BEGIN
    DoneScript(c);
    exit;
  END;
  ASSIGN(f,qrvpath+'scripts'+PATH_SEP+s+'.mcs');
  {$I-}
  RESET(f);
  IF IORESULT<>0 THEN
  BEGIN
    TextOut(c,'Scriptfile does not exist');
    exit;
  END;
  NEW(Scripts[c]);
  FillChar(Scripts[c]^,SizeOf(tSCript),0);
  WHILE NOT EOF(f) DO
  BEGIN
    inc(Scripts[c]^.size);
    ReadLn(f,s);
    GetMem(Scripts[c]^.Programm[Scripts[c]^.size],Length(s)+1);
    Scripts[c]^.Programm[Scripts[c]^.size]^:=s;
  END;
  CLOSE(F);
  Scripts[c]^.ip:=1;
END;



PROCEDURE SPY_CMD(c:BYTE;S:STRING);
BEGIN
  if s='' THEN
  BEGIN
    StartSpyMode;
    exit;
  END ELSE
  find(s,' ',l,r);
  InitSpy(gross(l),gross(r));
  StartSpyMode;
END;    

PROCEDURE MH_CMD(C:BYTE;S:STRING);
BEGIN
  MHInit;
END;  

PROCEDURE Interpret_CMD(c:BYTE;var s:string;input:BYTE);

BEGIN
  IF S='' THEN
  BEGIN
    PopUp('MCUTTerm '+version+' (c) HPZ');
    exit;
  END;
  CASE Which_Command(S) OF
    3 : MYCALL_CMD(C,S);
    1 : CONNECT_CMD(C,S);
    2 : DISCONNECT_CMD(C,S);
    5 : MH_CMD(C,S);
    7 : MONITOR_CMD(c,s);
    32: COMP_CMD(c,s);
    40: ACONN_CMD(c,s);
    41: TNC_CMD(c,s);
     4: FRACK_CMD(c,s);
    21: STAMP_CMD(c,s);
    20: RETRY_CMD(c,s);
    42: PREFIX_CMD(c,s);
    28: CALL_CMD(c,s);
    33: eu_cmd(c,s);
    36: QUIT_CMD(C,S);
    6 : STEXT_CMD(C,S);
    23: SBIN_CMD(C,S);
    8 : RTEXT_CMD(C,S);
    22: RBIN_CMD(C,S);
    43: ABORT_CMD(C,S);
    29: BOX_CMD(C,S);
    30: TERM_CMD(C,S);
    44: CLS_CMD(C,S);
    45: PRBUF_CMD(C,S);
    46: FORCE_CMD(C,S);
    47: RTT_CMD(C,S);
    48: DO_CMD(C,S);
    49: WAIT_CMD(C,S);
    50: IF_CMD(C,S);
    51: GOTO_CMD(C,S);
    52: SET_CMD(C,S);
    53: PUTDATA_CMD(C,S);
    54: SLEEP_CMD(C,S);
    55: PRINT_CMD(C,S);
    56: PACLEN_CMD(C,S);
    57: SPY_CMD(C,S);
    58: PUTM_CMD(C,S);
{$IFDEF EDITOR}
    60: REPLY_CMD(C,S);
{$ENDIF}
  ELSE
     PopUp('Invalid command');
  END;
END;


PROCEDURE ConnLoop(C:BYTE;CALL:STRING10);
VAR B        : BYTE;
    merk_bell: BOOLEAN;
BEGIN
  B:=250;
  WHILE (B>MaxTerminal+50) AND (KS[b]<>NIL) DO
    DEC(B);
  IF b>MaxTerminal+50 THEN
  BEGIN
    IF KS[C]=NIL THEN
    BEGIN
      NewKS(C);
      KS[c]^.FLAGS:=KS[c]^.FLAGS OR KS_OwnCon;
    END ELSE
    BEGIN
      PopUp('Cannot LOOP: Channel already connected');
      EXIT;
    END;
    new(mcall[b]);
    MCall[b]^:=CALL;
    merk_bell:=Klingel;
    Klingel:=FALSE;
    HandleConnect(B,'CONNECTED to '+MCall[c]^);
    HandleConnect(C,'CONNECTED to '+MCall[b]^);
    TextOut(c,#13+'CONNECTED to '+MCall[b]^+#13);
    Klingel:=Merk_Bell;
    KS[B]^.Loop:=C;
    KS[C]^.Loop:=B;
    KS[B]^.FLAGS:=KS[B]^.FLAGS OR KS_SYSOP;
    INC(KS[b]^.lev,10);
    {$IFDEF WA8DED}
    If (device=0) THEN
    SendCmd(c,'I LO0P-13');
    {$ENDIF}
  END ELSE
    PopUp('Cannot LOOP: No channel free');
END;

PROCEDURE DiscLoop(C:BYTE);
VAR b,x:BYTE;
BEGIN
  B:=KS[c]^.LOOP;
  IF c>maxTerminal THEN
  BEGIN
    b:=c;
    c:=KS[c]^.LOOP;
  END;
  TextOut(c,#13+'DISCONNECTED fm '+MCall[b]^+#13);
  Handlediscon(b,'DISCONNECTED fm '+MCall[c]^);
  Handlediscon(c,'DISCONNECTED fm '+MCall[b]^);
  dispose(mcall[b]);
  mcall[b]:=NIL;
  {$IFDEF WA8DED}
  IF device=0 THEN
    sendcmd(c,'i '+mcall[c]^) ;
  {$ENDIF}
END;


END.
