(***************************************************************************)

(**  ANSI-Auswertung fr die Scroll-Buffer                                **)

(**                                                                       **)

(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)

(** DG4IAD und DG6VJ                                                      **)

(**                                                                       **)

(**  dg6vj, feb 96                                                        **)

(***************************************************************************)

UNIT ANSI;



INTERFACE



(* ANSI

 * Funktionsrckgabe: 0: String ist noch nicht Vollstndig

 *                    1: OK, Codesequenz ausgewertet, Attribut-Byte in Attrib

 *                    2: Kein ANSI-Code gefunden, Hilfsbyte als Text senden

 *)

FUNCTION Decode_ANSI(S: STRING; VAR Attrib: BYTE): BYTE;





IMPLEMENTATION



FUNCTION Decode_ANSI(S: STRING; VAR Attrib: BYTE): BYTE;

{Konstanten-Deklaration fr die Farb-Attribute}

CONST Vorder_Rot = 4;

      Vorder_Gruen = 2;

      Vorder_Gelb = 14;

      Vorder_Blau = 1;

      Vorder_Magenta = 5;

      Vorder_Cyan = 3;

      Vorder_Weiss = 15;



      Hinter_Rot = 4*16;

      Hinter_Gruen = 2*16;

      Hinter_Gelb = 14*16;

      Hinter_Blau = 1*16;

      Hinter_Magenta = 5*16;

      Hinter_Cyan = 3*16;

      Hinter_Weiss = 15*16;



VAR Fertig: BOOLEAN;

    Hlp: STRING;

    code: WORD;

    b: BYTE;

BEGIN

  Decode_ANSI:=2;

  IF ((S<>'') AND (S[1]<>#27)) OR ((S[0]>=#2) AND (S[2]<>'[')) OR (LENGTH(S)>20) THEN

  BEGIN

    Decode_ANSI := 2;

    EXIT;

  END;

  IF LENGTH(S)<4  THEN BEGIN

    Decode_ANSI := 0;

    Exit;

  END;

  IF ((Byte(S[LENGTH(S)])) IN [97..122]) OR ((Byte(S[LENGTH(S)])) IN [65..90]) THEN BEGIN

    (* S[LENGTH(S)] := UpCase(S[LENGTH(S)]); *)

    S := COPY(S,3,255);

    CASE S[LENGTH(S)] OF

      'm': BEGIN        {Text-Attribute setzen}

             S := COPY(S,1,LENGTH(S)-1);

             (*Attrib := 0;*)

             REPEAT

               IF POS(';',S)>0 THEN BEGIN

                 Hlp := COPY(S,1,POS(';',S)-1);

                 S := COPY(S,POS(';',S)+1,255);

               END

               ELSE BEGIN

                 Hlp := S;

                 S := '';

               END;

               VAL(Hlp,b,code);

               IF code<>0 THEN BEGIN

                 Decode_ANSI := 2;

                 Exit;

               END;

               {Die 4 Bits fr Vorder oder Hintergrundfarbe lschen}

               CASE b OF

                 30..37: Attrib := Attrib AND $F0;

                 40..47: Attrib := Attrib AND $F;

               END;



               CASE b OF

                 {Vordergrundfarben}

                 31: Attrib := Attrib OR Vorder_Rot;

                 32: Attrib := Attrib OR Vorder_Gruen;

                 33: Attrib := Attrib OR Vorder_Gelb;

                 34: Attrib := Attrib OR Vorder_Blau;

                 35: Attrib := Attrib OR Vorder_Magenta;

                 36: Attrib := Attrib OR Vorder_Cyan;

                 37: Attrib := Attrib OR Vorder_Weiss;



                 {Hintergrundfarben}

                 41: Attrib := Attrib OR Hinter_Rot;

                 42: Attrib := Attrib OR Hinter_Gruen;

                 43: Attrib := Attrib OR Hinter_Gelb;

                 44: Attrib := Attrib OR Hinter_Blau;

                 45: Attrib := Attrib OR Hinter_Magenta;

                 46: Attrib := Attrib OR Hinter_Cyan;

                 47: Attrib := Attrib OR Hinter_Weiss;

               END;

             UNTIL Byte(S[0])=0;

             Decode_ANSI := 1;

             Exit;

           END;

    END;

  END

  ELSE Decode_ANSI := 0;



END;





END.